#on oak
/usr/pub/pgi/linux86/bin/pgf77 -o maxhom.LINUX -O3 -C maxhom.f lib-sys-LINUX.f lib-maxhom.f lib-maxhom-node-pvm3.f 

/usr/pub/pgi/linux86/bin/pgf77 -o filter_hssp.LINUX -O3 -C filter_hssp.f lib-sys-LINUX.f lib-maxhom.f 

/usr/pub/pgi/linux86/bin/pgf77 -o convert_seq.LINUX -O3 -C convert_seq.f lib-sys-LINUX.f lib-convert.f

/usr/pub/pgi/linux86/bin/pgf77 -o profile_make.LINUX -O3 -C profile_make.f lib-sys-LINUX.f lib-profile-make.f

# gnu gfortran compiler - only on INTEL MAC

/usr/local/bin/gfortran -o maxhom.MACINTEL -O3 -C maxhom.f lib-sys-MAC.f lib-maxhom.f lib-maxhom-node-pvm3.f 
/usr/local/bin/gfortran -o convert_seq.MACINTEL -O3 -C convert_seq.f lib-sys-MAC.f lib-convert.f
/usr/local/bin/gfortran -o filter_hssp.MACINTEL -O3 -C filter_hssp.f lib-sys-MAC.f lib-maxhom.f
/usr/local/bin/gfortran -o profile_make.MACINTEL -O3 -C profile_make.f lib-sys-MAC.f lib-profile-make.f

# gnu g77 compiler
g77 -o maxhom.MAC -O3 -C maxhom.f lib-sys-MAC.f lib-maxhom.f lib-maxhom-node-pvm3.f 
g77 -o convert_seq.MAC -O3 -C convert_seq.f lib-sys-MAC.f lib-convert.f
g77 -o filter_hssp.MAC -O3 -C filter_hssp.f lib-sys-MAC.f lib-maxhom.f
g77 -o profile_make.MAC -O3 -C profile_make.f lib-sys-MAC.f lib-profile-make.f



# IBM compiler
setenv PATH /opt/ibmcmp/xlf/8.1/bin:/usr/pub/bin:/usr/local/bin:/bin:/sbin:/usr/bin:/usr/sbin:/usr/etc:/sbin:/usr/local/bin
 
 
/opt/ibmcmp/xlf/8.1/bin/f77 -o maxhom.IBM -O3 -C maxhom.f lib-sys-MACIBM.f lib-maxhom.f lib-maxhom-node-pvm3.f
/opt/ibmcmp/xlf/8.1/bin/f77 -o convert_seq.IBM -O3 -C convert_seq.f lib-sys-MACIBM.f lib-convert.f
/opt/ibmcmp/xlf/8.1/bin/f77 -o filter_hssp.IBM -O3 -C filter_hssp.f lib-sys-MACIBM.f lib-maxhom.f

*----------------------------------------------------------------------*
*                                                                      *
*     FORTRAN code for program CONVERT_SEQ                             *
*             conversion of sequence and alignment formats             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Authors:                                                         *
*                                                                      *
*     Reinhard Schneider        May,        1994      version 1.0      *
*     LION			http://www.lion-ag/                    *
*     D-69120 Heidelberg	schneider@lion-ag.de                   *
*                                                                      *
*     &                                                                *
*                                                                      *
*     Burkhard Rost		May,        1994      version 1.1      *
*                   		Oct,        1998      version 2.0      *
*     EMBL/LION			http://www.embl-heidelberg.de/~rost/   *
*     D-69012 Heidelberg	rost@embl-heidelberg.de                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     General note:   - uses library lib-maxhom.f                      *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*

      PROGRAM MAKE_METRIC
* 
C     quick hack to produce structure/IO dependent metric used in MaxHom
*     
*     
*     
*     
************************************************************************
      IMPLICIT      NONE

C----
C---- parameters
C----
      INTEGER       NTRANS,NSTRMAX,NIOMAX,KOUT,KIN
      PARAMETER     (NTRANS=26,NSTRMAX=3,NIOMAX=3,KOUT=10,KIN=11)
      INTEGER       NSTR1,NSTR2,NIO1,NIO2,IL,IH,IB,IO,IE,N1,N2,N3,N4
C----
C----
C----
      CHARACTER     CTRANS*(NTRANS),CSTRUC*3,CIO*3
      REAL          STRVAL(NSTRMAX,NSTRMAX),IOVAL(NIOMAX,NIOMAX),
     +              VALUE(NTRANS)
      INTEGER       IORANGE(NIOMAX,NIOMAX)
      REAL          STRIOVAL(1:(NSTRMAX*NIOMAX),1:(NSTRMAX*NIOMAX))

      CHARACTER*5   CTEMP,CH
      INTEGER       ITEMP(3,3),IT1,IT2,IHVEC(1:9),FAC_STR,FAC_SEQ,
     +              ISTR1,IO1,I,ISTR2,IO2,J,MTRANS,NUMARGUMENTS

      CHARACTER*80  FILE_METRIC_SEQ,FILE_METRIC_OUT,FILE_METRIC_IN
      LOGICAL       LREAD_METRIC_IN,LHELP
      REAL          SIMSEQ(NTRANS,NTRANS,NSTRMAX,NIOMAX,NSTRMAX,NIOMAX),
     +              SIMSTR
C--------------------------------------------------
C----
C---- init defaults
C----
      FILE_METRIC_OUT='Make_metric_new.output'
      FILE_METRIC_SEQ=
     +     '/home/rost/pub/topits/mat/Maxhom_McLachlan.metric'
      FILE_METRIC_IN= 'Make_metric_new.input'
      ctrans='VLIMFWYGAPSTCHRKQENDBZX!-.'
C                                        read metric from file?
      LREAD_METRIC_IN=.FALSE.
      LREAD_METRIC_IN=.TRUE.
*                                                                      *
C--------------------------------------------------
C---- requesting input files:
C---- McLachlan (seq. metric) + file_in; file_out
C--------------------------------------------------
*                                                                      *
      CALL GET_ARG_NUMBER(NUMARGUMENTS)
      IF (NUMARGUMENTS.GT.0) THEN
         CALL GET_ARGUMENT(1,FILE_METRIC_IN)
      END IF
      IF (NUMARGUMENTS.GT.1) THEN
         CALL GET_ARGUMENT(2,FILE_METRIC_OUT)
      END IF
      IF (NUMARGUMENTS.GT.2) THEN
         CALL GET_ARGUMENT(3,FILE_METRIC_SEQ)
      END IF
      IF (NUMARGUMENTS.EQ.0) THEN
         WRITE(6,'(T2,A)')'---'
         WRITE(6,'(T2,A3,T10,A)')'----',
     +        'you can provide three input arguments:'
         WRITE(6,'(T2,A3,T10,A,T35,A)')'----','1: input metric def=',
     +        FILE_METRIC_IN
         WRITE(6,'(T2,A3,T10,A,T35,A)')'----','2: output metric def=',
     +        FILE_METRIC_OUT
         WRITE(6,'(T2,A3,T10,A,T35,A)')'----','3: sequence metric def=',
     +        FILE_METRIC_SEQ
         WRITE(6,'(T2,A)')'---'
      END IF
*                                                                      *
*                                                                      *
C percentage of match_struc / match_seq: 
C     (fac_str) * match_str + (10-fac_str) * match_seq
      FAC_STR=    10
C number of secondary structure and IO states
      NSTR1=       3
      NSTR2=       3
      NIO1=        2
      NIO2=        2
C define secondary structure states: E=beta , H=helix, L= NOT E or H
C      cstruc='ELH'
      CSTRUC='ELH'
      IE=INDEX(CSTRUC,'E')
      IL=INDEX(CSTRUC,'L')
      IH=INDEX(CSTRUC,'H')
C define match/mismatch between secondary structures states
C "ie,ie" = 3.0 ==> match between two residue in a beta strand
C give a value of 3.0
      STRVAL(IE,IE)=  4.0
      STRVAL(IE,IL)= -1.0
      STRVAL(IE,IH)= -4.0
      STRVAL(IL,IE)= -1.0
      STRVAL(IL,IL)=  1.0
      STRVAL(IL,IH)= -1.0
      STRVAL(IH,IE)= -4.0
      STRVAL(IH,IL)= -1.0
      STRVAL(IH,IH)=  4.0
C define IO states: B=buried , I=inside, O=ouside
C     cio='BIO'
      CIO='BO'
      IB=INDEX(CIO,'B')
C	ii=index(cio,'I')
      IO=INDEX(CIO,'O')
C define match/mismatch between IO states
C "ib,ib" = 3.0 ==> match between a buried residue with a buried residue
C give a value of 3.0
      IOVAL(IB,IB)=  4.0
C     IOVAL(IB,II)= -2.0
      IOVAL(IB,IO)= -2.0
C     IOVAL(II,IB)= -2.0
C     IOVAL(II,II)=  1.0
C     IOVAL(II,IO)= -2.0
      IOVAL(IO,IB)= -2.0
C     IOVAL(IO,II)= -2.0
      IOVAL(IO,IO)=  1.0
C define IO classes
C "ie,ib" = beta-strand + buried are residues with a %accessibility
C surface area below or equal to 5 percent (depndend on residue type)
      IORANGE(IE,IB)=  15
C     IORANGE(IE,II)=  16
      IORANGE(IE,IO)= 100
      IORANGE(IL,IB)=  15
C     IORANGE(IL,II)=  16
      IORANGE(IL,IO)= 100
      IORANGE(IH,IB)=  15
C     IORANGE(IH,II)=  16
      IORANGE(IH,IO)= 100

C--------------------------------------------------
C---- generate the sequence match matrix
C--------------------------------------------------
C----
C----
      CALL GETSIMMETRIC(NTRANS,CTRANS,NSTRMAX,NIOMAX,N1,N2,N3,N4,
     +     CTEMP,CTEMP,ITEMP,99,FILE_METRIC_SEQ,SIMSEQ)
C     -----------------

C--------------------------------------------------
C define match/mismatch between secondary structures and in/out
C        Eb Ee Lb Le Hb He 	
C    Eb   9  2  1 -6 -1 -8
C    Ee      7 -6  1 -8 -3
C    Lb         6 -1  1 -6
C    Le            4 -6  1
C    Hb               9  2
C    He                  7
C
C----
C E->x
      STRIOVAL(1,1)=  9.0
      STRIOVAL(1,2)=  2.0
      STRIOVAL(1,3)=  1.0
      STRIOVAL(1,4)= -6.0
      STRIOVAL(1,5)= -1.0
      STRIOVAL(1,6)= -8.0
      STRIOVAL(2,2)=  7.0
C----
C L->x
      strioval(3,3)=  6.0
      strioval(3,4)= -1.0
      strioval(4,4)=  4.0

C----
C symmetrie intuition
      STRIOVAL(2,3)=STRIOVAL(1,4)
      STRIOVAL(2,4)=STRIOVAL(1,3)
      STRIOVAL(2,5)=STRIOVAL(1,6)
      STRIOVAL(2,6)=STRIOVAL(1,5)
      STRIOVAL(3,5)=STRIOVAL(1,3)
      STRIOVAL(3,6)=STRIOVAL(1,4)
      STRIOVAL(4,5)=STRIOVAL(1,4)
      STRIOVAL(4,6)=STRIOVAL(1,3)
      STRIOVAL(5,5)=STRIOVAL(1,1)
      STRIOVAL(5,6)=STRIOVAL(1,2)
      STRIOVAL(6,6)=STRIOVAL(2,2)
C----
C symmetrie intuition
      DO IT1=1,6
         DO IT2=1,(IT1-1)
            STRIOVAL(IT1,IT2)=STRIOVAL(IT2,IT1)
         END DO
      END DO
      
C--------------------------------------------------
C read in factors and metric file?
C--------------------------------------------------
      IF (LREAD_METRIC_IN) THEN
         OPEN(KIN,FILE=FILE_METRIC_IN,STATUS='UNKNOWN',RECL=150)
         write(6,*)'--- read metric in'
         READ(KIN,'(A)',END=22114)CH
         write(6,'(A,T20,A)')'---',CH
         DO IT1=1,NSTR1*NIO1
            READ(KIN,'(A3,6I8)',END=22114)CH,
     +           (IHVEC(IT2),IT2=1,(NSTR2*NIO2))
            write(6,'(A5,I2,A1,A3,T20,6I6)')'read ',IT1,':',CH,
     +           (IHVEC(IT2),IT2=1,(NSTR2*NIO2))
            DO IT2=1,(NSTR2*NIO2)
               STRIOVAL(IT1,IT2)=IHVEC(IT2)/10.
            END DO
         END DO
         LHELP=.TRUE.
         DO WHILE (LHELP) 
            CH=' '
            READ(KIN,'(A)',END=22114)CH
            IF ( (CH(1:1).EQ.' ').OR.(CH(1:1).EQ.'*') ) THEN
               CONTINUE
            ELSEIF ( (CH(1:1).NE.'F').AND. 
     +               (CH(1:1).NE.'f') ) THEN
               write(6,*)'x.x ch=',ch(1:5)
               LHELP=.FALSE.
            ELSE
               BACKSPACE(KIN)
               READ(KIN,'(A8,I2)',END=22114)CH,FAC_STR
            END IF
         END DO
22114    CONTINUE
         CLOSE(KIN)

      END IF

c recompute factors
      FAC_SEQ=10-FAC_STR
         
C----------------------------------------------------------------------
C now summarise the setting
C----------------------------------------------------------------------

c write out onto printer
      WRITE(6,*)'--------------------------------------------------'
      WRITE(6,'(T5,A)')' '
      IF (LREAD_METRIC_IN) THEN
         WRITE(6,'(T5,A,T40,A)')'file containing metric asf.:',
     +        FILE_METRIC_IN
         WRITE(6,'(T5,A,T40,A)')'output will be in:',FILE_METRIC_OUT
         WRITE(6,'(T5,A)')'match = n*match_struc + (10-n)*match_seq '
         WRITE(6,'(T5,A,T20,I5)')'where n = ',FAC_STR
         WRITE(6,'(T5,A)')' '
      END IF
      WRITE(6,*)' '
      WRITE(6,*)'matrix generated:'
      WRITE(6,'(T10,6(A2,A1,A1,A2))')
     + '  ',cstruc(1:1),cio(1:1),'  ','  ',cstruc(1:1),cio(2:2),'  ',
     + '  ',cstruc(2:2),cio(1:1),'  ','  ',cstruc(2:2),cio(2:2),'  ',
     + '  ',cstruc(3:3),cio(1:1),'  ','  ',cstruc(3:3),cio(2:2),'  '
      DO ISTR1=1,NSTR1
         DO IO1=1,NIO1
            IT1=(ISTR1-1)*NIO1+IO1
            WRITE(6,'(A1,A1,T10,6F6.2)')
     +           CSTRUC(ISTR1:ISTR1),CIO(IO1:IO1),
     +           (STRIOVAL(IT1,IT2),IT2=1,(NSTR2*NIO2))
         END DO
      END DO
      WRITE(6,*)' '
      WRITE(6,*)'--------------------------------------------------'

C----------------------------------------------------------------------
C now write into file
C----------------------------------------------------------------------

      OPEN(KOUT,FILE=FILE_METRIC_OUT,STATUS='UNKNOWN',RECL=250)
C write header info
      WRITE(KOUT,'(A)')'#========================================='//
     +                   '=========================================='//
     +                   '=========================================='//
     +                   '==============='
      WRITE(KOUT,'(A,I3)')'STRUCTURE-STATES_1:',NSTR1
      WRITE(KOUT,'(A,I3)')'STRUCTURE-STATES_2:',NSTR2
      WRITE(KOUT,'(A,I3)')'I/O-STATES_1:',NIO1
      WRITE(KOUT,'(A,I3)')'I/O-STATES_2:',NIO2
      WRITE(KOUT,'(A)')'DSSP-STRUCTURE   I/O    %ACC-RANGE '//
     +                   '(<= less or equal)'
C write ranges for accessibility classes
      DO ISTR1=1,NSTR1
         DO IO1=1,NIO1
            WRITE(KOUT,'(4X,A,13X,A,7X,I3)')CSTRUC(ISTR1:ISTR1),
     +           CIO(IO1:IO1),IORANGE(ISTR1,IO1)
         ENDDO
      ENDDO

C write seperator lines
      WRITE(KOUT,'(A)')'#========================================='//
     +                   '=========================================='//
     +                   '=========================================='//
     +                   '==============='
      WRITE(KOUT,'(A)')'AA STR I/O  V     L     I     M     F     '//
     +                   'W     Y     G     A     P     S     T     '//
     +                   'C     H     R     K     Q     E     N     '//
     +                   'D     B     Z'
C write metric
      MTRANS=22
      DO I=1,MTRANS
         DO ISTR1=1,NSTR1
            DO IO1=1,NIO1
               DO ISTR2=1,NSTR2
                  DO IO2=1,NIO2
C---                                    old version: combine HEL be
C                       SIMSTR=
C     +                      strval(istr1,istr2) + ioval(io1,io2)
C---                                    new version: 6x6 matrix
                     SIMSTR=STRIOVAL( ((ISTR1-1)*NIO1+IO1), 
     +                    ((ISTR2-1)*NIO2+IO2) )

                     DO J=1,22 
C F*struc + (10-F)*seq
                        VALUE(J) = (FAC_STR/10. * SIMSTR) +
     +                       (FAC_SEQ/10. * SIMSEQ(I,J,1,1,1,1))
                        
                        IF (VALUE(J) .GE.  10.0) VALUE(J)=9.99
                        IF (VALUE(J) .LE. -10.0) VALUE(J)=-9.99


                     ENDDO
                     WRITE(KOUT,'(1X,A,2X,A,A,1X,A,A,1X,22(F5.2,1X))')
     +                    CTRANS(I:I),CSTRUC(ISTR1:ISTR1),
     +                    CSTRUC(ISTR2:ISTR2),CIO(IO1:IO1),
     +                    CIO(IO2:IO2),
     +                    (VALUE(J),J=1,22)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      END

*----------------------------------------------------------------------*
*                                                                      *
*     FORTRAN code for program FILTER_HSSP                             *
*             filters an HSSP file                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Author:                                                          *
*                                                                      *
*     Reinhard Schneider        Mar,        1990      version 1.0      *
*                         ->    Mar,        1997      version 2.0      *
*     LION			http://www.lion-ag/                    *
*     D-69120 Heidelberg	schneider@lion-ag.de                   *
*                                                                      *
*                                                                      *
*     Changes:                                                         *
*                                                                      *
*     Burkhard Rost		May,        1998      version 2.1      *
*                   		Oct,        1998      version 2.2      *
*                                                                      *
*     EMBL/LION			http://www.embl-heidelberg.de/~rost/   *
*     D-69012 Heidelberg	rost@embl-heidelberg.de                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     General note:   - uses library lib-maxhom.f                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Description (from RS):                                           *
*                                                                      *
C=======================================================================
C 
C ------------------------------
C INSTALLATION:
C ------------------------------
C 
C 1. change the character variable "metricfile" to your enviroment path
C 2. compile it
C 
C=======================================================================
C  INCREASE THE NUMBER OF FOLLOWING THREE PARAMETER IF NECESSARY
C=======================================================================
C 
C  maxaligns    = maximal number of alignments in a HSSP-file
C  maxres       = maximal number of residues in a PDB-protein
C  maxcore      = maximal space for storing the alignments
C  maxins       = maximal number of insertions in alignend sequences
C  maxinsbuffer = total size for buffer of all insertions
C 
C=======================================================================
C
C ------------------------------
C  Explanation of variables:
C ------------------------------
C
C  maxaa= 20 amino acids
C  pdbid= Brookhaven Data Bank identifier
C  header,compound,source,author= informations about the PDB-protein
C  pdbseq= amino acid sequence of the PDB-protein
C  chainid= chain identifier (chain A etc.)
C  secstr= DSSP secondary structure summary
C  bp1,bp2= beta-bridge partner
C  cols= DSSP hydrogen bonding patterns for turns and helices,
C        geometrical bend, chirality, one character name of beta-ladder
C        and of beta-sheet
C  sheetlabel= chain identifier of beta bridge partner
C  seqlength= number of amino acids in the PDB-protein
C  pdbno= residue number as in PDB file
C  nchain= number of different chains in pdbid.DSSP data set
C  kchain= number of chains used in HSSP data set
C  nalign= number of alignments
C  acc= solvated residue surface area in A**2
C  emblid= EMBL/SWISSPROT identifier of the alignend protein
C  strid= if the 3-D structure of this protein is known, then strid
C         (structure ID) is the Protein Data Bank identifier as taken
C         from the EMBL/SWISSPROT entry
C  protname= one line description of alignend protein
C  aliseq= sequential storage for the alignments
C  alipointer= points to the beginning of alignment X ( 1>= X <=nalign )
C  ifir,ilas= first and last position of the alignment in the test
C             protein
C  jfir,jlas= first and last position of the alignment in the alignend
C             protein
C  lali= length of the alignment excluding insertions and deletions
C  ngap= number of insertions and deletions in the alignment
C  lgap= total length of all insertions and deletions
C  lenseq= length of the entire sequence of the alignend protein
C  ide= percentage of residue identity of the alignment
C  var= sequence variability as derived from the nalign alignments
C  seqprof= relative frequency for each of the 20 amino acids
C  nocc= number of alignend sequences spanning this position (including
C        the test sequence
C  ndel= number of sequences with a deletion in the test protein at this
C        position
C  nins= number of sequences with an insertion in the test protein at
C        this position
C  entropy= entropy measure of sequence variability at this position
C  relent= relative entropy (entropy normalized to the range 0-100)
C======================================================================
C 
C ------------------------------
C CHANGES:
C ------------------------------
C  IDEMAX_ANSWER =  maximal pairwise sequence identity to not get
C                   excluded
*----------------------------------------------------------------------*

      PROGRAM FILTER_HSSP

      IMPLICIT        NONE

C----
C---- overall memory limiting parameters
C----
      INTEGER         MAXALIGNS,MAXRES,MAXCORE,MAXAA,MAXINS
      INTEGER         MAXINSBUFFER
      PARAMETER      (MAXALIGNS=              8765)
C      PARAMETER      (MAXALIGNS=             19999)
      PARAMETER      (MAXRES=                 9999)
C      PARAMETER      (MAXRES=                10000)
      PARAMETER      (MAXINS=                50000)
      PARAMETER      (MAXINSBUFFER=        4321432)
C---- lkajan: 16M to comfortably store all the characters of an alignment
C---- of size SEQLENGTH  3685 and NALIGN     2794
      PARAMETER      (MAXCORE=            16777216)
      PARAMETER      (MAXAA=                    20)
C----
C---- other parameters
C----
      INTEGER         MAXSTEP
C---- used for variability
      INTEGER         NTRANS,MAXSTRSTATES,MAXIOSTATES
      REAL            SMIN,SMAX
      PARAMETER      (MAXSTEP=                 100)
      PARAMETER      (NTRANS=                   26)
      PARAMETER      (MAXSTRSTATES=              3)
      PARAMETER      (MAXIOSTATES=               4)
      PARAMETER      (SMIN=                      0.0)
      PARAMETER      (SMAX=                      1.0)
C     only used to get rid of INDEX command (CPU time)
      INTEGER         NASCII
      PARAMETER      (NASCII=                  256)
C     files
      INTEGER         KIN,KOUT,KMAT,KISO
      PARAMETER      (KIN=                      10)
      PARAMETER      (KOUT=                     11)
      PARAMETER      (KMAT=                     12)
      PARAMETER      (KISO=                     14)

C---- br 2003-08: switch for new (1999) HSSP curve
      LOGICAL         LNEWCURVE
      PARAMETER      (LNEWCURVE=            .TRUE.)
C      PARAMETER      (LNEWCURVE=           .FALSE.)

C----
C---- attributes of sequence with known structure
C----
      CHARACTER*40    PDBID,HEADER
      CHARACTER*80    COMPOUND,SOURCE,AUTHOR,CHAINREMARK
      CHARACTER       PDBSEQ(MAXRES),CHAINID(MAXRES),SECSTR(MAXRES),
     +                COLS(MAXRES)*7,SHEETLABEL(MAXRES)
      INTEGER         SEQLENGTH,PDBNO(MAXRES),NCHAIN,KCHAIN,NALIGN,
     +                NALIGN_FILTER,BP1(MAXRES),BP2(MAXRES),ACC(MAXRES)
C----
C---- attributes of aligned sequences
C----
      CHARACTER*40    EMBLID(MAXALIGNS)
      CHARACTER*6     STRID(MAXALIGNS)
      CHARACTER*10    ACCNUM(MAXALIGNS)
      CHARACTER*60    PROTNAME(MAXALIGNS)
      CHARACTER       ALISEQ(MAXCORE),EXCLUDEFLAG(MAXALIGNS)
      INTEGER         ALIPOINTER(MAXALIGNS),
     +                IFIR(MAXALIGNS),ILAS(MAXALIGNS),JFIR(MAXALIGNS),
     +                JLAS(MAXALIGNS),LALI(MAXALIGNS),NGAP(MAXALIGNS),
     +                LGAP(MAXALIGNS),LENSEQ(MAXALIGNS),
     +                INSNUMBER,INSALI(MAXINS),INSPOINTER(MAXINS),
     +                INSLEN(MAXINS),INSBEG_1(MAXINS),INSBEG_2(MAXINS)
C----
C---- buffer to store insertions of alignments
C----
      CHARACTER       INSBUFFER(MAXINSBUFFER)
      REAL            IDE(MAXALIGNS),SIM(MAXALIGNS)
C----
C---- attributes of profile
C----
      INTEGER         VAR(MAXRES),SEQPROF(MAXRES,MAXAA),NOCC(MAXRES),
     +                NDEL(MAXRES),NINS(MAXRES),RELENT(MAXRES)
      REAL            ENTROPY(MAXRES),CONSWEIGHT(MAXRES),CONSWEIGHT_MIN
C----
C---- miscellaneous
C----
      LOGICAL         LERROR,LCONSERV,LHSSP_LONG_ID,LIDE_100,LSAME
      CHARACTER*9     CDATE
C----
C---- threshold
C----
      LOGICAL         LCONSIDER,LFORMULA,LALL
      INTEGER         ISOLEN(MAXSTEP),NSTEP,ISAFE
      REAL            ISOIDE(MAXSTEP),IDEMAX
      CHARACTER*80    IDEMAX_ANSWER
C----
C---- value of best match
C----
      INTEGER         NSTRSTATES,NIOSTATES
C----
C---- comparison metric
C----
      REAL            MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                     MAXSTRSTATES,MAXIOSTATES)
C----
C---- normalised to sum over 0 (by SETCONSERVATION)
C---- 
      REAL            SIMCONSERV(NTRANS,NTRANS)

      REAL            IORANGE(MAXSTRSTATES,MAXIOSTATES)

      CHARACTER       CSTRSTATES*(MAXSTRSTATES),CIOSTATES*(MAXIOSTATES)
C---- 
C---- 
C......
      CHARACTER*80    HSSPLINE,DATABASE
      CHARACTER*132   CPARAMETER(10),LINE
      CHARACTER       TRANS*(NTRANS)
C.....
      CHARACTER*132   HSSPFILE,OUTFILE,METRICFILE,OUTFILE_TMP,
     +                DISTANCE_TABLE,DISTANCE_TABLE_TMP
      CHARACTER*80    THRESHOLD,EXCLUDE_IDENTICAL,TEMPNAME
      CHARACTER       PID*40,LOWER*26
C----
C---- only used to get rid of INDEX command (CPU time)
C----
      INTEGER         LOWERPOS(NASCII)
      INTEGER         MATPOS(NASCII)
C----
C---- internal
C----
      INTEGER         ISTART,ISTOP,I,J,ILINE,NPARALINE,IALIGN,JALIGN,
     +                NRES,ILEN
      REAL            DISTANCE
      CHARACTER*80    CTEMP
      LOGICAL         LDIST_TABLE

C---- end of variables
C---- ------------------------------------------------------------------

C     order of amino acids in HSSP sequence profile
      TRANS=        'VLIMFWYGAPSTCHRKQENDBZX!-.'
C     used to convert lower case char from DSSP-seq to 'C' (Cys)
      LOWER=        'abcdefghijklmnopqrstuvwxyz'
      CALL GETPOS(LOWER,LOWERPOS,NASCII)
      INSNUMBER=0
      DO I=1,MAXINS
         INSPOINTER(I)=0
         INSLEN(I)=    0
         INSBEG_1(I)=  0
         INSBEG_2(I)=  0
      ENDDO
C---- ------------------------------------------------------------------
C     defaults:  CHANGE TO LOCAL ENVIROMENT
C---- ------------------------------------------------------------------
      METRICFILE=       '/home/rost/pub/max/mat/Maxhom_GCG.metric'
      THRESHOLD=        'formula+5'
      IDEMAX_ANSWER=    '1.00'
      HSSPFILE=         ' '	
      LFORMULA=         .FALSE.
      LALL=             .FALSE.
      DATABASE=         ' '
      HSSPLINE=         ' '
      EXCLUDE_IDENTICAL='NO'
      DISTANCE_TABLE=   'NO'
      LIDE_100=         .FALSE.
      LINE=             ' '
      LDIST_TABLE=      .FALSE.
      LHSSP_LONG_ID=    .FALSE.

      CONSWEIGHT_MIN=   0.01

C---- end of settings
C---- ------------------------------------------------------------------

C---- ------------------------------------------------------------------
C---- blabla for user
C---- ------------------------------------------------------------------
      WRITE(*,*)' '
      WRITE(*,*)'****************************  HSSP-FILE FILTER ***'//
     +          '*****************************'
      WRITE(*,*)' R. Schneider, 1990 and later, EMBL-Heidelberg'
      WRITE(*,*)'**************************************************'//
     +          '****************************'
      WRITE(*,*)' '
      WRITE(*,*)' If you want to exclude an alignment independent'//
     +     ' from the threshold, mark the'
      WRITE(*,*)' alignment in your "personal" copy of the HSSP-'//
     +     'file in the following way:'
      WRITE(*,*)' '
      WRITE(*,*)' type a character (non blank, overstrike mode)'//
     +     ' after the alignment number'
      WRITE(*,*)' in the PROTEINS-block, like the "*" in:'
      WRITE(*,*)' '
      WRITE(*,*)'                        15*: REV1_YEAST'
      WRITE(*,*)'                          ^'

C---- ------------------------------------------------------------------
C---- prompt for input
C---- ------------------------------------------------------------------
C---- query name of input file      
      CALL GETCHAR(132,HSSPFILE,  '  HSSP input file ?')
      CALL GETPIDCODE(HSSPFILE,PID)
      CALL STRPOS(PID,ISTART,ISTOP)

C---- query name of output file
      OUTFILE=PID(1:ISTOP)//'.hssp_fil'
      CALL GETCHAR(132,OUTFILE_TMP,   '  HSSP output file ?')
      CALL STRPOS(OUTFILE_TMP,ISTART,ISTOP)
      OUTFILE(1:)=OUTFILE_TMP(ISTART:ISTOP)

C---- query metric used to convert identity to similarity
      CALL GETCHAR(132,METRICFILE,'  metric file (HSSP-VARIABILITY) ?')

C---- query cut-off threshold 
      IF (LNEWCURVE) THEN
         CALL GETCHAR(80,THRESHOLD, '  BR 1999 threshold ? /n '//
     +     ' /n '//
     +     '  formula+x   : formula value plus x percent /n '//
     +     '  ALL         : no threshold or /n '//
     +     '  "file name" : with threshold specification ')
      ELSE
         CALL GETCHAR(80,THRESHOLD, '  RS 1989 threshold ? /n '//
     +     ' /n '//
     +     '  formula+x   : formula value plus x percent /n '//
     +     '  ALL         : no threshold or /n '//
     +     '  "file name" : with threshold specification ')
      ENDIF
C---- maximal pairwise sequence identity
      CALL GETCHAR(80,IDEMAX_ANSWER,'  exclude too similar pairs?/n'//
     +     ' positive real number < 1 (like: 0.8)')
      CALL LOWTOUP(IDEMAX_ANSWER,80)
      CALL STRPOS(IDEMAX_ANSWER,ISTART,ISTOP)
      CALL READ_REAL_FROM_STRING(IDEMAX_ANSWER(ISTART:ISTOP),IDEMAX)
C---- end of new stuff

C---- query 'you want to clean up identical pairs?'
      CALL GETCHAR(80,EXCLUDE_IDENTICAL,'  clean up 100% '//
     +     'identical pairs ?')

C---- query name of distance table (or NO for no table written)
      CALL GETCHAR(132,DISTANCE_TABLE,'  write distance table ?/n'//
     +     '  NO          : default no file written/n'//
     +     '  YES         : default file = PDBid_distance.table/n'//
     +     '  FILE_NAME   : written into this file written/n')
      DISTANCE_TABLE_TMP=DISTANCE_TABLE
      CALL LOWTOUP(DISTANCE_TABLE_TMP,80)	
      IF (INDEX(DISTANCE_TABLE_TMP,'NO') .NE. 0) THEN
         LDIST_TABLE=.FALSE.
      ELSE IF (INDEX(DISTANCE_TABLE_TMP,'YES') .NE. 0) THEN
         LDIST_TABLE=.TRUE.
         DISTANCE_TABLE="DEFAULT"
      ELSE 
         LDIST_TABLE=.TRUE.
      ENDIF

      TEMPNAME(1:)=THRESHOLD
      CALL LOWTOUP(TEMPNAME,80)	
      IF (INDEX(TEMPNAME,'FORMULA') .NE. 0) THEN
         LFORMULA=.TRUE.
         I=INDEX(THRESHOLD,'+')
         J=INDEX(THRESHOLD,'-')
C---- extract 'safe' range
         IF (I.NE.0) THEN
            CALL STRPOS(THRESHOLD,ISTART,ISTOP)
            READ(THRESHOLD(I+1:ISTOP),'(I2)')ISAFE
            WRITE(*,'(A,I2,A)')' use formula value +',isafe,' %'
         ELSE IF (J.NE.0) THEN
            CALL STRPOS(THRESHOLD,ISTART,ISTOP)
            READ(THRESHOLD(J:ISTOP),'(I2)')ISAFE
            WRITE(*,'(A,I2,A)')' use formula value ',isafe,' %'
         ELSE
            ISAFE=0
         ENDIF
      ELSE IF (INDEX(TEMPNAME,'ALL') .NE. 0) THEN
         LALL=.TRUE.
      ELSE
C---- read threshold from file (for details look in routine gethsspcut)
         CALL GETHSSPCUT(KISO,MAXSTEP,THRESHOLD,ISOLEN,ISOIDE,NSTEP)
      ENDIF
      WRITE(*,*)'=================================================='//
     +     '============================'
      CALL LOWTOUP(EXCLUDE_IDENTICAL,80)
      IF ( INDEX(EXCLUDE_IDENTICAL,'Y') .NE. 0) LIDE_100=.TRUE.

C---- ------------------------------------------------------------------
C---- read HSSP-file
C---- ------------------------------------------------------------------

      CALL READHSSP(KIN,HSSPFILE,LERROR,
     +     MAXRES,MAXALIGNS,MAXCORE,MAXINS,MAXINSBUFFER,
     +     PDBID,HEADER,COMPOUND,SOURCE,AUTHOR,SEQLENGTH,
     +     NCHAIN,KCHAIN,CHAINREMARK,NALIGN,
     +     EXCLUDEFLAG,EMBLID,STRID,IDE,SIM,IFIR,ILAS,
     +     JFIR,JLAS,LALI,NGAP,LGAP,LENSEQ,ACCNUM,PROTNAME,
     +     PDBNO,PDBSEQ,CHAINID,SECSTR,COLS,SHEETLABEL,BP1,
     +     BP2,ACC,NOCC,VAR,ALISEQ,ALIPOINTER,
     +     SEQPROF,NDEL,NINS,ENTROPY,RELENT,CONSWEIGHT,
     +     INSNUMBER,INSALI,INSPOINTER,INSLEN,INSBEG_1,
     +     INSBEG_2,INSBUFFER,LCONSERV,LHSSP_LONG_ID)
      IF (LERROR) THEN
         WRITE(*,*)'*** ERROR reading HSSP-file (after READHSSP)'
         STOP
      ENDIF
C---- 
C---- read 'old' database specification and parameter
C---- 
      CALL OPEN_FILE(KIN,HSSPFILE,'old,readonly',lerror)
      DO WHILE(INDEX(LINE,'HSSP').EQ.0)
         READ(KIN,'(A)')LINE
      ENDDO
      I=LEN(HSSPLINE)
      HSSPLINE(1:I)=LINE(1:I)
      DO WHILE (INDEX(LINE,'SEQBASE').EQ.0 .AND.
     +     INDEX(LINE,'DATABASE').EQ.0)
         READ(KIN,'(A)')LINE
      ENDDO
      I=LEN(DATABASE)
      DATABASE(1:I)=LINE(1:I)
      LINE=' '
      ILINE=1
      DO WHILE (INDEX(LINE,'THRESHOLD').EQ.0)
         READ(KIN,'(A)')LINE
         IF (INDEX(LINE,'PARAMETER').NE.0) THEN
            CPARAMETER(ILINE)=LINE(11:)
            ILINE=ILINE+1
         ENDIF
      ENDDO
      NPARALINE=ILINE-1
      CLOSE(KIN)
      NRES=SEQLENGTH+KCHAIN-1
C---- 
C---- read SIMILARITY MATRIX
C---- 
      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES,NIOSTATES,NSTRSTATES,NIOSTATES,
     +     CSTRSTATES,CIOSTATES,IORANGE,KMAT,METRICFILE,MATRIX)
C---- 
      CALL SCALEMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     MATRIX,SMIN,SMAX,0.0,0.0)
C---- 
C---- GET ACTUAL DATE
C---- 
      CDATE=' '
      CALL GETDATE (CDATE)
C---- 

C---- ------------------------------------------------------------------
C---- check all pairwise identities, and exclude all pairs i,j with:
C---- j > i, and identity(i,j) > IDEMAX
C---- ------------------------------------------------------------------
      IF (IDEMAX.LT.1) THEN
         CALL DIST_TABLE_EXCLUDE(IDEMAX,NALIGN,NRES,IDE,IFIR,ILAS,
     +        LALI,ALIPOINTER,ALISEQ,EXCLUDEFLAG,NTRANS,TRANS)
      END IF
C---- 
C---- ------------------------------------------------------------------
C---- get number of alignments after 'clean up'
C---- ------------------------------------------------------------------
      WRITE(*,*)'=================================================='//
     +     '============================'
      NALIGN_FILTER=0
      DO IALIGN=1,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            IF (LNEWCURVE) THEN
               CALL CHECKHSSPCUT99(LALI(IALIGN),IDE(IALIGN)*100,ISOLEN,
     +              ISOIDE,NSTEP,LFORMULA,LALL,ISAFE,LCONSIDER,DISTANCE)
            ELSE
               CALL CHECKHSSPCUT(LALI(IALIGN),IDE(IALIGN)*100,ISOLEN,
     +              ISOIDE,NSTEP,LFORMULA,LALL,ISAFE,LCONSIDER,DISTANCE)
            ENDIF
            IF (LCONSIDER) THEN
               NALIGN_FILTER=NALIGN_FILTER+1
C---- 
C---- for exclusion of identical alignments
C---- 
               IF (LIDE_100) THEN
                  IF (IDE(IALIGN).EQ.1.0 .AND. IFIR(IALIGN).EQ.1 .AND.
     +                 ILAS(IALIGN) .EQ. NRES ) THEN
                     EXCLUDEFLAG(IALIGN)='*'
                     WRITE(*,'(i6,a)')ialign,'. ALIGNMENT excluded: '//
     +                    'identical to master'
                     NALIGN_FILTER=NALIGN_FILTER-1
                  ELSE
C---- 
C---- loop over other alignments and check for identity
C---- 
                     DO JALIGN=IALIGN+1,NALIGN
                        IF (EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
                           IF (IFIR(IALIGN) .EQ. IFIR(JALIGN) .AND.
     +                          ILAS(IALIGN) .EQ. ILAS(JALIGN) ) THEN
                              LSAME=.TRUE.
                              I=0
                              ILEN=ILAS(IALIGN)-IFIR(IALIGN)+1
                              DO WHILE( LSAME .AND. I .LE. ILEN)
                                 IF (ALISEQ(ALIPOINTER(IALIGN)+I).NE.
     +                               ALISEQ(ALIPOINTER(JALIGN)+I)) THEN
                                    LSAME=.FALSE.
                                 ENDIF
                                 I=I+1
                              ENDDO
                              IF (LSAME) THEN
                                 EXCLUDEFLAG(JALIGN)='*'
                                 WRITE(*,'(I6,A,I6)')JALIGN,
     +                          ' ALIGNMENT excluded: identical to'//
     +                                ' alignment: ',ialign
                              ENDIF
                           ENDIF
                        ENDIF
                     ENDDO
                  ENDIF
               ENDIF
            ELSE
               EXCLUDEFLAG(IALIGN)='*'
               WRITE(*,'(I6,A)')IALIGN,'. ALIGNMENT excluded: threshold'
            ENDIF
         ELSE
            WRITE(*,'(I6,A)')IALIGN,'. ALIGNMENT excluded: marked'
         ENDIF
      ENDDO

C---- --------------------------------------------------
C---- write header of HSSP file
C---- --------------------------------------------------
      IF (CHAINREMARK .NE. ' ') THEN
         CTEMP(1:)=CHAINREMARK(1:)
         I=INDEX(CTEMP,':')
         CHAINREMARK(1:)=CTEMP(I+1:)
      ENDIF
C---- 
C---- write header
C---- 
      CALL HSSPHEADER(KOUT,OUTFILE,HSSPLINE,PDBID,CDATE,
     +     DATABASE,CPARAMETER,NPARALINE,
     +     THRESHOLD,ISAFE,LFORMULA,
     +     HEADER,COMPOUND,SOURCE,AUTHOR,SEQLENGTH,
     +     NCHAIN,KCHAIN,CHAINREMARK,NALIGN_FILTER)
      
C---- END IF empty!
      IF (NALIGN_FILTER .EQ. 0) THEN
         WRITE(6,*)'-*- WARNING FILTER_HSSP file empty (no ali found)!'
         WRITE(KOUT,'(A)')'//'
         CLOSE(KOUT)
         STOP
      ENDIF

C---- --------------------------------------------------
C---- conservation weights, profile, and variance
C---- --------------------------------------------------
C---- 
C---- 98-10: br & rs 
C---- normalise MATRIX -> SIMCONSERV
C----    such that SIMCONSERV has an average of 0
C---- 
      CALL SETCONSERVATION(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES,NIOSTATES,CSTRSTATES,CIOSTATES,IORANGE,KMAT,
     +     METRICFILE,MATRIX,SIMCONSERV)
C---- 
C---- 98-10: br
C---- 98-10: br & rs 
C---- compile conservation weights
C---- 
      CALL GETCONSWEIGHT_BR(MAXSTRSTATES,MAXIOSTATES,
     +     MAXRES,MAXALIGNS,NTRANS,NASCII,NALIGN,NRES,
     +     IDE,IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
     +     EXCLUDEFLAG,TRANS,MATRIX,SIMCONSERV,MATPOS,
     +     CONSWEIGHT_MIN,CONSWEIGHT)
C---- 
C---- rescale metric
C---- 
      CALL SCALEMETRIC(NTRANS,TRANS,MAXSTRSTATES,
     +     MAXIOSTATES,MATRIX,SMIN,SMAX,0.0,0.0)
C---- 
C---- calculate variability
C---- 
      CALL CALC_VAR(NALIGN,NRES,PDBSEQ,IDE,IFIR,ILAS,
     +     ALIPOINTER,ALISEQ,EXCLUDEFLAG,MAXSTRSTATES,
     +     MAXIOSTATES,NTRANS,TRANS,MATRIX,VAR)
C---- 
C---- profiles
C---- 
      CALL CALC_PROF(MAXRES,MAXAA,NRES,PDBSEQ,NALIGN,EXCLUDEFLAG,IDE,
     +     IFIR,ILAS,ALISEQ,ALIPOINTER,TRANS,SEQPROF,
     +     NOCC,NDEL,NINS,ENTROPY,RELENT)
C---- 
C---- finally write new HSSP file
C---- 
      CALL WRITE_HSSP(KOUT,MAXRES,NALIGN,NRES,EMBLID,STRID,ACCNUM,IDE,
     +     SIM,IFIR,ILAS,JFIR,JLAS,LALI,NGAP,LGAP,LENSEQ,
     +     PROTNAME,ALIPOINTER,ALISEQ,PDBNO,CHAINID,PDBSEQ,
     +     SECSTR,COLS,BP1,BP2,SHEETLABEL,ACC,NOCC,VAR,
     +     SEQPROF,NDEL,NINS,ENTROPY,RELENT,CONSWEIGHT,
     +     INSNUMBER,INSALI,INSPOINTER,INSLEN,INSBEG_1,
     +     INSBEG_2,INSBUFFER,ISOLEN,ISOIDE,NSTEP,
     +     LFORMULA,LALL,ISAFE,EXCLUDEFLAG,LCONSERV,
     +     LHSSP_LONG_ID)
C---- 
C---- additionally write table with sequence identity ij ?
C---- 
      IF (LDIST_TABLE) THEN
         IF (DISTANCE_TABLE .EQ. 'DEFAULT') THEN
            CALL STRPOS(PDBID,ISTART,ISTOP)
            DISTANCE_TABLE=PDBID(ISTART:ISTOP)//'_distance.table'
         ENDIF
         CALL DIST_TABLE2(KOUT,DISTANCE_TABLE,NALIGN,NRES,PDBID,
     +        EMBLID,IDE,IFIR,ILAS,LALI,ALIPOINTER,ALISEQ,
     +        EXCLUDEFLAG,NTRANS,TRANS)
         WRITE(6,'(A,A)')'--- distance table into file:',DISTANCE_TABLE
      ENDIF
      END
C     end of FILTER_HSSP
C......................................................................

C......................................................................
C     SUB DIST_TABLE
      SUBROUTINE DIST_TABLE(KOUT,FILENAME,NALIGN,NRES,
     +     PDB_ID,EMBL_ID,IDE,IFIR,ILAS,LALI,
     +     ALIPOINTER,ALISEQ,EXCLUDEFLAG,NTRANS,CTRANS)
CPLAN speed up this routine
C RS May 93
C calculate and write distance table for all pairs of alignend
C sequences in one HSSP-file
C
C---- import
      IMPLICIT        NONE  
      INTEGER         KOUT,NALIGN,NRES,NTRANS,
     +                IFIR(*),ILAS(*),LALI(*),ALIPOINTER(*)
      REAL            IDE(*)
      CHARACTER       FILENAME*(*)
      CHARACTER*(*)   ALISEQ(*),EXCLUDEFLAG(*),PDB_ID*(*),EMBL_ID(*)
C---- allowed sequence symbols
      CHARACTER*(*)   CTRANS
C----
C---- internal
C----
      INTEGER         MAXRES,NASCII,MAXLEN
      PARAMETER      (NASCII=                  256)
      PARAMETER      (MAXRES=                 9999)
C      PARAMETER      (MAXRES=                10000)
      PARAMETER      (MAXLEN=                20000)
      INTEGER         IALIGN_SEQ(MAXRES),JALIGN_SEQ(MAXRES),
     +                I,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP
      REAL            SEQDIST
      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR
C---- only used to get rid of INDEX command (CPU TIME)
      INTEGER         MATPOS(NASCII)
C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
      WRITE(6,*)' dist_table'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(6,*)'ERROR: NRES .GT. MAXRES IN DIST_TABLE'
         WRITE(6,*)'**** INCREASE MAXRES ****'
         STOP
      ENDIF
C---- 
C---- initialize 
C----
      DO I=1,NRES
         IALIGN_SEQ(I)=0
         JALIGN_SEQ(I)=0
      ENDDO
      LINE=' '
      ISTEP=14
      KPOS=13
C----
C---- output file
C----
      CALL OPEN_FILE(KOUT,FILENAME,'NEW,RECL=50000',LERROR)
      CALL STRPOS(PDB_ID,IBEG,IEND)
      WRITE(KOUT,'(A,A)')PDB_ID(IBEG:IEND),' distance table' 
      WRITE(KOUT,'(A,I6)')'number of alignments: ',nalign 
C----
C---- first line gives identities and alignment lengths of the HSSP
C----
      WRITE(LINE(KPOS:),'(A,A)')'|',PDB_ID(1:12)
      KPOS=KPOS+ISTEP
      DO IALIGN=1,NALIGN-1
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            IF (KPOS .GT. MAXLEN) THEN
               WRITE(6,*)'*** ERROR: MAXLEN overflow in DIST_TABLE'//
     +              ' (lib-maxhom)'
	       WRITE(6,*)'*** INCREASE DIMENSION to > ',KPOS
	       STOP
            ENDIF
            WRITE(LINE(KPOS:),'(A,A)')'|',EMBL_ID(IALIGN)
            KPOS=KPOS+ISTEP
         ENDIF
      ENDDO
      CALL STRPOS(LINE,IBEG,IEND)
      WRITE(KOUT,*)LINE(1:IEND)
      DO I=1,IEND
         LINE(I:I)='='
      ENDDO
      WRITE(KOUT,*)LINE(1:IEND)

C---- ------------------------------------------------------------------
C---- loop over all alignments
C---- ------------------------------------------------------------------
      DO IALIGN=1,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            LINE=' '
            KPOS=27
C----
C---- first distance to pdb-seq
C----
            SEQDIST=1.0-IDE(IALIGN)
            WRITE(LINE(1:),'(A,A,2X,F4.2,1X,I5)')
     +           EMBL_ID(IALIGN),'|',SEQDIST,LALI(IALIGN)
            IPOS=ALIPOINTER(IALIGN)-IFIR(IALIGN)
C----
C---- store alignment sequence in integer array
C----
            DO IRES=IFIR(IALIGN),ILAS(IALIGN)
               IALIGN_SEQ(IRES)=MATPOS( ICHAR( ALISEQ(IPOS+IRES) ) )
               IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
	          IF (ALISEQ(IPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(IPOS+IRES) .LE. 'z') THEN
                     IALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(IPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C---- loop over pair partners
C----
            DO JALIGN=1,IALIGN-1
	       IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
                  JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
                  DO IRES=IFIR(JALIGN),ILAS(JALIGN)
                     JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
                     IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                        IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                       ALISEQ(JPOS+IRES) .LE. 'z') THEN
                           JALIGN_SEQ(IRES)=
     +                          MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                        ENDIF
                     ENDIF
                  ENDDO
                  SEQDIST=0.0
                  IAGR=0
                  ILEN=0
C----
C---- get distance between overlap of alignend sequences
C----
                  IBEG= MAX(IFIR(IALIGN),IFIR(JALIGN))
                  IEND= MIN(ILAS(IALIGN),ILAS(JALIGN))
                  DO IRES= IBEG,IEND
                     IF ( IALIGN_SEQ(IRES) .NE. 0 .AND.
     +                    JALIGN_SEQ(IRES) .NE. 0) THEN
                        IF (IALIGN_SEQ(IRES) .EQ. JALIGN_SEQ(IRES)) THEN
                           IAGR=IAGR+1
                        ENDIF
                        ILEN=ILEN+1
                     ENDIF
                  ENDDO
                  IF (ILEN .NE. 0) THEN
                     SEQDIST=1.0-(FLOAT(IAGR)/ILEN)
                  ENDIF
C----
C---- build up output line
C----
                  WRITE(LINE(KPOS:),'(A,2X,F4.2,1X,I5)')'|',SEQDIST,ILEN
                  KPOS=KPOS+14
                  IF (KPOS .GT. MAXLEN) THEN
                     WRITE(6,*)'*** ERROR: MAXLEN overflow in'//
     +                    '  DIST_TABLE (lib-maxhom)'
                     WRITE(6,*)'*** INCREASE DIMENSION > ',KPOS
                     STOP
                  ENDIF
               ENDIF
            ENDDO
C----       end loop over pairs
            CALL STRPOS(LINE,IBEG,IEND)
            WRITE(KOUT,'(A)')LINE(IBEG:IEND)
         ENDIF
      ENDDO
C---- end loop over all alignments
      CLOSE(KOUT)
      RETURN
      END
C     END DIST_TABLE
C......................................................................

C......................................................................
C     SUB DIST_TABLE2
      SUBROUTINE DIST_TABLE2(KOUT,FILENAME,NALIGN,NRES,
     +     PDB_ID,EMBL_ID,IDE,IFIR,ILAS,LALI,
     +     ALIPOINTER,ALISEQ,EXCLUDEFLAG,NTRANS,CTRANS)
CPLAN speed up this routine
C RS May 93
C calculate and write distance table for all pairs of alignend
C sequences in one HSSP-file
C
C---- import
      IMPLICIT        NONE  
      INTEGER         KOUT,NALIGN,NRES,NTRANS,
     +                IFIR(*),ILAS(*),LALI(*),ALIPOINTER(*)
      REAL            IDE(*)
      CHARACTER       FILENAME*(*)
      CHARACTER*(*)   ALISEQ(*),EXCLUDEFLAG(*),PDB_ID*(*),EMBL_ID(*)
C---- allowed sequence symbols
      CHARACTER*(*)   CTRANS
C----
C---- internal
C----
      INTEGER         MAXRES,NASCII,MAXLEN
      PARAMETER      (NASCII=                  256)
      PARAMETER      (MAXRES=                 9999)
C      PARAMETER      (MAXRES=                10000)
      PARAMETER      (MAXLEN=                20000)
      INTEGER         IALIGN_SEQ(MAXRES),JALIGN_SEQ(MAXRES),
     +                I,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP
      REAL            SEQDIST
      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR
      CHARACTER       XC
C---- only used to get rid of INDEX command (CPU TIME)
      INTEGER         MATPOS(NASCII)
C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
C---- spacer
      XC=CHAR(9)
      XC=' '
      XC='|'
      WRITE(6,*)' dist_table'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(6,*)'ERROR: NRES .GT. MAXRES IN DIST_TABLE'
         WRITE(6,*)'**** INCREASE MAXRES ****'
         STOP
      ENDIF
C---- 
C---- initialize 
C----
      DO I=1,NRES
         IALIGN_SEQ(I)=0
         JALIGN_SEQ(I)=0
      ENDDO
      LINE=' '
      ISTEP=12
      KPOS=12

C---- ------------------------------------------------------------------
C---- output file
C----
      CALL OPEN_FILE(KOUT,FILENAME,'NEW,RECL=50000',LERROR)
C----
C---- header
C----
      CALL STRPOS(PDB_ID,IBEG,IEND)
      WRITE(KOUT,'(A)')   '# HSSP_FILTER DISTANCE TABLE'
      WRITE(KOUT,'(A,A)') '# PDBID     ',PDB_ID(IBEG:IEND)
      WRITE(KOUT,'(A,I6)')'# NALIGN    ',NALIGN
      WRITE(KOUT,'(A,A)') '# NOTATION  ','ROWS:      i = 1   .. nali'
      WRITE(KOUT,'(A,A)') '# NOTATION  ','EACH ROW : j = i+1 .. nali'
      WRITE(KOUT,'(A,A)') '# NOTATION  ','EACH CELL: PIDE,LALI'
C----
C---- how long will lines be?
C----
      KPOS=ISTEP
      DO IALIGN=2,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            IF (KPOS .GT. MAXLEN) THEN
               WRITE(6,*)'*** ERROR: MAXLEN overflow in DIST_TABLE'//
     +              ' (lib-maxhom)'
	       WRITE(6,*)'*** INCREASE DIMENSION!!'
	       STOP
            ENDIF
            KPOS=KPOS+ISTEP
         ENDIF
      ENDDO
      IEND=KPOS
C---- beautiful FORTRAN ASCII
      DO I=1,IEND
         LINE(I:I)='='
      ENDDO
      WRITE(KOUT,'(A,A)')"# ",LINE(1:IEND)
C----
C---- first line gives identities and alignment lengths of the HSSP
C----
      WRITE(LINE(1:),'(A)')PDB_ID(1:12)
      KPOS=ISTEP
      DO IALIGN=2,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            WRITE(LINE(KPOS:),'(A,A)')XC,EMBL_ID(IALIGN)
            KPOS=KPOS+ISTEP
         ENDIF
      ENDDO
      CALL STRPOS(LINE,IBEG,IEND)
      WRITE(KOUT,*)LINE(1:IEND)

C---- ------------------------------------------------------------------
C---- loop over all alignments
C---- ------------------------------------------------------------------
      DO IALIGN=1,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            LINE=' '
            KPOS=1+ISTEP
C---- 
C---- first distance to pdb-seq
C----
            SEQDIST=1.0-IDE(IALIGN)
            WRITE(LINE(1:),'(A,A,I4,A1,I5)')
     +           EMBL_ID(IALIGN)(1:ISTEP),XC, 
     +           INT(100*SEQDIST),',',LALI(IALIGN)
            IPOS=ALIPOINTER(IALIGN)-IFIR(IALIGN)
C----
C----       store alignment sequence in integer array (for i)
C----
            DO IRES=IFIR(IALIGN),ILAS(IALIGN)
               IALIGN_SEQ(IRES)=MATPOS( ICHAR( ALISEQ(IPOS+IRES) ) )
               IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
	          IF (ALISEQ(IPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(IPOS+IRES) .LE. 'z') THEN
                     IALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(IPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C---- loop over pair partners
C----
            DO JALIGN=(IALIGN+1),NALIGN
	       IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
                  JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
C----
C----             store alignment sequence in integer array (for j)
C----
                  DO IRES=IFIR(JALIGN),ILAS(JALIGN)
                     JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
                     IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                        IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                       ALISEQ(JPOS+IRES) .LE. 'z') THEN
                           JALIGN_SEQ(IRES)=
     +                          MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                        ENDIF
                     ENDIF
                  ENDDO
                  SEQDIST=0.0
                  IAGR=0
                  ILEN=0
C----
C----             get distance between overlap of alignend sequences
C----
                  IBEG= MAX(IFIR(IALIGN),IFIR(JALIGN))
                  IEND= MIN(ILAS(IALIGN),ILAS(JALIGN))
                  DO IRES= IBEG,IEND
                     IF ( IALIGN_SEQ(IRES) .NE. 0 .AND.
     +                    JALIGN_SEQ(IRES) .NE. 0) THEN
                        IF (IALIGN_SEQ(IRES) .EQ. JALIGN_SEQ(IRES)) THEN
                           IAGR=IAGR+1
                        ENDIF
                        ILEN=ILEN+1
                     ENDIF
                  ENDDO
                  IF (ILEN .NE. 0) THEN
                     SEQDIST=1.0-(FLOAT(IAGR)/ILEN)
                  ENDIF
C----
C---- build up output line
C----
C                 WRITE(LINE(KPOS:),'(A,2X,F4.2,1X,I5)')'|',SEQDIST,ILEN
                  WRITE(LINE(KPOS:),'(A,I4,A1,I5)')
     +                 XC, INT(100*SEQDIST),',',ILEN
                  KPOS=KPOS+ISTEP
                  IF (KPOS .GT. MAXLEN) THEN
                     WRITE(6,*)'*** ERROR: MAXLEN overflow in'//
     +                    '  DIST_TABLE (lib-maxhom)'
                     WRITE(6,*)'*** INCREASE DIMENSION!!'
                     STOP
                  ENDIF
               ENDIF
            ENDDO
C----       end loop over pairs
            CALL STRPOS(LINE,IBEG,IEND)
            WRITE(KOUT,'(A)')LINE(IBEG:IEND)
         ENDIF
      ENDDO
C---- end loop over all alignments
      CLOSE(KOUT)
      RETURN
      END
C     END DIST_TABLE2
C......................................................................

C......................................................................
C     SUB DIST_TABLE_EXCLUDE
      SUBROUTINE DIST_TABLE_EXCLUDE(IDEMAX,NALIGN,NRES,IDE,
     +     IFIR,ILAS,LALI,ALIPOINTER,ALISEQ,EXCLUDEFLAG,NTRANS,CTRANS)
C---- 
C---- BR May 98
C---- 
C---- Calculate pairwise levels of sequence identity, and returns
C---- EXCLUDEFLAG(iali)='*' if the identity of alignment number
C---- 'iali' to any other sequence is above IDEMAX (threshold input)
C---- 
C---- out:           output is the changed vectore EXCLUDEFLAG
C---- 
C---- import
      IMPLICIT        NONE  
      INTEGER         NALIGN,NRES,NTRANS,
     +                IFIR(*),ILAS(*),LALI(*),ALIPOINTER(*)
      REAL            IDE(*),IDEMAX
      CHARACTER*(*)   ALISEQ(*),EXCLUDEFLAG(*)
C---- allowed sequence symbols
      CHARACTER*(*)   CTRANS
C----
C---- internal
C----
      INTEGER         MAXRES,NASCII,MAXLEN
      PARAMETER      (NASCII=                  256)
      PARAMETER      (MAXRES=                 9999)
C      PARAMETER      (MAXRES=                10000)
      PARAMETER      (MAXLEN=               100000)
C     br 2000-04: was 20000!
C      PARAMETER      (MAXLEN=               20000)
      INTEGER         IALIGN_SEQ(MAXRES),JALIGN_SEQ(MAXRES),
     +                I,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP
      REAL            SEQIDE
      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR
C---- only used to get rid of INDEX command (CPU TIME)
      INTEGER         MATPOS(NASCII)
C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
      WRITE(6,*)  '--- lib-maxhom:DIST_TABLE_EXCLUDE'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(6,*)'*** ERROR: NRES .GT. MAXRES IN DIST_TABLE_EXCLUDE'
         WRITE(6,*)'*** INCREASE MAXRES to > ',NRES
         STOP
      ENDIF
C---- 
C---- initialize 
C----
      DO I=1,NRES
         IALIGN_SEQ(I)=0
         JALIGN_SEQ(I)=0
      ENDDO
      ISTEP=14
      KPOS=13
C----
C---- first line gives identities and alignment lengths of the HSSP
C----
      KPOS=KPOS+ISTEP
      DO IALIGN=1,NALIGN-1
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            IF (KPOS .GT. MAXLEN) THEN
               WRITE(6,*)'*** ERROR: MAXLEN overflow in'//
     +              ' DIST_TABLE_EXCLUDE (lib-maxhom)'
	       WRITE(6,*)'*** INCREASE DIMENSION to > ',KPOS
	       STOP
            ENDIF
            KPOS=KPOS+ISTEP
         ENDIF
      ENDDO

C---- ------------------------------------------------------------------
C---- loop over all alignments
C---- ------------------------------------------------------------------
      DO IALIGN=1,NALIGN
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
            KPOS=27
C----
C---- first distance to pdb-seq
C----
            SEQIDE=IDE(IALIGN)
            IPOS=ALIPOINTER(IALIGN)-IFIR(IALIGN)
C----
C---- store alignment sequence in integer array
C----
            DO IRES=IFIR(IALIGN),ILAS(IALIGN)
               IALIGN_SEQ(IRES)=MATPOS( ICHAR( ALISEQ(IPOS+IRES) ) )
               IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
	          IF (ALISEQ(IPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(IPOS+IRES) .LE. 'z') THEN
                     IALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(IPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C---- loop over pair partners
C----
C            DO JALIGN=1,IALIGN-1
            DO JALIGN=IALIGN+1,NALIGN
	       IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
                  JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
                  DO IRES=IFIR(JALIGN),ILAS(JALIGN)
                     JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
                     IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                        IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                       ALISEQ(JPOS+IRES) .LE. 'z') THEN
                           JALIGN_SEQ(IRES)=
     +                          MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                        ENDIF
                     ENDIF
                  ENDDO
                  SEQIDE=0.0
                  IAGR=0
                  ILEN=0
C----
C---- get distance between overlap of alignend sequences
C----
                  IBEG= MAX(IFIR(IALIGN),IFIR(JALIGN))
                  IEND= MIN(ILAS(IALIGN),ILAS(JALIGN))
                  DO IRES= IBEG,IEND
                     IF ( IALIGN_SEQ(IRES) .NE. 0 .AND.
     +                    JALIGN_SEQ(IRES) .NE. 0) THEN
                        IF (IALIGN_SEQ(IRES) .EQ. JALIGN_SEQ(IRES)) THEN
                           IAGR=IAGR+1
                        ENDIF
                        ILEN=ILEN+1
                     ENDIF
                  ENDDO
                  IF (ILEN .NE. 0) THEN
                     SEQIDE=(FLOAT(IAGR)/ILEN)
                  ENDIF
C---- exclude if too similar
                  IF (SEQIDE.GE.IDEMAX) THEN
                     EXCLUDEFLAG(JALIGN)='*'
                  ENDIF
C----
C---- build up output line
C----
                  KPOS=KPOS+14
                  IF (KPOS .GT. MAXLEN) THEN
                     WRITE(6,*)'*** ERROR: MAXLEN overflow in'//
     +                    '  DIST_TABLE_EXCLUDE (lib-maxhom)'
                     WRITE(6,*)'*** INCREASE DIMENSION > ',KPOS
                     STOP
                  ENDIF
               ENDIF
            ENDDO
C----       end loop over pairs
         ENDIF
      ENDDO
C---- end loop over all alignments
      RETURN
      END
C     END DIST_TABLE_EXCLUDE
C......................................................................

C......................................................................
C     SUB GETCONSWEIGHT_BR
      SUBROUTINE GETCONSWEIGHT_BR(MAXSTRSTATES,MAXIOSTATES,
     +     MAXRES,MAXALIGNS,NTRANS,NASCII,
     +     NALIGN,NRES,IDE,IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
     +     EXCLUDEFLAG,CTRANS,MATRIX,SIMCONSERV,MATPOS,
     +     CONSWEIGHT_MIN,CONSWEIGHT)
C---- 
C---- BR May 98 + Oct 98
C---- 
C---- Calculate the conservation weight, taking into account the
C---- EXCLUDEFLAG(iali)='*' if the identity of alignment number
C---- 'iali' to any other sequence is above IDEMAX (threshold input)
C---- 
C---- 
C---- out:           output is the conservation weight
C---- 
C---- ------------------------------------------------------------------
C----
C---- formula: 
C----                 nali
C----                 -----
C----                 \      (1 - IDE(s,a,b)) * SIM(s,a,b)
C----          CW(s)=  >     -----------------------------       
C----                 /                DISTSUM
C----                 -----
C----                 a,b
C----                 
C---- with:    CW(s):       conservation weight for residue s
C----          a,b:         alignment between protein a and b
C----          IDE(s,a,b):  identity of residue s in a and s in b
C----                       = 0 || 1
C----          SIM(s,a,b):  similarity of residue s in a and s in b
C----                 
C----          DISTSUM(s):  sum over all distances at position s
C----                       and the following definition:
C---- 
C----                 nali   nres = overlap (a,b)
C----                 -----  ----
C----                 \      \             delta(s,a,b)
C----     DISTSUM(s)=  >      >     ------------------------------
C----                 /      /      number of overlapping residues
C----                 -----  ----
C----                 a,b    s
C----                 
C---- with:    delta(s,a,b) = 1 if residue s in a = residue s in b
C----                         0 else
C---- 
C---- normalise:
C----          finally normalised weights to have an average of 1:
C---- 
C----                 nres
C----                 -----
C----                 \      
C----        NORM(s)=  >     CW(s)
C----                 /           
C----                 -----
C----                 s
C---- 
C----     CW_NORM(s)= CW(s) / NORM
C---- 
C---- 
C---- ------------------------------------------------------------------
C---- 

      IMPLICIT        NONE  

C---- 
C---- import
C---- 
C     parameters for array
      INTEGER         MAXSTRSTATES,MAXIOSTATES,MAXRES,MAXALIGNS,
     +                NTRANS,NASCII
C     actual values
      INTEGER         NALIGN,NRES
C     pointer arrays
      INTEGER         IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +                ALIPOINTER(MAXALIGNS)
C     alignment length lali(i) length of ali between PDBSEQ and ali i
      INTEGER         LALI(MAXALIGNS)
C     guide sequence
      CHARACTER       PDBSEQ(MAXRES)
C     all aligned sequences
      CHARACTER*(*)   ALISEQ(*)
C     flags (take ' ', else other)
      CHARACTER*(*)   EXCLUDEFLAG(MAXALIGNS)
C     percentage sequence identity
      REAL            IDE(MAXALIGNS),IDEMAX
C     comparison metric
      REAL            MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                      MAXSTRSTATES,MAXIOSTATES)   
C     normalised to sum over 0 (by SETCONSERVATION)
      REAL            SIMCONSERV(NTRANS,NTRANS)
C     allowed sequence symbols
      CHARACTER*(*)   CTRANS
C     minimal conservation weight
      REAL            CONSWEIGHT_MIN
C     only used to get rid of INDEX command (CPU time)
      INTEGER         MATPOS(NASCII)

C----
C---- output from sbr
C----
C     conservation weight
      REAL            CONSWEIGHT(MAXRES)

C---- ------------------------------------------------------------------
C---- internal
C---- ------------------------------------------------------------------
C----
C      INTEGER        NASCII,MAXLEN
      INTEGER         MAXRES_LOC,MAXLEN
      PARAMETER      (MAXRES_LOC=             9999)
C      PARAMETER      (MAXRES_LOC=            10000)
      PARAMETER      (MAXLEN=                20000)
      INTEGER         IALIGN_SEQ(MAXRES_LOC),JALIGN_SEQ(MAXRES_LOC),
     +                I,J,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP,ISAFERANGE,
     +                IALIGN_SEQTMP,JALIGN_SEQTMP
      INTEGER         NOCC(MAXRES_LOC)

C---- big: seq ide distance for pair i,j
      REAL            SUM,MEAN,XVAL
      INTEGER         NPOS

      REAL            SIMDIST_POS(MAXRES_LOC)
      REAL            SEQDIST_POS(MAXRES_LOC)

      REAL            SEQDIST
      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR

C---- ------------------------------------------------------------------
C---- 
C---- defaults, ini

C---- 
C---- FORMULA+ISAFERANGE -> include into averaging
      ISAFERANGE= 5
C---- br: make 'safer' for weights
      ISAFERANGE= 5
C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
      WRITE(6,*)  '--- GETCONSWEIGHT_BR begin'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(*,*)'*** ERROR: NRES .GT. MAXRES IN GETCONSWEIGHT_BR'
         WRITE(*,*)'*** INCREASE MAXRES ****'
         STOP
      ENDIF
C---- 
C---- ERROR!
C---- 
      IF (NRES .LE. 0) RETURN
C---- 
C---- initialize 
C----
      DO I=1,NRES
         IALIGN_SEQ(I)= 0
         JALIGN_SEQ(I)= 0
         SIMDIST_POS(I)=0.0
         SEQDIST_POS(I)=0.0
         NOCC(I)=       0
      ENDDO
      
C---- ------------------------------------------------------------------
C---- guide against all
C---- ------------------------------------------------------------------
C---- store PDB sequence in integer array
      DO IRES=1,NRES
         IALIGN_SEQ(IRES)=MATPOS(ICHAR(PDBSEQ(IRES)))
         IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
            IF ( PDBSEQ(IRES) .GE. 'a' .AND. 
     +           PDBSEQ(IRES) .LE. 'z') THEN
               IALIGN_SEQ(IRES)=
     +              MATPOS(ICHAR(PDBSEQ(IRES))-32)
            ENDIF
         ENDIF
      ENDDO
      
C----
C---- loop over all aligned sequences
C----
      DO JALIGN=1,NALIGN
         IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
C----          store alignment sequence in integer array (for j)
            JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
            DO IRES=IFIR(JALIGN),ILAS(JALIGN)
               JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
               IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                  IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(JPOS+IRES) .LE. 'z') THEN
                     JALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C---- 
C---- passed into SBR: IDE(i)
C---- 
            SEQDIST= 1.0 - IDE(JALIGN)
C----
C----       get overlap of aligned sequences
C----
            IBEG= MAX(1,   IFIR(JALIGN))
            IEND= MIN(NRES,ILAS(JALIGN))
            DO IRES= IBEG,IEND
               IF ( (IALIGN_SEQ(IRES) .NE. 0) .AND.
     +              (JALIGN_SEQ(IRES) .NE. 0) ) THEN
C---- 
C---- count up number of pairs found for current residue
C---- 
                  NOCC(IRES)=NOCC(IRES)+1
C----
C----             position specific distances
C----               
                  SEQDIST_POS(IRES)=
     +                 SEQDIST_POS(IRES) + SEQDIST
                  SIMDIST_POS(IRES)=
     +                 SIMDIST_POS(IRES) + 
     +                 SEQDIST * SIMCONSERV(IALIGN_SEQ(IRES),
     +                                      JALIGN_SEQ(IRES))
               END IF
            END DO
         ENDIF
C----    end of: exclude?
      ENDDO
C---- end loop over all sequences aligned to guide

C---- ------------------------------------------------------------------
C---- all against all: get all pair distances
C---- ------------------------------------------------------------------
      DO IALIGN=1,NALIGN
C----    to exclude?
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
C----       store alignment sequence in integer array (for i)
            IPOS=ALIPOINTER(IALIGN)-IFIR(IALIGN)
            DO IRES=IFIR(IALIGN),ILAS(IALIGN)
               IALIGN_SEQ(IRES)=MATPOS( ICHAR( ALISEQ(IPOS+IRES) ) )
               IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
	          IF (ALISEQ(IPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(IPOS+IRES) .LE. 'z') THEN
                     IALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(IPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C----       loop over pair partners
C----
            DO JALIGN=IALIGN+1,NALIGN
	       IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
C----             store alignment sequence in integer array (for j)
                  JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
                  DO IRES=IFIR(JALIGN),ILAS(JALIGN)
                     JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
                     IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                        IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                       ALISEQ(JPOS+IRES) .LE. 'z') THEN
                           JALIGN_SEQ(IRES)=
     +                          MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                        ENDIF
                     ENDIF
                  ENDDO
C----
C---- get distance between overlap of aligned sequences
C----
                  IAGR=0
                  ILEN=0
                  IBEG= MAX(IFIR(IALIGN),IFIR(JALIGN))
                  IEND= MIN(ILAS(IALIGN),ILAS(JALIGN))
                  DO IRES=IBEG,IEND
                     IF ( IALIGN_SEQ(IRES) .NE. 0 .AND.
     +                    JALIGN_SEQ(IRES) .NE. 0) THEN

C---- count up number of pairs found for current residue
                        NOCC(IRES)=NOCC(IRES)+1

                        IF (IALIGN_SEQ(IRES).EQ.JALIGN_SEQ(IRES)) THEN
                           IAGR=IAGR+1
                        ENDIF
                        ILEN=ILEN+1
                     ENDIF
                  ENDDO
                  IF (ILEN .NE. 0) THEN
                  
                     SEQDIST= 1.0 - (FLOAT(IAGR)/ILEN)

                     DO IRES=IBEG,IEND
                        IF ( IALIGN_SEQ(IRES).NE.0 .AND.
     +                       JALIGN_SEQ(IRES).NE.0 ) THEN
                           SEQDIST_POS(IRES)=
     +                          SEQDIST_POS(IRES) + SEQDIST
                           SIMDIST_POS(IRES)=
     +                          SIMDIST_POS(IRES) + 
     +                          SEQDIST * SIMCONSERV(IALIGN_SEQ(IRES),
     +                                               JALIGN_SEQ(IRES))
                        ENDIF
                     END DO
                  END IF
               ENDIF
C----          end of: exclude?
            ENDDO
C----       end loop over pairs
         ENDIF
      ENDDO
C---- end loop over all alignments

C---- ------------------------------------------------------------------
C---- assign conservation weights
C---- ------------------------------------------------------------------

      DO IRES=1,NRES
         IF ((SEQDIST_POS(IRES) .GT. 0) .AND.
     +       (NOCC(IRES) .GT. 0) ) THEN
            CONSWEIGHT(IRES)=
     +           SIMDIST_POS(IRES)/SEQDIST_POS(IRES)
C            write(6,'(a,i4,a,f8.3,a,f8.3,a,f8.3)')'xx before norm i=',
C     +           ires,' cw=',consweight(ires),
C     +           ' sim=',simdist_pos(ires),
C     +           ' dis=',seqdist_pos(ires)
         ELSE 
            CONSWEIGHT(IRES)=1.0
         END IF
C----
C----    no negative values for conservation weight
C----
         IF (CONSWEIGHT(IRES) .LT. CONSWEIGHT_MIN) THEN
            CONSWEIGHT(IRES)=CONSWEIGHT_MIN
         ENDIF
      END DO

C---- ------------------------------------------------------------------
C---- weight conservation weights (average = 1)
C---- ------------------------------------------------------------------

      NPOS= 0 
      MEAN= 1.0
      SUM=  0.0
      DO IRES=1,NRES
         IF (NOCC(IRES).NE.0) THEN
            SUM = SUM  + CONSWEIGHT(IRES) 
            NPOS=NPOS+1
         ENDIF
      ENDDO
      IF (NPOS .NE. 0) THEN 
         MEAN=SUM/NPOS 
      ENDIF
      WRITE(6,*)'GETCONSWEIGHT: SUM,MEAN ',SUM,MEAN
      IF (MEAN.GT. 0.99 .AND. MEAN .LT. 1.01) RETURN
      XVAL=1.0-MEAN

      DO IRES=1,NRES
         IF (NOCC(IRES).NE.0) CONSWEIGHT(IRES)=CONSWEIGHT(IRES)+XVAL
      ENDDO

      WRITE(6,*)  '--- GETCONSWEIGHT_BR ended'
      RETURN
      END
C     END GETCONSWEIGHT_BR 
C......................................................................

C......................................................................
C     SUB SETCONSERVATION
      SUBROUTINE SETCONSERVATION(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES,NIOSTATES,CSTRSTATES,CIOSTATES,IORANGE,KMAT,
     +     METRIC_FILENAME,MATRIX,SIMCONSERV)
C 1. set conservation weights to 1.0
C 2. rescale matrix for the 22 amino residues such that the sum over
C    the matrix is 0.0 (or near)
C this matrix is used to calculate the conservation weights (SIMCONSERV)
c	implicit none
C import
      CHARACTER*(*)   METRIC_FILENAME
      REAL            MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                       MAXSTRSTATES,MAXIOSTATES)
      REAL            SIMCONSERV(1:26,1:26)
      INTEGER         NSTRSTATES,NIOSTATES,KMAT
      CHARACTER*(*)   CSTRSTATES,CIOSTATES
      REAL            IORANGE(MAXSTRSTATES,MAXIOSTATES)
     
C internal
      INTEGER         NACID,MAXRES_LOC
      PARAMETER      (NACID=                    22)
      PARAMETER      (MAXRES_LOC=             9999)
C      PARAMETER      (MAXRES_LOC=            10000)

      CHARACTER*(26)  TRANS

      INTEGER         I,J
      LOGICAL         LFIRSTWEIGHT
      REAL            XLOW,XHIGH,XMAX,XMIN,XFACTOR,SUMMAT
      REAL            CONSWEIGHT_1(MAXRES_LOC),
     +                CONSWEIGHT_2(MAXRES_LOC),CONSMIN
*----------------------------------------------------------------------*

C
      DO I=1,MAXRES_LOC 
         CONSWEIGHT_1(I)=1.0
      ENDDO
      LFIRSTWEIGHT=.TRUE.

C     get metric
C     98-10 br: already done
C      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
C     +     NSTRSTATES,NIOSTATES,NSTRSTATES,NIOSTATES,
C     +     CSTRSTATES,CIOSTATES,IORANGE,KMAT,METRIC_FILENAME,MATRIX)

c     rescale matrix that the sum over matrix is +- 0.0 
      XLOW=     0.0 
      XHIGH=    0.0
      XMAX=     1.0 
      XMIN=    -1.0 
      XFACTOR=100.0
	
C (re)store original values in simconserv()
 20   DO J=1,NTRANS 
         DO I=1,NTRANS
            SIMCONSERV(I,J)=MATRIX(I,J,1,1,1,1) 
         ENDDO
      ENDDO
c scale with xmin/xmax
      CALL SCALEINTERVAL(SIMCONSERV,NTRANS**2,XMIN,XMAX,XLOW,XHIGH)
C RESEt the values for 'X' '!' and '-'
      I=INDEX(TRANS,'X')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'!')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'-')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'.')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
C calculate sum over matrix (22 amino acids) after scaling
      SUMMAT=0.0
      DO I=1,NACID 
         DO J=1,NACID
            SUMMAT=SUMMAT+SIMCONSERV(I,J)
         ENDDO
      ENDDO
cd	write(*,*)' sum: ',summat,xmin
c check sum=0.0 (+- 0.01) ; if not xmin=xmin/2 ; scale again
      IF (SUMMAT .GT. 0.01) THEN
         XMIN=XMIN+(XMIN/XFACTOR)
      ELSE IF (SUMMAT .LT. -0.01) THEN
         XMIN=XMIN-(XMIN/XFACTOR)
      ELSE
         WRITE(*,*)' SETCONSERVATION: sum over matrix: ',summat
         WRITE(*,*)'                  smin is : ',xmin
         RETURN
      ENDIF
      GOTO 20
      END
C     END SETCONSERVATION
C......................................................................

C============================================  PVM3
C maxhom node interface for PVM3
	subroutine node_interface(lh1,lh2)
 
	implicit none
	include 'maxhom.param'
	include 'maxhom.common'
c import
	real      lh1(0:maxmat)
	integer*2 lh2(0:maxtrace)
 
c internal
C on a mixed architecture network the node is reading the alignment
C data on request and sends them to the host
C local for each node
	real      value,sim,hom,rms,distance,checkval,sdev
	integer ifir,jfir,jlas,idel,ndel,len1,lenocc
	integer irecord,nrecord,ialign,ifile,imsgtag
	integer i,j,k,ipoint,iend
	integer ilen_name,ilen_compnd,ilen_ACCESSION,ilen_pdbref,ilen_al
	integer ilen_insseq
	integer ilconsider,ildssp_2
	character*100 coretemp
	character csymbol,ctemp
	logical lerror
c       logical lendbase
 
        integer file_buffer(maxqueue),nfile_queue
	character*80 filename_buffer(maxqueue_list)
	character*80 filename,tempname
        character pdbrefline*3000
	character*80 chainremark,profilemetric
   	character line*100
 
 
	integer iseq,ibuf_poi
 
c checkformat
	character*20 seqformat
	integer ifirst_round,iflag
	integer ipos,nchain,kselect
c	integer kchain
	real xmaplow,xmaphigh,xsmin,xsmax
        logical ltruncated
c        logical ldb_read_one
 
C init
C timing
        total_time=0.0
	current_dir=' ' 
         architecture=' '
	lfirst_scan=.true.
 
c        ldb_read_one=.false.
 
	nbuffer_len = 6 + 12 + len(compnd_2) +
     +   len(ACCESSION_2) + len(pdbref_2)
c	nbuffer_len = 6 + len(name_2) + len(compnd_2) +
c     +   len(ACCESSION_2) + len(pdbref_2)
 
	call get_machine_name(machine_name)
	tempname='ARCH'
	call get_enviroment_variable(tempname,architecture)
	tempname='MAXHOM_DEFAULT'
	call get_enviroment_variable(tempname,maxhom_default)
	if(maxhom_default .eq. ' ')then
	   write(*,*)'WARN: env.var. MAXHOM_DEFAULT not set; '//
     +               'now: ./maxhom.default'
	   maxhom_default(1:)='maxhom.default'
	   call flush_unit(6)
	endif
c	write(*,'(a,a,a,a,i5)')' maxhom_node : ',
c     +        machine_name(1:15),' ',architecture(1:6),idproc
c	call flush_unit(6)
 
C receive all the necessary data from host
C loop entry for list processing
 10	call receive_data_from_host(id_host) 
         call flush_unit(6)
c open log file for parameter,warnings, error.....
	if(lfirst_scan .eqv. .true.)then
	   call concat_string_int('MAXHOM.LOG_',idproc,logfile)
           tempname=logfile
	   if(corepath .ne. ' ')then
	     call concat_strings(corepath,tempname,logfile)
           endif
c          tempname= 'NEW,RECL=200'
c	   call open_file(klog,logfile,tempname,lerror)
c	   call log_file(klog,'**************************** MAXHOM-'//
c     +         'LOGFILE ***************************',1)
	endif
C end signal if we had a list of sequences
	if(n1 .eq. -999) goto 900
 
 	do i=1,maxqueue
	   file_buffer(i) = 0
	enddo
 	do i=1,maxqueue_list
	   filename_buffer(i)=' '
	enddo
	ipoint=1
	ialign=0 
         nrecord=0 
         irecord=0 
         ifile=0 
         ialign_good=0
	insseq=' ' 
         sdev=0.0
 
C overwrite default stuff in case the actual machine is on a different
C file system (connected via Ethernet, Internet..)
C Caution: maxhom.default has to be on the right place
c	call get_default()
 
   	ldssp_2=.false. 
         n2in=0 
         csymbol=' ' 
         csq_2=' '
	header_2=' ' 
         compnd_2=' ' 
         author_2=' ' 
         source_2=' '
	do i=1,maxsq
	   cresid(i)=' ' 
         pdbno_2(i)=0 
         bp1_2(i)=0 
         bp2_2(i)=0
	   lacc_2(i)=0 
         lstruc_2(i)=0 
         consweight_2(i)=1.0
	enddo
	call init_char_array(1,maxsq,cols_2,csymbol)
	call init_char_array(1,maxsq,chainid_2,csymbol)
	call init_char_array(1,maxsq,sheetlabel_2,csymbol)
	call init_char_array(1,maxsq,struc_2,csymbol)
 
	call concat_string_int(corefile,link(idproc),tempname)
	coretemp= tempname
	if(corepath .ne. ' ')then
	  call concat_strings(corepath,tempname,coretemp)
        endif
	call concat_string_int('UNFORMATTED,DIRECT,NEW,RECL=',
     +                          maxrecordlen,tempname)
c	write(*,*)idproc,' : ',coretemp(1:60)
c	call flush_unit(6)
	call open_file(kcore,coretemp,tempname,lerror)
 
 
c$$$    if (ldb_read_one .eqv. .true.)then
c$$$           lfirst_scan=.false.
c$$$           msgtype=8000
c$$$	   call mp_receive_data(msgtype,link(id_host))
c$$$	   call mp_get_int4(msgtype,id_host,ipoint,N_one)
c$$$	   call mp_get_int4(msgtype,id_host,nseq_warm_start,N_one)
c$$$           msgtype=9000
c$$$	   call mp_receive_data(msgtype,link(id_host))
c$$$	   call mp_get_string_array(msgtype,id_host,cdatabase_buffer,
c$$$     +                              ipoint)
c$$$           msgtype=10000
c$$$	   call mp_receive_data(msgtype,link(id_host))
c$$$	   call mp_get_int4(msgtype,id_host,i,N_one)
c$$$	   write (*,*)' got buffer and start signal: ',idproc,ipoint,
c$$$     +                nseq_warm_start
c$$$           call flush_unit(6)
c$$$	   ipoint=1
c$$$	endif
 
        call get_cpu_time('time init:',idproc,
     +                        itime_old,itime_new,total_time,logstring)
	call log_file(klog,logstring,1)
 
C======================================================================
C NO warm-start
C======================================================================
	if(lfirst_scan .eqv. .true.)then
	  lfirst_scan=.false.
	  nfile_queue=0
	  ifirst_round=0
 
 
 
c fill queue when first communication
	     if( listofseq_2 .eqv. .true.)then
		msgtype=9000
		do i=1,maxqueue_list
		   call mp_receive_data(msgtype,link(id_host))
		   call mp_get_string(msgtype,id_host,
     +                 filename_buffer(i),len(filename_buffer(i)))
		   write(*,'(a,a,i6)')'1. got: ',
     +                   filename_buffer(i)(1:30),idproc
		   call flush_unit(6)
	           if (filename_buffer(i) .eq. 'STOP')then
		      nfile_queue=i
		      goto 180
		   endif
		enddo
		ifirst_round=1
		nfile_queue=maxqueue_list
		goto 180
	     endif
 
 
 
 
 
 
c check if there is a (are) message(s) from the host to
C  fill our work-queue
C if not, work on the next file on the stack
 
100	  msgtype=3000
	  call mp_probe(msgtype,iflag)
	  if ( iflag .gt. 0)then
	    nfile_queue=nfile_queue+1
	    call mp_receive_data(msgtype,link(id_host))
 
	    if( listofseq_2 .eqv. .false.)then
	       call mp_get_int4(msgtype,id_host,
     +                          file_buffer(nfile_queue),N_one)
c	    write(logstring,*)'fill file stack: ',idproc,nfile_queue,
c     +                 file_buffer(nfile_queue)
c	    call log_file(klog,logstring,1)
	       if (file_buffer(nfile_queue) .lt. 0)goto 180
	       goto 100
	    else
	       call mp_get_string(msgtype,id_host,
     +                           filename_buffer(nfile_queue),
     +	                         len(filename_buffer(1)) )
	       if (filename_buffer(nfile_queue) .eq. 'STOP')goto 180
	       goto 100
	    endif
	  endif
C send work-request to host
	  msgtype=2000
	  call mp_init_send()
	  call mp_put_int4(msgtype,id_host,idproc,N_one)
	  call mp_send_data(msgtype,link(id_host))
c	  write(logstring,'(a,i4,i4)')'send work_message:',idproc,
c     +                                link(id_host)
c	  call log_file(klog,logstring,1)
	  msgtype=3000
c fill queue when first communication
	  if (ifirst_round .eq. 0) then
	     if( listofseq_2 .eqv. .false.)then
		call mp_receive_data(msgtype,link(id_host))
		do i=1,maxqueue
		   call mp_get_int4(msgtype,id_host,file_buffer(i),
     +                              N_one)
		enddo
		ifirst_round=1
		nfile_queue=maxqueue
c	     else
c		do i=1,maxqueue_list
c		   call mp_receive_data(msgtype,link(id_host))
c		   call mp_get_string(msgtype,id_host,
c     +                 filename_buffer(i),len(filename_buffer(i)))
c		   write(*,'(a,a,i6)')'1. got: ',
c     +                   filename_buffer(i)(1:30),idproc
c		   call flush_unit(6)
c	           if (filename_buffer(i) .eq. 'STOP')then
c		      nfile_queue=i
c		      goto 180
c		   endif
c		enddo
c		ifirst_round=1
c		nfile_queue=maxqueue_list
	     endif
c either the master is too slow, so we have to wait :-(
c or we have finished the work and are waiting for 
C the "finish-signal" :-)
	  else if (nfile_queue .le. 0)then
	     write(logstring,'(a,i8,2x,i6)')'WARNING stack empty: ',
     +                         idproc,file_buffer(1)
	     call log_file(klog,logstring,1)
             call flush_unit(6)
	     call mp_receive_data(msgtype,link(id_host))
	     if( listofseq_2 .eqv. .false.)then
		call mp_get_int4(msgtype,id_host,file_buffer(1),N_one)
	     else
		call mp_get_string(msgtype,id_host,
     +                             filename_buffer(1),
     +                             len(filename_buffer(1)))
	     endif
	     nfile_queue=1
	  endif
C ======================================================================
C database
C ======================================================================
 180	  if(listofseq_2 .eqv. .false.)then
C next file is always the first on the stack
 	     ifile=file_buffer(1)
C now the real work starts
	     if(ifile .gt. 0)then
c            write(logstring,'(a,i8,i4)')'work on file:',idproc,
c     +                       file_buffer(1)
c	        call log_file(klog,logstring,1)
 
		call open_sw_data_file(kbase,lbinary,ifile,
     +                             split_db_data,split_db_path,hostname)
		if(lwarm_start .eqv. .false.)ipoint=1
 
		if(lbinary .eqv. .true.)then
		   read(kbase)ibuf_poi,iseq
		else
		   read(kbase,'(i10,i10)')ibuf_poi,iseq
		endif
		if(ipoint + ibuf_poi .lt. maxdatabase_buffer)then
		   if(lbinary .eqv. .true.)then
		     read(kbase)
     +             (cdatabase_buffer(i),i=ipoint,ipoint+ibuf_poi-1)
		   else
		     read(kbase,'(a)')
     +              (cdatabase_buffer(i),i=ipoint,ipoint+ibuf_poi-1)
		   endif
		   close(kbase)
 
 
		   do k=1,iseq
		      do ipos=1,nbuffer_len
			 cbuffer_line(ipos:ipos)=
     +                  cdatabase_buffer(ipoint)
			 ipoint=ipoint+1
		      enddo
		      read(cbuffer_line(1:),111)n2in,name_2,
     +                    ACCESSION_2,pdbref_2,compnd_2
c		      read(cbuffer_line(1:),111)n2in,name_2,
c     +		   compnd_2,ACCESSION_2,pdbref_2
111		      format(i6,a12,a,a,a)
		      iend=n2in
		      if(n2in .gt. maxsq)iend=maxsq
		
		      do ipos=1,iend
			 csq_2(ipos:ipos)=cdatabase_buffer(ipoint)
			 ipoint=ipoint+1
		      enddo
		      if(n2in .gt. maxsq)then
			 ipoint=ipoint + (n2in-iend)
			 n2in=maxsq
		      endif
 
		      call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
c		      ialign_processed=ialign_processed+1		
		   enddo
		else
		   write(logstring,*)' ** FATAL ERROR **/n'//
     +		' database_buffer overflow increase/n'//
     +		' dimension of MAXDATABASE_BUFFER'
		   call log_file(klog,logstring,1)
		   STOP
		endif
 
		nseq_warm_start=ialign
c refresh the content of the work-queue
		nfile_queue=nfile_queue-1
		do i=1,nfile_queue
		   file_buffer(i) = file_buffer(i+1)
		enddo
c	    write(logstring,'(a,i4,i4)')'on stack:',idproc,nfile_queue
c	        call log_file(klog,logstring,1)
		if ( nfile_queue .gt. 0)then
		   if (file_buffer(nfile_queue) .lt. 0)then
		      goto 180
		   endif
		endif
		goto 100
	     endif
C=======================================================================
C list of filenames
C=======================================================================
	  else
C next file is always the first on the stack
	     filename=filename_buffer(1)
C now the real work starts
	     if(filename .ne. 'STOP')then
		name_2=filename
		call checkformat(kbase,name_2,seqformat,lerror)
		if(index(seqformat,'PROFILE') .ne. 0)lprofile_2=.true.
		if(index(seqformat,'DSSP'   ) .ne. 0)ldssp_2=.true.
		if(lprofile_2)then
c		   write(logstring,'(a,a)')'read PROFILE 2: ',name_2
c		   call log_file(klog,logstring,1)
		   call readprofile(kprof,name_2,maxsq,ntrans,trans,
     +                   ldssp_2,n2in,nchain,hsspid_2,header_2,compnd_2,
     +                   source_2,author_2,xsmin,xsmax,xmaplow,xmaphigh,
     +                   profilemetric,pdbno_2,chainid_2,csq_2_array,
     +	                 struc_2,nsurf_2,cols_2,sheetlabel_2,bp1_2,
     +	                 bp2_2,nocc_2,gapopen_2,gapelong_2,consweight_2,
     +                   simmetric_2,maxbox,nbox_2,profilebox_2)
		   do i=1,n2in
                      csq_2(i:i)=csq_2_array(i)
		   enddo
caution
C cstrstates,simorg and lsq_2 not known here
C pass simorg and set lsq_2
		   if(metricfile .ne. 'PROFILE')then
		       write(*,*)' option not possible, ask reinhard'
		       stop
		   endif
		   if(smin_answer .eq. 'PROFILE')then
                      smin=xsmin 
         smax=xsmax 
         maplow=xmaplow
	              maphigh=xmaphigh
		   else if(lprofile_2 .and. smin_answer .ne.
     +                      'PROFILE')then
	              maplow=xmaplow 
         maphigh=xmaphigh
		   endif
		   if(openweight_answer .ne. 'PROFILE')then
	              do i=1,maxsq 
         gapopen_2(i)=open_1 
         enddo
		   endif
	           if(elongweight_answer .ne. 'PROFILE')then
	              do i=1,maxsq 
         gapelong_2(i)=elong_1 
         enddo
	           endif
C reset conservation weights for sequence 2 if not wanted
	           if(.not. lconserv_2 )then
                      do i=1,maxsq 
         consweight_2(i)=1.0 
         enddo
	           endif
		   lnorm_profile=.false.
 
c	            if(lnorm_profile)then
c	              write(*,*)'CALL NORM_PROFILE '
c                      smin=0.0   ; smax=0.0
c	              maplow=0.0 ; maphigh=0.0
c	              call norm_profile(maxsq,ntrans,trans,n2in,n1,
c     +                             lsq_1,simmetric_2,profile_epsilon,
c     +                             profile_gamma,smin,smax,maplow,
c     +                             maphigh,gapopen_2,gapelong_2,sdev)
c	            else
c		   write(*,*)' call scale_profile disabled'
 
c	              write(*,'(a,4(2x,f5.2)))')'CALL SCALE_PROFILE 2',
c     +                          smin,smax,maplow,maphigh
c	              call scale_profile_metric(maxsq,ntrans,trans,
c     +                            simmetric_2,smin,smax,maplow,maphigh)
c	            endif
C not profile
		else
C all chains wanted from dssp data set
		   call checkformat(kbase,name_2,seqformat,lerror)
		   if(index(seqformat,'DSSP') .ne. 0 .or.
     +	              index(seqformat,'PROFILE-DSSP') .ne.0)then
                      ldssp_2=.true.
		   endif
 
c		   kchain=0
		   tempname=' '
		   i=index(name_2,'_!_')
		   if(i.ne.0)then
	              tempname(1:)=name_2(1:i-1)
                      ctemp(1:)=name_2(i+3:)
		   else
	              tempname(1:)=name_2(1:)
                      ctemp=' '
		   endif
		   pdbrefline=' '
		   if(ldssp_2 .eqv. .false.)then
                       call get_seq(kbase,tempname,trans,ctemp,
     +                   compnd_2,ACCESSION_2,pdbrefline,pdbno_2,n2in,
     +                   csq_2,struc_2_string,nsurf_2,ltruncated,
     +                   lerror)
C convert cresid to pdb-number and chain identifier, used in 3d
C superposition cresid from getseq is :
C "1234AB" (number, alternate residue, chain identifier)
C here skip alternate residue and append chain_id
                       do i=1,n2in 
         csq_2_array(i)=csq_2(i:i)
                          struc_2(i)=struc_2_string(i:i)
                          read(cresid(i),'(i4,1x,a)')
     +                         pdbno_2(i),chainid_2(i)
                       enddo
		   else
C all chains wanted from DSSP data set
		      k=0 
         chainremark=' '
		      i=index(tempname,'!')-1
		      if(i .gt. 0)then
			 kselect=1 
         iend=len(tempname)
			 do j=iend,i+1,-1
			    if(tempname(j:j) .eq. ',')kselect=kselect+1
			 enddo
			 write(*,*)' use ',kselect,' chain(s) ',
     +                               tempname(i:)
                           chainremark(1:)=tempname
                      else
			 call select_unique_chain(kgetseq,
     +		                       tempname,line)
			 chainremark= line(1:80)
		      endif
		      j=1
		      call getdsspforhssp(kgetseq,tempname,
     +                        maxsq,chainremark,
     +		              brkid_2,header_2,compnd_2,source_2,
     +	                      author_2,n2in,i,j,k,pdbno_2,
     +                        chainid_2,csq_2_array,struc_2,cols_2,
     +	                      bp1_2,bp2_2,sheetlabel_2,nsurf_2)
		      do i=1,n2in
			 csq_2(i:i)=csq_2_array(i)
		      enddo
		   endif
		   call select_pdb_pointer(kref,dssp_path,pdbrefline,
     +                                pdbref_2)
		endif
		call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
c refresh the content of the work-queue
		nfile_queue=nfile_queue-1
		do i=1,nfile_queue
		   filename_buffer(i) = filename_buffer(i+1)
		enddo
	
		if ( nfile_queue .gt. 0)then
		   if (filename_buffer(nfile_queue) .eq. 'STOP')then
		      goto 180
		   endif
		endif
		goto 100
	     endif
C=====================================================================
C list of filename
C=====================================================================
	  endif
	  call get_cpu_time('database scan: ',idproc,
     +                        itime_old,itime_new,total_time,logstring)
	  call log_file(klog,logstring,1)
	  write(logstring,'(a,i6,i8,i10)')'internal buffer: ',idproc,
     +                                nseq_warm_start,ipoint
	  call log_file(klog,logstring,1)
	  if(listofseq_2 .eqv. .true.)lfirst_scan=.true.
 
C=======================================================================
C warm start
C=======================================================================
	else
	  do i=1,nseq_warm_start
             do ipos=1,nbuffer_len
                cbuffer_line(ipos:ipos)=cdatabase_buffer(ipoint)
                ipoint=ipoint+1
             enddo
             read(cbuffer_line(1:),111)n2in,name_2,
     +             compnd_2,ACCESSION_2,pdbref_2
	     iend=n2in
	     if(n2in .gt. maxsq)iend=maxsq
	
	     do ipos=1,iend
		csq_2(ipos:ipos)=cdatabase_buffer(ipoint)
		ipoint=ipoint+1
	     enddo
	     if(n2in .gt. maxsq)then
		ipoint=ipoint + (n2in-iend)
		n2in=maxsq
	     endif
	     call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
	  enddo
c	  ialign_processed=nseq_warm_start
	  call get_cpu_time('database scan warm start: ',idproc,
     +                        itime_old,itime_new,total_time,logstring)
	  call log_file(klog,logstring,1)
C=====================================================================
C end warm-start
C=======================================================================
	endif
C=====================================================================
C send results to host
c	write (logstring,'(a,i4)')'got end signal: ',idproc
c	call log_file(klog,logstring,1)
 
	msgtype=4000
	call mp_init_send()
	call mp_put_int4(msgtype,id_host,ialign,N_one)
	call mp_put_int4(msgtype,id_host,ialign_good,N_one)
	call mp_send_data(msgtype,link(id_host))
   	if(ialign .gt. 0)then
	   msgtype=5000
	   call mp_init_send()
	   call mp_put_real4_array(msgtype,id_host,alisortkey,ialign)
	   call mp_put_int4_array(msgtype,id_host,irecpoi,ialign)
	   call mp_put_int4_array(msgtype,id_host,ifilepoi,ialign)
	   call mp_send_data(msgtype,link(id_host))
 
	   write (logstring,'(a,i6,2x,i6)')
     +	   'send result OK: ',idproc,ialign
	   call log_file(klog,logstring,1)
	else
	   write (logstring,'(a,i6)')'nothing found: ',idproc
	   call log_file(klog,logstring,1)
	endif
C on a mixed architecture cluster wait for request from host for
C the alignment data and send them
c	if(lmixed_arch )then
	  ilen_name=len(name_2)    
         ilen_compnd=len(compnd_2)
	  ilen_ACCESSION=len(ACCESSION_2) 
         ilen_pdbref=len(pdbref_2)
	  ilen_al=len(al_2) 
         ilen_insseq=len(insseq)
 
200	  msgtype=6000
 
	  call mp_receive_data(msgtype,link(id_host))
	  call mp_get_int4(msgtype,id_host,irecord,N_one)
	  call mp_get_int4(msgtype,id_host,imsgtag,N_one)
	  call mp_get_real4(msgtype,id_host,checkval,N_one)
c	  write (*,*)' request: ',idproc,irecord ; call flush_unit(6)
	  if(irecord .le. 0)goto 300
	  call getalign(kcore,irecord,ifir,len1,lenocc,jfir,jlas,
     +                  idel,ndel,value,rms,hom,
     +                  sim,sdev,distance,checkval)
 
 
	  ilconsider=0 
         ildssp_2=0
          if( lconsider )ilconsider=1 
         if( ldssp_2 )ildssp_2=1
 
	  msgtype=imsgtag
	  call mp_init_send()
	  call mp_put_int4(msgtype,id_host,ilconsider,N_one)
	  call mp_put_int4(msgtype,id_host,ildssp_2,N_one)
	  call mp_put_string(msgtype,id_host,name_2,ilen_name)
	  call mp_put_string(msgtype,id_host,compnd_2,ilen_compnd)
	  call mp_put_string(msgtype,id_host,ACCESSION_2,ilen_ACCESSION)
	  call mp_put_string(msgtype,id_host,pdbref_2,ilen_pdbref)
	  call mp_put_real4(msgtype,id_host,value,N_one)
	  call mp_put_int4(msgtype,id_host,ifir,N_one)
	  call mp_put_int4(msgtype,id_host,len1,N_one)
	  call mp_put_int4(msgtype,id_host,lenocc,N_one)
	  call mp_put_int4(msgtype,id_host,jfir,N_one)
	  call mp_put_int4(msgtype,id_host,jlas,N_one)
	  call mp_put_int4(msgtype,id_host,n2in,N_one)
	  call mp_put_int4(msgtype,id_host,idel,N_one)
	  call mp_put_int4(msgtype,id_host,ndel,N_one)
	  call mp_put_int4(msgtype,id_host,nshifted,N_one)
	  call mp_put_real4(msgtype,id_host,rms,N_one)
	  call mp_put_real4(msgtype,id_host,hom,N_one)
	  call mp_put_real4(msgtype,id_host,sim,N_one)
	  call mp_put_real4(msgtype,id_host,sdev,N_one)
	  call mp_put_real4(msgtype,id_host,distance,N_one)
c	  call mp_put_string(msgtype,id_host,al_1,ilen_al)
	  call mp_put_string(msgtype,id_host,al_2,ilen_al)
	  call mp_put_string(msgtype,id_host,sal_2,ilen_al)
	  call mp_put_int4(msgtype,id_host,iins,N_one)
	  if(iins .gt. 0)then
	    call mp_put_int4_array(msgtype,id_host,inslen_local,iins)
	    call mp_put_int4_array(msgtype,id_host,insbeg_1_local,iins)
	    call mp_put_int4_array(msgtype,id_host,insbeg_2_local,iins)
	    call mp_put_string(msgtype,id_host,insseq,ilen_insseq)
	  endif
	  call mp_send_data(msgtype,link(id_host))
c	  write (*,*)' request send: ',idproc ; call flush_unit(6)
 
	  goto 200
c	endif
300	close(kcore)
c	if(lmixed_arch )then
	call del_oldfile(kcore,coretemp)
c	endif
 
	if ( (l3way .eqv. .true. ) .and.
     +       (l3waydone .eqv. .false.) )then
	   l3waydone=.true.
	   write(*,*)' second scan; go back to start:', idproc
	   goto 10
	endif
 
	if(lwarm_start)then
	   write(*,*)' warm-start; go back to start:', idproc
	   goto 10
	endif
900	call get_cpu_time('time finish: ',idproc,
     +                        itime_old,itime_new,total_time,logstring)
	call log_file(klog,logstring,1)
	return
	end
C END NODE_INTERFACE....................................................
 
C SUBROUTINE REPORT_TIME...............................................
c	subroutine report_time(klog,maxstep,text,idproc,itime,istep,
c     +                         total_time)
C import
c	integer klog,maxstep,idproc,itime(0:maxstep,*),istep
c	real total_time
c	character*(*) text(*)
C internal
c	character*200 logstring
c	integer i
c	real xtime1,xtime2,xtime3
c	real one_sec
c	parameter (one_sec=1000000.0)
c	write(logstring,*)' timing: '
c	call log_file(klog,logstring,2)
c	do i=1,istep
c	  xtime1= float(itime(i,1)) / one_sec
c	  xtime2= float(itime(i,2)) / one_sec
c	  xtime3= float(itime(i,3)) / one_sec
c
c	  write(logstring,'(a,i6,3(f10.2))')text(i),idproc,
c     +                    xtime1,xtime2,xtime3
c	  call log_file(klog,logstring,2)
c	enddo
c	write(logstring,*)' total: ',total_time
c	call log_file(klog,logstring,2)
c	return
c	end
C END REPORT_TIME.......................................................
 
C============================================
C maxhom host working interface for PVM3
	subroutine host_interface(lh1,lh2,ifile,filename,ialign,
     +                            nrecord,ipoint)
 
	implicit none
	include 'maxhom.param'
	include 'maxhom.common'
c import
	character*(*) filename
	real      lh1(0:maxmat)
	integer*2 lh2(0:maxtrace)
 
c	real lh(0:maxmat*2)
	integer ipoint
c internal
C local for each node
	real    sdev
	integer nrecord,ialign,ifile,iseq,k
c	logical lendbase
	integer ipos,i,ibuf_poi,iend
C init
	nbuffer_len = 6 + 12 + len(compnd_2) +
     +                len(ACCESSION_2) + len(pdbref_2)
 
c	nbuffer_len = 6 + len(name_2) + len(compnd_2) +
c     +                len(ACCESSION_2) + len(pdbref_2)
	sdev=0.0
 
 111	format(i6,a12,a,a,a)
	if(lfirst_scan .eqv. .true.)then
	   call open_sw_data_file(kbase,lbinary,ifile,split_db_data,
     +                            split_db_path,hostname)
 
	   if(lwarm_start .eqv. .false.)ipoint=1
	   if(lbinary .eqv. .true.)then
	      read(kbase)ibuf_poi,iseq
	   else
	      read(kbase,'(i10,i10)')ibuf_poi,iseq
	   endif
	   if(ipoint + ibuf_poi .lt. maxdatabase_buffer)then
	      if(lbinary .eqv. .true.)then
		 read(kbase)
     +           (cdatabase_buffer(i),i=ipoint,ipoint+ibuf_poi-1)
	      else
		 read(kbase,'(a)')
     +         (cdatabase_buffer(i),i=ipoint,ipoint+ibuf_poi-1)
	      endif
	      close(kbase)
	      do k=1,iseq
		 do ipos=1,nbuffer_len
		    cbuffer_line(ipos:ipos)=cdatabase_buffer(ipoint)
		    ipoint=ipoint+1
		 enddo
		 read(cbuffer_line(1:),111)n2in,name_2,
     +	      ACCESSION_2,pdbref_2,compnd_2
c		 read(cbuffer_line(1:),111)n2in,name_2,
c     +	      compnd_2,ACCESSION_2,pdbref_2
 
		 iend=n2in
		 if(n2in .gt. maxsq)iend=maxsq
 
		 do ipos=1,iend
		    csq_2(ipos:ipos)=cdatabase_buffer(ipoint)
		    ipoint=ipoint+1
		 enddo
		 if(n2in .gt. maxsq)then
		    ipoint=ipoint + (n2in-iend)
		    n2in=maxsq
		 endif
		 call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
		 nseq_warm_start=nseq_warm_start+1
	      enddo
	   else
	      write(logstring,*)' ** FATAL ERROR **/n'//
     +	   ' database_buffer overflow increase/n'//
     +	   ' dimension of MAXDATABASE_BUFFER'
	      call log_file(klog,logstring,1)
	      STOP
	   endif
 
c	   lendbase=.false.
c	   do while(.not. lendbase)
c	     call get_swiss_entry(maxsq,kbase,lbinary,n2in,name_2,
c     +	              compnd_2,ACCESSION_2,pdbref_2,csq_2,lendbase)
c	     if(.not. lendbase)then
c               if (lwarm_start) then
c                  if( (ipoint + nbuffer_len + n2in) .gt.
c     +                 maxdatabase_buffer)then
c                    write(*,*)' **** FATAL ERROR ****'
c                    write(*,*)' database_buffer overflow increase'
c                    write(*,*)' dimension of MAXDATABASE_BUFFER'
c                    STOP
c                  endif
c                  write(cbuffer_line(1:),'(i6,a,a,a,a)')n2in,name_2,
c     +                  compnd_2,ACCESSION_2,pdbref_2
c                  do ipos=1,nbuffer_len
c                     cdatabase_buffer(ipoint)=cbuffer_line(ipos:ipos)
c                     ipoint=ipoint+1
c                  enddo
c                  do ipos=1,n2in
c                     cdatabase_buffer(ipoint)=csq_2(ipos:ipos)
c                     ipoint=ipoint+1
c		  enddo
c               endif
c	       call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
c	       nseq_warm_start=nseq_warm_start+1
c	     endif
c	  enddo
c	  close(kbase)
	else
	   write(*,*)' host warm-start: ',nseq_warm_start
	  do i=1,nseq_warm_start
             do ipos=1,nbuffer_len
                cbuffer_line(ipos:ipos)=cdatabase_buffer(ipoint)
                ipoint=ipoint+1
             enddo
c	     write(*,*)cbuffer_line,ipoint
             read(cbuffer_line(1:),111)n2in,name_2,
     +             compnd_2,ACCESSION_2,pdbref_2
 
	     iend=n2in
	     if(n2in .gt. maxsq)iend=maxsq
	
	     do ipos=1,iend
		csq_2(ipos:ipos)=cdatabase_buffer(ipoint)
		ipoint=ipoint+1
	     enddo
	     if(n2in .gt. maxsq)then
		ipoint=ipoint + (n2in-iend)
		n2in=maxsq
	     endif
	     call do_align(lh1,lh2,idproc,ialign,nrecord,sdev)
	  enddo
	endif
 
	return
	end
C END HOST_INTERFACE....................................................

C---- ------------------------------------------------------------------
C---- contains now all previously needed libraries for Schneider stuff
C---- ------------------------------------------------------------------
C this library contains subroutines which are system specific things, 
C like get the actual date, time, open a file etc.
C ===> have one system-lib.for for VMS, UNIX is nix (SGI/PARIX).... machines
C      and link them.

C======================================================================
C......................................................................
C     SUB GETDATE
C     returns date in a string of implied length
C     UNIX version
      SUBROUTINE GETDATE(DATE)
      CHARACTER*(*) DATE
      CHARACTER CTEMP*24
      CHARACTER DAY*2, MONTH*3, YEAR*2
      
      DATE=' '
      CTEMP=' '
      CALL FDATE(CTEMP)
      MONTH = CTEMP(5:7)
      DAY = CTEMP(9:10)
      YEAR = CTEMP(23:24)
      DATE = (((DAY // '-') // MONTH) // '-') // YEAR
      RETURN 
      END
C     END GETDATE
C......................................................................

C......................................................................
C     SUB GETTIME(CTIME)
      SUBROUTINE GETTIME(CTIME)
c     returns time in a string of implied length
      CHARACTER CTIME*(*)
      CHARACTER*24 CTEMP
      CTEMP = ' '
      CALL FDATE(CTEMP)
      CTIME(1:)=CTEMP(11:22)

      RETURN
      END
C     END GETTIME(CTIME)
C......................................................................

C......................................................................
C     SUB GET_CURRENT_DIR
C     returns path name of the current directory
C     SGI/UNIX version
      SUBROUTINE GET_CURRENT_DIR(DIR_NAME)
      CHARACTER*(*) DIR_NAME
      INTEGER ILEN
      CHARACTER*128 TEMP_NAME
      
      TEMP_NAME=' '
C     CALL GETCWD(TEMP_NAME)
      DIR_NAME=' '
      ILEN=LEN(DIR_NAME)
      IEND=MIN(128,ILEN)
      DIR_NAME=TEMP_NAME(1:IEND)
      RETURN 
      END
C     END GET_CURRENT_DIR
C......................................................................

C......................................................................
C     SUB GET_ENVIROMENT_VARIBALE
C     RETURNS VALUE OF ENVIROMENT VARIABLE
C     UNIX version
      SUBROUTINE GET_ENVIROMENT_VARIABLE(ENV_VAR,VARIABLE)
      CHARACTER*(*) ENV_VAR,VARIABLE
      
      VARIABLE=' '
      CALL STRPOS(ENV_VAR,IBEG,IEND)
      CALL GETENV(ENV_VAR(IBEG:IEND),VARIABLE)
      RETURN 
      END
C END GET_ENVIROMENT_VARIABLE
C......................................................................

C......................................................................
C     SUB GET_MACHINE_NAME
c     returns current machine name
c     UNIX version
      SUBROUTINE GET_MACHINE_NAME(MACHINE_NAME)
      CHARACTER*(*) MACHINE_NAME
      INTEGER HOSTNM,ITEST
      
      ITEST=0
      MACHINE_NAME=' '
      ITEST=HOSTNM(MACHINE_NAME)
      IF (ITEST .NE. 0) THEN
         WRITE(*,*)' hostnm failed !!'
         WRITE(*,*)' error code is: ',itest
      ENDIF
      RETURN 
      END
C     END GET_MACHINE_NAME
C......................................................................

C......................................................................
C     SUB GET_ARG_NUMBER  
C     returns number of arguments
C     UNIX version
      SUBROUTINE GET_ARG_NUMBER(INUMBER)
      INTEGER INUMBER

      INUMBER=0
      INUMBER=IARGC()
      RETURN 
      END
C     END GET_ARG_NUMBER
C......................................................................

C......................................................................
C     SUB GET_ARGUMENT  
C     returns the content of x-th argument
C     UNIX version
      SUBROUTINE GET_ARGUMENT(INUMBER,ARGUMENT)
      CHARACTER*(*) ARGUMENT
      INTEGER INUMBER

      CALL GETARG(INUMBER,ARGUMENT)
      RETURN 
      END
C     END GET_ARGUMENT
C......................................................................

C......................................................................
C lkajan 20110618: chmod_ is not present in earlier libgfortran so this fails to link, however this sub is not used anywhere - commenting all out
CC     SUB CHANGE_MODE
C      SUBROUTINE CHANGE_MODE(FILENAME,MODE,IRETURN_VAL)
Cc     changes the mode of a file via the integer function "chmod"
Cc import
C      CHARACTER*(*) FILENAME,MODE
Cc export
C      INTEGER IRETURN_VAL
Cc internal
C      INTEGER CHMOD
C
C      CALL STRPOS(FILENAME,IBEG,IEND)
C      CALL STRPOS(MODE,JBEG,JEND)
C      IRETURN_VAL=CHMOD(FILENAME(IBEG:IEND),MODE(JBEG:JEND))
C      IF (IRETURN_VAL .NE. 0) THEN
C         WRITE(*,*)' *** ERROR IN CHANGE_MODE:***'
C         WRITE(*,*)'     MODE CHANGE NOT PERFORMED !'
C         WRITE(*,*)'     MODE: ',MODE(JBEG:JEND)
C         WRITE(*,*)'     FILE: ',FILENAME(IBEG:IEND)
C      ENDIF
C      RETURN
C      END
CC     END CHANGE_MODE
C......................................................................

C......................................................................
C     SUB GET_CPU_TIME
C     get elapsed CPU time between two calls of GET_CPU_TIME
C     total_time  = elapsed CPU time
C     user_time   =  used user CPU time
C     system_time = used system CPU time
      SUBROUTINE GET_CPU_TIME(CSTRING,IDPROC,ITIME_OLD,
     +     ITIME_NEW,TOTAL_TIME,LOGSTRING)
C import export
      CHARACTER CSTRING*(*)
      CHARACTER LOGSTRING*(*)
      INTEGER IDPROC
      INTEGER ITIME_OLD(*),ITIME_NEW(*)
      REAL TOTAL_TIME
C internal
      INTEGER IBEG,IEND
      REAL XTIME(2),TOTAL

      XTIME(1)=0.0
      XTIME(2)=0.0

      TOTAL  = DTIME(XTIME)
      TOTAL_TIME = TOTAL_TIME + TOTAL

      CALL STRPOS(CSTRING,IBEG,IEND)
      WRITE(LOGSTRING,'(A,I6,4(F10.2))')CSTRING(IBEG:IEND),
     +     IDPROC,TOTAL,XTIME(1),XTIME(2),TOTAL_TIME

      RETURN
      END
C     END GET_CPU_TIME
C......................................................................

C......................................................................
C     SUB INIT_CPU_TIME
      SUBROUTINE INIT_CPU_TIME(ITIME_OLD)
C import export
      INTEGER ITIME_OLD(*)
C internal
      REAL XTIME(2),TOTAL
      
      XTIME(1)=0.0
      XTIME(2)=0.0

      TOTAL  = DTIME(XTIME)
	
      RETURN
      END
C     END INIT_CPU_TIME
C......................................................................

C......................................................................
C     SUBROUTINE GET_CPU_TIME
C     get elapsed CPU time between two calls of GET_CPU_TIME
C     total_time  = elapsed CPU time
C     user_time   =  used user CPU time
C     system_time = used system CPU time
c     subroutine get_cpu_time(total_time,user_time,system_time)
C export
c	real total_time, user_time,system_time
C internal
c	real xtime(2)

c	xtime(1)=0.0
c	xtime(2)=0.0

c	total_time  = dtime(xtime)
c	user_time   = xtime(1)
c	system_time = xtime(2)
c	write(*,*)'   total    user  system'
c	write(*,'(3(1x,f7.2))')total_time,user_time,system_time

c	return
c	end
C     END GET_CPU_TIME
C......................................................................


C......................................................................
C     SUB OPEN_FILE
      SUBROUTINE OPEN_FILE(IUNIT,INNAME,CSTRING,LERROR)
C     IMPLICIT NONE
C INPUT
C CSTATUS: 'OLD' OR 'NEW' OR 'UNKNOWN'
C CACCESS:  'APPEND' 'DIRECT'
C FORM:     'FORMATTED' OR 'UNFORMATTED'
C IRECLEN: RECORD LENGTH
C NOTE: AFTER OPENING A "OLD" OR "UNKNOWN" FILE (NO DIRECT ACESS): 
C       REWIND THE FILE, BECAUSE SOME STRANGE COMPILERS PUT THE FILE 
C       POINTER AT THE END !
C
      CHARACTER*(*) INNAME,CSTRING
      INTEGER IUNIT,IRECLEN
c output: lerror is true if open error
      LOGICAL LERROR
c internal
      CHARACTER*200 TEMPSTRING,CTEMP,FILENAME
      CHARACTER*10 CNUMBER
      LOGICAL LNEW,LAPPEND,LUNKNOWN
      LOGICAL LUNFORMATTED,LDIRECT
      LOGICAL LOPENDONE,LSILENT
      INTEGER LENGTH,I,J,K
c init
      TEMPSTRING=' '
      FILENAME=' '
      LNEW=.FALSE.
      LAPPEND=.FALSE.
      LERROR=.FALSE.
      LUNKNOWN=.FALSE.
      LUNFORMATTED=.FALSE.
      LDIRECT=.FALSE.
      LOPENDONE=.FALSE.
      LSILENT=.FALSE.
      IRECLEN=137
      TEMPSTRING(1:)=CSTRING(1:)
      CNUMBER='0123456789'
c
      LENGTH=LEN(TEMPSTRING)
      CALL LOWTOUP(TEMPSTRING,LENGTH)
      IF (INDEX(TEMPSTRING,'NEW').NE.0) THEN
         LNEW=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'UNKNOWN').NE.0) THEN
         LUNKNOWN=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'UNFORMATTED').NE.0) THEN
         LUNFORMATTED=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'DIRECT').NE.0) THEN
         LDIRECT=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'APPEND').NE.0) THEN
         LAPPEND=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'SILENT').NE.0) THEN
         LSILENT=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'RECL=').NE.0) THEN
         CTEMP=' '
         K=INDEX(TEMPSTRING,'RECL=')+5
         CTEMP(1:)=TEMPSTRING(K:)
         CALL STRPOS(CTEMP,I,J)
         J=I
         DO WHILE (INDEX(CNUMBER,CTEMP(J:J)).NE.0 )
            J=J+1
         ENDDO
         J=J-1
         CALL READ_INT_FROM_STRING(CTEMP(I:J),IRECLEN)
      ENDIF

      CALL STRPOS(INNAME,IBEG,IEND)
      FILENAME(1:)=INNAME(IBEG:IEND)

      IF (LNEW) THEN
         CALL DEL_OLDFILE(IUNIT,FILENAME)
      ENDIF
      IF (LNEW .AND. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW .AND. LUNFORMATTED ) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
     +        ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW .AND. (.NOT. LUNFORMATTED) .AND. LDIRECT ) THEN
         OPEN(IUNIT,FILE=FILENAME,ACCESS='DIRECT',STATUS='NEW',
     +        FORM='FORMATTED',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,ACCESS='DIRECT',STATUS='NEW',
C     +         FORM='FORMATTED',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. .NOT. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='FORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='FORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LUNFORMATTED ) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
     +        ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW')
         REWIND(IUNIT)                         
         LOPENDONE=.TRUE.
      ELSEIF (LUNKNOWN .AND. LAPPEND) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ACCESS='APPEND',
     +        ERR=999)
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ACCESS='APPEND')
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN')
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LAPPEND) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ACCESS='APPEND',ERR=999)
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ACCESS='APPEND')
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSE
         OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ENDIF
      IF (.NOT. LOPENDONE) THEN
         WRITE(*,*)' ERROR IN OPEN_FILE: FILE NOT OPENED'
         WRITE(*,*)'  unknown specifier combination !'
         STOP
      ENDIF
      RETURN
 999  IF (.NOT. LSILENT) THEN
         WRITE(*,*)' ERROR: open file error for file: '
         WRITE(*,*)'name: ',FILENAME
         WRITE(*,*)'unit: ',iunit
      ENDIF
      LERROR=.TRUE.
      RETURN
      END
C     END OPEN_FILE
C......................................................................

C......................................................................
C     SUB CLOSE_FILE
      SUBROUTINE CLOSE_FILE(IUNIT,FILENAME)
      INTEGER IUNIT
      CHARACTER*(*) FILENAME
      LOGICAL LOPEN
      
      INQUIRE(FILE=FILENAME,OPENED=LOPEN)
      IF (LOPEN) THEN
         CLOSE(IUNIT)
      ENDIF
      RETURN
      END
C     END CLOSE_FILE
C......................................................................

C......................................................................
C     SUBR DEL_OLDFILE
      SUBROUTINE DEL_OLDFILE(IUNIT,FILENAME)
      CHARACTER*(*) FILENAME
      INTEGER IUNIT
      LOGICAL LEXIST,LOPEN
      INTEGER IBEG,IEND
      CHARACTER*100 TEMPNAME
      
      TEMPNAME=' '
      CALL STRPOS(FILENAME,IBEG,IEND)
      TEMPNAME(1:)=FILENAME(IBEG:IEND)
      INQUIRE(FILE=TEMPNAME,OPENED=LOPEN)
      IF (LOPEN) THEN
         CLOSE(IUNIT)
      ENDIF
      INQUIRE(FILE=TEMPNAME,EXIST=LEXIST)
      IF (LEXIST) THEN
         OPEN(IUNIT,FILE=TEMPNAME,STATUS='OLD')
         CLOSE(IUNIT,STATUS='DELETE')
      ENDIF
      RETURN
      END
C     END DEL_OLDFILE
C......................................................................

C......................................................................
C     SUB FLUSH
      SUBROUTINE FLUSH_UNIT(IUNIT)
      INTEGER IUNIT
      
      CALL FLUSH(IUNIT)
      
      RETURN
      END
C     END FLUSH
C......................................................................

C......................................................................
C     SUB C_PARIOINIT
      SUBROUTINE C_PARIOINIT(INODE,ILINK,HOSTNAME,ILEN)
      INTEGER INODE,ILEN,ILINK(*)
      CHARACTER*(*) HOSTNAME
      
      HOSTNAME=' '
      
      RETURN
      END
C     END C_PARIOINIT
C......................................................................

*----------------------------------------------------------------------*
*                                                                      *
*     FORTRAN code for program CONVERT_SEQ                             *
*             conversion of sequence and alignment formats             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Authors:                                                         *
*                                                                      *
*     Reinhard Schneider        Mar,        1991      version 1.0      *
*     Ulrike Goebel             Mar,        1997      version 1.1      *
*     Reinhard Schneider        Mar,        1997      version 2.0      *
*     LION			http://www.lion-ag/                    *
*     D-69120 Heidelberg	schneider@lion-ag.de                   *
*                                                                      *
*     Burkhard Rost		May,        1998      version 2.1      *
*                   		Oct,        1998      version 2.2      *
*                                                                      *
*     EMBL/LION			http://www.embl-heidelberg.de/~rost/   *
*     D-69012 Heidelberg	rost@embl-heidelberg.de                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     General note:   - uses library lib-maxhom.f                      *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*

      PROGRAM CONVERT_SEQ

      IMPLICIT        NONE
C----
C---- parameters
C----
      INTEGER         MAXRES,MAXCHAIN,MAXINS,MAXINSBUF,IN,OUT,
     +                CODELEN,MAXALIGNS,MAXCORE,MAXAA,MAX_NAME_LEN
      PARAMETER      (MAXRES=                 9999)
C      PARAMETER      (MAXRES=                30011)
      PARAMETER      (MAXALIGNS=             8765)
C      PARAMETER      (MAXALIGNS=             19999)
C      PARAMETER      (MAXINS=                50000)
C      PARAMETER      (MAXINSBUF=            200000)
      PARAMETER      (MAXINS=               100000)
      PARAMETER      (MAXINSBUF=           1000000)
      PARAMETER      (MAXCORE=            30303030)
C      PARAMETER      (MAXCORE=             3213213)
C      PARAMETER      (MAXCORE=             2888888)
      PARAMETER      (MAXCHAIN=                 50)
      PARAMETER      (CODELEN=                  40)
      PARAMETER      (MAXAA=                    20)
      PARAMETER      (MAX_NAME_LEN=           1024)
C     only used to get rid of INDEX command (CPU time)
      INTEGER         NASCII
      PARAMETER      (NASCII=                  256)
C     files
      PARAMETER      (IN=                       12)
      PARAMETER      (OUT=                      14)
 
C---- br 2003-08: switch for new (1999) HSSP curve
      LOGICAL         LNEWCURVE
      PARAMETER      (LNEWCURVE=            .TRUE.)
C      PARAMETER      (LNEWCURVE=           .FALSE.)


      INTEGER         ISTART,ISTOP,NBLOCKS,NSYMBOLS,NBREAKS,NREAD,
     +                IALIGN, CHANGEPOS,NCHAIN,KCHAIN,NRES,CALLS,
     +                NTRIALS,NRESTMP
      INTEGER         RANGE(2),CHBPOS(MAXCHAIN-1)

      CHARACTER*1     C,CGAPCHAR,CGAPCHARPIR
      CHARACTER*(4*MAXCHAIN)   CCHAIN
      CHARACTER*(MAXRES) SEQ,  STRUC
      CHARACTER*(MAX_NAME_LEN) FILENAME,BASENAME,OUTNAME,TEMPNAME,
     +                VARMETRIC
      CHARACTER*130   QUESTION
      CHARACTER       ACCNUM*80,PDBREF*10,TRANS*26,INFORMAT*4,
     +                OUTFORMAT*1
      LOGICAL         LFILTER,LINSERT,LDELETE,LDOEXP, LDOCLIP,
     +                TRUNCATED, ERROR,MULTFORMAT, DO_INIT_INSBUF
C MSFTOSEQ
C     pointer arrays: ifir(i) begin of PDBSEQ against alignment i
      INTEGER         IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +                ALIPOINTER(MAXALIGNS),
     +                NALIGN, ALILEN,MSFCHECK,SEQCHECK(MAXALIGNS)
      CHARACTER*(CODELEN) PDBNAME
      CHARACTER       ALISEQ(MAXCORE)
      CHARACTER*1     TYPE
      REAL            WEIGHT(MAXALIGNS)
C READHSSP
      LOGICAL         LCONSERV,LOLDVERSION,LHSSP_LONG_ID
C attributes of sequence with known structure
      CHARACTER       PDBSEQ(MAXRES),CHAINID(MAXRES),
     +                SECSTR_HSSP(MAXRES),SHEETLABEL(MAXRES)
      CHARACTER*7     COLS(MAXRES)
      CHARACTER*12    PDBID
      CHARACTER*40    HEADER
      CHARACTER*400   COMPND,SOURCE,AUTHOR,CHAINREMARK
      INTEGER         PDBNO(MAXRES),BP1(MAXRES),BP2(MAXRES),ACC(MAXRES)
C attributes of aligned sequences

C     flags (take ' ', else other)
      CHARACTER       EXCLUDEFLAG(MAXALIGNS)
      CHARACTER*5     STRID(MAXALIGNS)
      CHARACTER*10    ACCNUM_HSSP(MAXALIGNS)
      CHARACTER*40    EMBLID(MAXALIGNS)
      CHARACTER*60    PROTNAME(MAXALIGNS)
      INTEGER         JFIR(MAXALIGNS),JLAS(MAXALIGNS),LALI(MAXALIGNS),
     +                NGAP(MAXALIGNS),LGAP(MAXALIGNS),LENSEQ(MAXALIGNS),
     +                INSNUMBER,INSALI(MAXINS),INSPOINTER(MAXINS),
     +                INSLEN(MAXINS),INSBEG_1(MAXINS),INSBEG_2(MAXINS)
      REAL            IDE(MAXALIGNS),SIM(MAXALIGNS)
      CHARACTER       INSBUFFER(MAXINSBUF)
C attributes of profile
      INTEGER         VAR(MAXRES),SEQPROF(MAXRES,MAXAA),NOCC(MAXRES),
     +                NDEL(MAXRES),NINS(MAXRES),RELENT(MAXRES)
      REAL            ENTROPY(MAXRES)
      REAL            CONSWEIGHT(MAXRES),CONSWEIGHT_MIN
C threshold  
      INTEGER         I
C----
C----
C---- end of settings
C---- ------------------------------------------------------------------
C----
C---- ------------------------------------------------------------------
C     initialisation
      NTRIALS=       0
      CALLS=         1
      CGAPCHAR=      '.'
      CGAPCHARPIR=   '-'
      OUTNAME=       ' '
      LCONSERV=      .FALSE.
      LOLDVERSION=   .FALSE.
      LHSSP_LONG_ID= .FALSE.
      VARMETRIC=     '/home/rost/pub/max/mat/Maxhom_GCG.metric'
      DO_INIT_INSBUF=.TRUE.
      TRANS=         'VLIMFWYGAPSTCHRKQENDBZX!-'
      TEMPNAME=      ' '
      INSNUMBER=     0

      CONSWEIGHT_MIN=0.01

C-----------------------------------------------------------------------
c        tempname = '/data/hssp/1acx.hssp'
 1    CALL GETCHAR(MAX_NAME_LEN, TEMPNAME, 
     +     ' Name of input sequence file :')
C-----------------------------------------------------------------------
      CALL EXTRACT_CHAINS(TEMPNAME,FILENAME,MAXCHAIN,CCHAIN)
      CALL CHECKFORMAT(IN,FILENAME,INFORMAT,ERROR)
      IF ( ERROR ) THEN
         IF ( NTRIALS .LT. 3 ) THEN
            NTRIALS = NTRIALS + 1
            GOTO 1
         ELSE
            STOP 'NO VALID SEQUENCE FILE GIVEN ! '
         ENDIF
      ENDIF
      CALL GETPIDCODE(FILENAME,BASENAME)

C-----------------------------------------------------------------------
c...read sequence(s)
 
      MULTFORMAT = .FALSE.
      CALL STRPOS(INFORMAT,ISTART,ISTOP)
      IF ( INFORMAT(ISTART:ISTOP) .EQ. 'HSSP' ) THEN
         MULTFORMAT = .TRUE.
         CALL READHSSP(IN,FILENAME,ERROR,MAXRES,MAXALIGNS,
     +        MAXCORE,MAXINS,MAXINSBUF,PDBID,HEADER,COMPND,
     +        SOURCE,AUTHOR,ALILEN,NCHAIN,KCHAIN,CHAINREMARK,
     +        NALIGN,EXCLUDEFLAG,EMBLID,STRID,IDE,SIM,IFIR,
     +        ILAS,JFIR,JLAS,LALI,NGAP,LGAP,LENSEQ,ACCNUM_HSSP,
     +        PROTNAME,PDBNO,PDBSEQ,CHAINID,SECSTR_HSSP,
     +        COLS,SHEETLABEL,BP1,BP2,ACC,NOCC,VAR,ALISEQ,
     +        ALIPOINTER,SEQPROF,NDEL,NINS,ENTROPY,RELENT,
     +        CONSWEIGHT,INSNUMBER,INSALI,INSPOINTER,INSLEN,
     +        INSBEG_1,INSBEG_2,INSBUFFER,LCONSERV,
     +        LHSSP_LONG_ID)
         IF (ERROR) THEN
            WRITE(6,*)' *** ERROR reading HSSP-file:',FILENAME
            STOP '*** ERROR reading HSSP-file'
            GOTO 1
         ENDIF
         ALILEN = ALILEN + KCHAIN - 1
         CALL MARK_DUPLICATES(EMBLID,NALIGN)

      ELSE IF ( INFORMAT(ISTART:ISTOP) .EQ. 'MSF' ) THEN
         MULTFORMAT = .TRUE.
         CALL READ_MSF(IN,FILENAME,MAXALIGNS,MAXCORE,ALISEQ,
     1        ALIPOINTER,IFIR,ILAS,JFIR,JLAS,TYPE,EMBLID,
     2        WEIGHT,SEQCHECK,MSFCHECK,ALILEN,NALIGN,ERROR)
         IF (ERROR) THEN
            WRITE(*,*)'*** ERROR READING MSF-FILE:',FILENAME
            GOTO 1
            STOP '*** ERROR reading MSF-file'
         ENDIF
      ELSE
         SEQ = ' '
         CALL GET_SEQ(IN,FILENAME,TRANS,CCHAIN,
     +        COMPND,ACCNUM,PDBREF,PDBNO,NRES,SEQ,
     +        STRUC,ACC,TRUNCATED,ERROR)
         IF ( ERROR ) THEN
            WRITE(6,*)'*** ERROR in GET_SEQ for file=',FILENAME
            STOP
         ENDIF
      ENDIF
C--------------------------------------------------------------------

      RANGE(1) = 1
      IF ( MULTFORMAT ) THEN
         RANGE(2) = ALILEN
      ELSE
         RANGE(2) = NRES
         CALL CHAINBREAKPOS( SEQ,RANGE(1),RANGE(2),MAXCHAIN-1,
     1        NBREAKS,CHBPOS, ERROR )
         IF ( ERROR ) STOP
      ENDIF
C-------------------select output format------------------------------
 
C return label for next choice of format
 2    CONTINUE

      IF  ( MULTFORMAT ) THEN
         OUTFORMAT = 'm'
         CALL GETCHAR (1,OUTFORMAT,
     +        'Output-format? [*m*]: m = MSF/n'                  //
     +        '                      h = HSSP/n'                 //
     +        '                      p = PIR/n'                  //
     +        '                      f = FASTA/Pearson/n'        //
     +        '                      d = DAF/n'        //
     +        '                      y = PHYLIP ' )
      ELSE
         OUTFORMAT = 'g'
         CALL GETCHAR (1,OUTFORMAT,
     1        'Output-format? [*g*]: g = GCG/n'                    //
     2        '                      a = Alb/n'                    //
     3        '                      k = Klein (old-NBRF-format)/n'//
     4        '                      p = PIR/n'                    //
     5        '                      e = EMBL/SWISS/n'             //
     6        '                      s = star/n'                   //
     7        '                      f = FASTA/Pearson ' )
      ENDIF
      CALL LOWTOUP(OUTFORMAT,1)
C-----------------------------------------------------------------------
      IF ( OUTFORMAT .EQ. 'H' ) THEN
         CALL GETCHAR(MAX_NAME_LEN,VARMETRIC,
     1        ' use which metric file for variability calculation ? ' )
         CALL STRPOS(INFORMAT,ISTART,ISTOP)
         IF ( INFORMAT(ISTART:ISTOP) .EQ. 'MSF' ) THEN
            C = 'N'
C            LDOCLIP=.FALSE.
            CALL GETCHAR(1,C,
     1           ' treat gaps in master sequence as insertions ? ')
            CALL LOWTOUP(C,1)
C            IF (C .EQ. 'Y') LDOCLIP=.TRUE.
            LDOCLIP = C .EQ. 'Y'
         ENDIF
      ELSE
c...select residue range

         RANGE(1) = 1
         IF ( MULTFORMAT ) THEN
            RANGE(2)= ALILEN
            QUESTION=
     1      'Do you want to select a fragment of this alignment?[*N*]'
         ELSE
            RANGE(2)= NRES
            QUESTION=
     1      'Do you want to select a fragment of this protein?[*N*]'
         ENDIF
         NRESTMP=RANGE(2)
         CALL STRPOS(INFORMAT,ISTART,ISTOP)
         C = 'N'
         CALL GETCHAR(1,C,QUESTION)
         CALL LOWTOUP(C,1)
         IF ( C .NE. 'N' .AND. C .NE. ' ') THEN
            CALL GETINT
     1           (2,RANGE,
     2           ' Enter residue numbers of fragment start and stop: ')
C----            br 98.05: correct for too high
            IF (RANGE(2).GT.NRESTMP) THEN
               RANGE(2)= MIN(RANGE(2),NRESTMP)
               WRITE(6,'(A,I5)')' *** oops, 2nd number too large, '//
     +              'corrected to: ',RANGE(2)
            END IF
            IF (RANGE(1).GT.NRESTMP) THEN
               RANGE(1)= 1
               WRITE(6,'(A,I5)')' *** oops, 1st number too large, '//
     +              'corrected to: ',RANGE(1)
            END IF
            IF (RANGE(1).EQ.RANGE(2)) THEN
               WRITE(6,'(A,I5,A3,I5)')' *** oops you wanted: ',
     +              RANGE(1),' - ',RANGE(2)
               RANGE(1)=1
               RANGE(2)=NRESTMP
               WRITE(6,'(A,I5,A3,I5)')' *** was deemed strange and'//
     +              ' corrected to: ',RANGE(1),' - ',RANGE(2)
            END IF
         ENDIF
      ENDIF
C-----------------------------------------------------------------------
c...make up a default name for outfile

      CALL STRPOS(BASENAME,ISTART,ISTOP)
      IF ( OUTFORMAT .EQ. 'M' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.msf'
      ELSE IF ( OUTFORMAT .EQ. 'H' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.hssp'
      ELSE IF ( OUTFORMAT .EQ. 'D' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.daf'
      ELSE IF ( OUTFORMAT .EQ. 'P' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.pir'
C        else if ( outformat .eq. 'F' ) then
C           outname = basename(istart:istop) // '.pearson'
      ELSE IF ( OUTFORMAT .EQ. 'F' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.f'
      ELSE IF ( OUTFORMAT .EQ. 'S' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.star'
      ELSE IF ( OUTFORMAT .EQ. 'A' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.alb'
      ELSE IF ( OUTFORMAT .EQ. 'K' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.klein'
      ELSE IF ( OUTFORMAT .EQ. 'E' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.embl'
      ELSE IF ( OUTFORMAT .EQ. 'G' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.gcg'
C        else if ( outformat .eq. 'Y' ) then
C           outname = basename(istart:istop) // '.phylip'
      ELSE IF ( OUTFORMAT .EQ. 'Y' ) THEN
         OUTNAME = BASENAME(ISTART:ISTOP) // '.phy'
      ENDIF
      CALL GETCHAR(MAX_NAME_LEN,OUTNAME,' output file name ?' )
C-----------------------------------------------------------------------
      CALL OPEN_FILE(OUT,OUTNAME,'new',error)
      IF ( ERROR ) STOP
C-----------------------------------------------------------------------

C----
C---- --------------------------------------------------
C---- alignment formats
C---- --------------------------------------------------
C----
      IF ( MULTFORMAT ) THEN
         IF ( CALLS .EQ. 1 ) THEN
            CALL STRPOS(INFORMAT,ISTART,ISTOP)

            IF ( INFORMAT(ISTART:ISTOP) .EQ. 'HSSP' ) THEN
C msftoseq does not care about lowercase letters !
               DO I=1,ALILEN
                  IF(PDBSEQ(I) .EQ. '!')THEN
                     PDBSEQ(I)= CGAPCHAR
                  ENDIF
               ENDDO
c	         call CHARARRAYREPL(pdbseq,alilen,'!',cgapchar)
               CALL DSSP_NOTATION_TO_CYS(PDBSEQ,ALILEN)
 
C pdbseq will be "changepos"th sequence in aliseq
               PDBNAME = PDBID

               CALL LEFTADJUST(PDBNAME,1,CODELEN)
               CHANGEPOS = 1
               LINSERT = .TRUE.
               LDELETE = .FALSE.

               CALL CHANGE_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,MAXRES,
     +              LINSERT,LDELETE,CHANGEPOS,NALIGN,
     1              PDBSEQ,1,ALILEN,PDBNAME,
     2              ALILEN,ALISEQ,ALIPOINTER,IFIR,ILAS,JFIR,JLAS,
     3              LALI,NGAP,LGAP,LENSEQ,STRID,IDE,SIM,EXCLUDEFLAG,
     4              ACCNUM_HSSP,EMBLID,PROTNAME,INSALI,INSNUMBER)
               
               IF (OUTFORMAT .NE. 'D')THEN
                  DO IALIGN = 1,NALIGN
                     WEIGHT(IALIGN) = 1.0
                  ENDDO
               ENDIF
            ENDIF
         ENDIF

         IF ( OUTFORMAT .EQ. 'P' ) THEN
            NSYMBOLS = 30
            DO IALIGN = 1,NALIGN
               CALL GET_SEQ_FROM_ALISEQ(ALISEQ,IFIR,ILAS,
     1              ALIPOINTER,ALILEN,IALIGN,SEQ,NREAD,
     2              ERROR )
               IF ( ERROR ) STOP
               CALL STRREPLACE(SEQ,ALILEN,CGAPCHAR,CGAPCHARPIR)
               CALL WRITE_PIR(OUT,SEQ,FILENAME,OUTNAME,ACCNUM,
     1              EMBLID(IALIGN),NSYMBOLS,RANGE(1),
     2              RANGE(2),ERROR)
               IF ( ERROR ) STOP
            ENDDO
C---- 
C----    out HSSP
C----
         ELSE IF ( OUTFORMAT .EQ. 'H' ) THEN
C even if chains are not regularily counted, dont have "nchain=0"
C .... in the header!
            NCHAIN = 1
            CALL MAKE_HSSP(MAXRES,MAXALIGNS,MAXCORE,
     +           MAXAA,MAXINS,MAXINSBUF,
     +           OUT,OUTNAME,FILENAME,PDBID,HEADER,
     +           COMPND,SOURCE,AUTHOR,ALILEN,NCHAIN,KCHAIN,
     +           CHAINREMARK,NALIGN,EXCLUDEFLAG,EMBLID,STRID,
     +           IDE,SIM,IFIR,ILAS,JFIR,JLAS,LALI,NGAP,LGAP,
     +           LENSEQ,ACCNUM_HSSP,PROTNAME,PDBNO,PDBSEQ,CHAINID,
     +           SECSTR_HSSP,COLS,SHEETLABEL,BP1,BP2,ACC,NOCC,
     +           VAR,ALISEQ,ALIPOINTER,SEQPROF,NDEL,NINS,ENTROPY,
     +           RELENT,CONSWEIGHT_MIN,CONSWEIGHT,LCONSERV,LOLDVERSION,
     +           CGAPCHAR,LFILTER,VARMETRIC,LDOCLIP,
     +           INSNUMBER,INSALI,INSPOINTER,INSLEN,INSBEG_1,
     +           INSBEG_2,INSBUFFER,DO_INIT_INSBUF,ERROR,
     $           LHSSP_LONG_ID)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'Y' ) THEN
            NBLOCKS = 5
            CALL WRITE_PHYLIP(OUT,MAXALIGNS,MAXCORE,RANGE(1),
     1           RANGE(2),NBLOCKS,ALISEQ,ALIPOINTER,
     2           IFIR,ILAS,EMBLID,NALIGN,ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'M' ) THEN
            TYPE = 'P'
            NBLOCKS = 5
            CALL STRPOS(INFORMAT,ISTART,ISTOP)
            IF ( INFORMAT(ISTART:ISTOP) .EQ. 'HSSP' ) THEN
               C = 'N'
               CALL GETCHAR(1,C,
     1        ' Expand sequences according to HSSP insertion list ? ')
               CALL LOWTOUP(C,1)
               LDOEXP = C .EQ. 'Y'
            ELSE
               LDOEXP = .FALSE.
            ENDIF
C	      call write_msf(out,filename,outname,MAXALIGNS,MAXRES,

            CALL WRITE_MSF(OUT,FILENAME,OUTNAME,MAXALIGNS,MAXRES,
     1           MAXCORE,MAXINS,MAXINSBUF,RANGE(1),RANGE(2),NBLOCKS,
     2           ALISEQ,ALIPOINTER,IFIR,ILAS,TYPE,EMBLID,WEIGHT,
     3           SEQCHECK,MSFCHECK,ALILEN,NALIGN,INSNUMBER,INSALI,
     4           INSPOINTER,INSLEN,INSBEG_1,INSBUFFER,
     5           LDOEXP,ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'D' ) THEN
            TYPE = 'P'
            NBLOCKS = 1
            CALL STRPOS(INFORMAT,ISTART,ISTOP)
            IF ( INFORMAT(ISTART:ISTOP) .EQ. 'HSSP' ) THEN
               LDOEXP = .TRUE.
            ENDIF
            CALL WRITE_DAF(OUT,FILENAME,OUTNAME,MAXALIGNS,MAXRES,
     1           MAXCORE,MAXINS,MAXINSBUF,RANGE(1),RANGE(2),
     2           ALISEQ,ALIPOINTER,IDE,IFIR,ILAS,EMBLID,WEIGHT,
     3           ALILEN,NALIGN,LALI,INSNUMBER,INSALI,
     4           INSPOINTER,INSLEN,INSBEG_1,INSBUFFER,
     5           ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'F' ) THEN
            NBLOCKS = 6
            DO IALIGN = 1,NALIGN
               CALL GET_SEQ_FROM_ALISEQ(ALISEQ,IFIR,ILAS,
     1              ALIPOINTER,ALILEN,IALIGN,SEQ,NREAD,
     2              ERROR )
               IF ( ERROR ) STOP
               CALL WRITE_PEARSON(OUT,OUTNAME,SEQ,NBLOCKS,
     1              EMBLID(IALIGN),COMPND,RANGE(1),
     2              RANGE(2),ERROR)
               IF ( ERROR ) STOP
            ENDDO
         ELSE
            WRITE(*,*)' wat is tipp wat richtiges, bloedmann'
C            GOTO 2
            STOP
         ENDIF
      ELSE
         IF ( OUTFORMAT .EQ. 'S' ) THEN
            NBLOCKS = 7
            CALL WRITE_STAR(OUT,SEQ,NBLOCKS,FILENAME,OUTNAME,
     1           COMPND,RANGE(1),RANGE(2),ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'A' ) THEN
            NBLOCKS = 5
            CALL WRITE_ALB(OUT,OUTNAME,SEQ,NBLOCKS,COMPND,FILENAME,
     1           RANGE(1),RANGE(2),CHBPOS,NBREAKS,ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'K' ) THEN
            NBLOCKS = 6
            CALL WRITE_KLEIN(OUT,SEQ,NBLOCKS,BASENAME,FILENAME,
     1           OUTNAME,COMPND,RANGE(1),RANGE(2),
     2           ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'P' ) THEN
            NSYMBOLS = 30
            CALL STRREPLACE(SEQ,NRES,CGAPCHAR,CGAPCHARPIR)
            CALL WRITE_PIR(OUT,SEQ,FILENAME,OUTNAME,ACCNUM,COMPND,
     1           NSYMBOLS,RANGE(1),RANGE(2),ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'E' ) THEN
            NBLOCKS = 6
            CALL WRITE_EMBL(OUT,SEQ,NBLOCKS,FILENAME,OUTNAME,COMPND,
     1           RANGE(1),RANGE(2),ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'G' ) THEN
            NBLOCKS = 5
            CALL WRITE_GCG(OUT,SEQ,NBLOCKS,NBREAKS,FILENAME,OUTNAME,
     1           COMPND,RANGE(1),RANGE(2),ERROR)
            IF ( ERROR ) STOP
         ELSE IF ( OUTFORMAT .EQ. 'F' ) THEN
            NBLOCKS = 6
            CALL WRITE_PEARSON(OUT,OUTNAME,SEQ,NBLOCKS,ACCNUM,
     1           COMPND,RANGE(1),RANGE(2),ERROR)
            IF ( ERROR ) STOP
         ELSE
            WRITE(*,*)' wat is tipp wat richtiges, bloedmann'
C            GOTO 2
            STOP
         ENDIF
      ENDIF
 
      CLOSE(OUT)
 
      C = 'N'
      CALL GETCHAR(1,C,' write another format ?')
      CALL LOWTOUP(C,1)
      IF ( C .NE. 'N' ) THEN
         CALLS = CALLS + 1
         DO_INIT_INSBUF = .FALSE.
         GOTO 2
      ENDIF
 
      END
C     END PROGRAM CONVERT
C......................................................................
 
C......................................................................
C     SUB CHAINBREAKPOS
      SUBROUTINE CHAINBREAKPOS( SEQ,BEGIN,END,MAXBREAK,NBREAKS,
     1     CHBPOS, ERROR )
	
      IMPLICIT        NONE
C Import
      INTEGER         MAXBREAK,BEGIN,END
      CHARACTER*(*)   SEQ
C Export
      INTEGER         NBREAKS,CHBPOS(MAXBREAK)
      LOGICAL         ERROR
C Internal
      INTEGER         IPOS
*----------------------------------------------------------------------*
 
      NBREAKS = 0
      DO IPOS = BEGIN,END
         IF ( SEQ(IPOS:IPOS) .EQ. '!' ) THEN
            NBREAKS = NBREAKS + 1
            IF ( NBREAKS .GT. MAXBREAK ) THEN
               ERROR = .TRUE.
               WRITE(*,'(A)')
     1              ' MAXBREAK overflow in chainbreakpos !'
               RETURN
            ENDIF
            CHBPOS(NBREAKS) = IPOS
         ENDIF
      ENDDO
      
      RETURN
      END
C     END CHAINBREAKPOS
C......................................................................
 
C......................................................................
C     SUB CHOOSE_NAME
      SUBROUTINE CHOOSE_NAME(EMBLID,NSEQS,NUMBER)
C 21.10.92
      IMPLICIT        NONE
C Import
      INTEGER         NSEQS
      CHARACTER*(*)   EMBLID(NSEQS)
C Export
      INTEGER         NUMBER
C Internal
      INTEGER         NAMELEN_LOC
      PARAMETER      (NAMELEN_LOC=              13)
      INTEGER INAME
      CHARACTER*(NAMELEN_LOC) ANSWER
      CHARACTER*(NAMELEN_LOC) TEST
      LOGICAL LFOUND
      
      ANSWER = EMBLID(1)
      
      DO INAME = 1,NSEQS
         WRITE(*,'(1X,A)') EMBLID(INAME)
      ENDDO
 1    CONTINUE
      CALL GETCHAR(NAMELEN_LOC,ANSWER,
     1     'Choose name of HSSP master sequence :' )
      CALL LOWTOUP(ANSWER,NAMELEN_LOC)
C position of sequence in alignment = return information
      LFOUND = .FALSE.
      NUMBER = 1
      INAME = 1
      DO WHILE ( INAME .LE. NSEQS .AND. .NOT. LFOUND )
         TEST = EMBLID(INAME)
         CALL LOWTOUP(TEST,NAMELEN_LOC)
         IF ( ANSWER .EQ. TEST ) THEN
            LFOUND = .TRUE.
         ELSE
            INAME = INAME + 1
            NUMBER = NUMBER + 1
         ENDIF
      ENDDO
      IF ( .NOT. LFOUND ) THEN
         WRITE(*,'(1X,A)') ' *** INVALID CHOICE ***'
         STOP
C         GOTO 1
      ENDIF
 
      RETURN
      END
C     END CHOOSE_NAME
C......................................................................
 
C......................................................................
C     SUB CLIP_ALISEQ
      SUBROUTINE CLIP_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,
     1     MAXINSBUF,ALISEQ,ALIPOINTER,NALIGN,CGAPCHAR,NRES,
     2     IFIR,ILAS,JFIR,JLAS,DELPOS,NDEL,INSNUMBER,INSALI,
     3     INSPOINTER,INSLEN,INSBEG_1,INSBEG_2,INSBUFFER,
     4     ERROR)
C 5.7.93
C delete the regions indicated in "delpos" from all sequences of the
C passed "aliseq" structure;
C copy the regions to "insbuffer"
      IMPLICIT        NONE
C Import
      INTEGER         MAXALIGNS, MAXCORE, MAXINS, MAXINSBUF,NALIGN,NRES
      INTEGER         IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +                JFIR(MAXALIGNS),JLAS(MAXALIGNS),
     +                ALIPOINTER(MAXALIGNS)
      INTEGER         DELPOS(2,*),NDEL
      CHARACTER*1     CGAPCHAR
C Export
      INTEGER         INSNUMBER,INSALI(MAXINS),INSPOINTER(MAXINS),
     +                INSLEN(MAXINS),INSBEG_1(MAXINS),INSBEG_2(MAXINS)
      CHARACTER       ALISEQ(MAXCORE)
      CHARACTER       INSBUFFER(MAXINSBUF)
      LOGICAL         ERROR
C Internal
      INTEGER         MAXTEMPBUF
      PARAMETER      (MAXTEMPBUF=             1000)
      INTEGER         I,IALIGN,IDEL,MAXLENDEL,LENDEL,
     +                IPOS,JPOS,IAP,ISP,NTERMDEL,
     +                NEXTPOS_INS,LGAP,NSYMBOLS,LASTPOS,POS,LEN
      CHARACTER*1     C
      CHARACTER*(MAXTEMPBUF) TEMPBUF
*----------------------------------------------------------------------*
        
      INSNUMBER = 0
      NEXTPOS_INS = 1
      MAXLENDEL = 0
        
      DO IALIGN = 1,NALIGN
         NTERMDEL = 0
         LGAP = 0
         LASTPOS = IFIR(IALIGN)
         LENDEL = 0
         IPOS = ALIPOINTER(IALIGN)-1
         ISP = JFIR(IALIGN) - 1
         DO IDEL = 1,NDEL
            POS = DELPOS(1,IDEL)
            LEN = DELPOS(2,IDEL)
            IF ( POS .LE. IFIR(IALIGN) ) THEN
               NTERMDEL = NTERMDEL + LEN
C     IF ( POS+LEN-1 .LT. IFIR(IALIGN) ) THEN
C     NTERMDEL = NTERMDEL + LEN
C     ELSE IF ( POS       .LT. IFIR(IALIGN) .AND.
C     1                  pos+len-1 .ge. ifir(ialign)       ) then
C                 ntermdel = ntermdel + len
            ELSE IF ( POS .GT. IFIR(IALIGN) .AND.
     1              POS .LE. ILAS(IALIGN)        ) THEN
               DO IAP = LASTPOS,POS-1
                  IPOS = IPOS + 1
                  IF ( ALISEQ(IPOS) .NE. CGAPCHAR ) THEN
                     ISP = ISP + 1
                  ENDIF
               ENDDO
               IPOS = IPOS + 1
               ISP = ISP + 1
               NSYMBOLS = 0
               TEMPBUF = ' '
               DO JPOS = 1,LEN
                  IF ( ALISEQ(IPOS+JPOS-1) .NE. CGAPCHAR ) THEN
                     NSYMBOLS = NSYMBOLS + 1
                     TEMPBUF(NSYMBOLS:NSYMBOLS) =
     1                    ALISEQ(IPOS+JPOS-1)
                  ELSE
                     LGAP = LGAP + 1
                  ENDIF
               ENDDO
               DO JPOS = IPOS,ALIPOINTER(IALIGN)+
     1              (ILAS(IALIGN)-IFIR(IALIGN))-LEN
                  ALISEQ(JPOS) = ALISEQ(JPOS+LEN)
               ENDDO
               IF ( NSYMBOLS .GT. 0 ) THEN
                  INSNUMBER = INSNUMBER + 1
                  IF ( INSNUMBER .GT. MAXINS ) THEN
                     WRITE(*,'(1X,A)')
     1                    'MAXINS overflow in clip_aliseq !'
                     ERROR = .TRUE.
                     RETURN
                  ENDIF
                  INSPOINTER(INSNUMBER) = NEXTPOS_INS
                  INSBEG_1(INSNUMBER) = POS-LENDEL-1
                  INSBEG_2(INSNUMBER) = ISP-1
                  INSALI(INSNUMBER) = IALIGN
                  INSLEN(INSNUMBER) = NSYMBOLS
                  IF ( IPOS .GT. 1 ) THEN
                     C = ALISEQ(IPOS-1)
                     JPOS = IPOS-1
                     IF ( C .EQ. CGAPCHAR ) THEN
                        DO WHILE ( JPOS .GT. 1 .AND.
     1                       ALISEQ(JPOS) .EQ. CGAPCHAR )
                           JPOS = JPOS - 1
                           C = ALISEQ(JPOS)
                        ENDDO
                     ENDIF
                     CALL UPTOLOW(C,1)
                     ALISEQ(JPOS) = C
                  ENDIF
                  INSBUFFER(NEXTPOS_INS) = C
                  DO I = 1,NSYMBOLS
                     INSBUFFER(NEXTPOS_INS+I) = TEMPBUF(I:I)
                  ENDDO
                  C = ALISEQ(IPOS)
                  JPOS = IPOS
                  IF ( C .EQ. CGAPCHAR ) THEN
                     DO WHILE
     1                    ( JPOS .LT.
     2                    ALIPOINTER(IALIGN)+ILAS(IALIGN)-IFIR(IALIGN)
     3                    .AND.
     4                    ALISEQ(JPOS) .EQ. CGAPCHAR )
                        JPOS = JPOS + 1
                        C = ALISEQ(JPOS)
                     ENDDO
                  ENDIF
                  CALL UPTOLOW(C,1)
                  ALISEQ(JPOS) = C
                  INSBUFFER(NEXTPOS_INS+NSYMBOLS+1) = C
                  NEXTPOS_INS =
     1                 NEXTPOS_INS + NSYMBOLS + 3
                  IF ( NEXTPOS_INS .GT. MAXINSBUF ) THEN
                     WRITE(*,'(1X,A)')
     1                    'MAXINSBUF overflow in clip_aliseq !'
                     ERROR = .TRUE.
                     RETURN
                  ENDIF
               ENDIF
               LASTPOS = POS + LEN + 1
               LENDEL = LENDEL + LEN
            ENDIF
         ENDDO
         MAXLENDEL = MAX(MAXLENDEL,LENDEL)
         IFIR(IALIGN) = IFIR(IALIGN)-NTERMDEL
         IF ( IFIR(IALIGN) .LT. 1 ) THEN
C delete n-terminal gaps
            DO JPOS = ALIPOINTER(IALIGN),
     1           ALIPOINTER(IALIGN)+
     2           (ILAS(IALIGN)-1)-(1-IFIR(IALIGN))
               ALISEQ(JPOS) = ALISEQ(JPOS+(1-IFIR(IALIGN)))
            ENDDO
            IFIR(IALIGN) = 1
         ENDIF
         ILAS(IALIGN) = ILAS(IALIGN)-LENDEL-NTERMDEL
         JLAS(IALIGN) = JLAS(IALIGN)-LENDEL-NTERMDEL +LGAP
      ENDDO
C>>>>>
      NRES = NRES - MAXLENDEL
 
      RETURN
      END
C     END CLIP_ALISEQ
C......................................................................
 
C......................................................................
C     SUB CHANGE_ALISEQ
      SUBROUTINE CHANGE_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,MAXRES,
     1     LINSERT,LDELETE,CHANGEPOS,NALIGN,
     +     NEWSEQ,NEWSEQSTART,NEWSEQSTOP,NEWSEQNAME,
     2     FILLUP,ALISEQ,ALIPOINTER,
     3     IFIR,ILAS,JFIR,JLAS,LALI,NGAP,LGAP,LENSEQ,STRID,
     4     IDE,SIM,EXCLUDEFLAG,ACCNUM,EMBLID,PROTNAME,INSALI,
     5     INSNUMBER)
 
      IMPLICIT     NONE
C Import
      INTEGER      MAXALIGNS,MAXCORE,MAXINS,MAXRES,CHANGEPOS
C mutually exclusive logicals:
C ........ if ( linsert ) "newseq" is inserted into aliseq at position
C ........ "changepos". Its name, stop/start values and so on are
C ........ added to the appropriate arrays.
C ........ if ( ldelete ), the "changepos"th sequence is deleted from
C ........ aliseq ( so is its name, start/stop values .. from emblid,
C ........ ifir, ilas .. ) and is returned in "newseq".  Its name is
C ........ returned in "newseqname".
      LOGICAL       LINSERT, LDELETE
C Import / Export
      INTEGER       NALIGN,FILLUP,ALIPOINTER(MAXALIGNS)
      INTEGER       NEWSEQSTART,NEWSEQSTOP
      CHARACTER     ALISEQ(MAXCORE),NEWSEQ(MAXRES),NEWSEQNAME*(*)
C  attributes of aligned sequences
C---- first and last residue of guide (ifir), and aligned (jfir)
      INTEGER       IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +              JFIR(MAXALIGNS),JLAS(MAXALIGNS)
      INTEGER       LALI(MAXALIGNS),NGAP(MAXALIGNS),
     +              LGAP(MAXALIGNS),LENSEQ(MAXALIGNS),
     +              INSALI(MAXINS),INSNUMBER
      CHARACTER*(*) STRID(MAXALIGNS),ACCNUM(MAXALIGNS),
     +              EMBLID(MAXALIGNS),PROTNAME(MAXALIGNS)
C---- ' ' if no flag, '*' if to exclude
      CHARACTER     EXCLUDEFLAG(MAXALIGNS)
C---- percentage identity       similarity
      REAL          IDE(MAXALIGNS),SIM(MAXALIGNS)

C Internal
      INTEGER       IALIGN,IINS,IPOS,JPOS,LEN,IBEG,IEND,ITMP,I
      INTEGER       NEWSEQLEN
      CHARACTER*1   CGAPCHAR
      
      CGAPCHAR = '.'
C----------------------------------------------------------------------
      IF ( LINSERT ) THEN
C----------------------------------------------------------------------
 
         NEWSEQLEN = NEWSEQSTOP-NEWSEQSTART+1
         IF ( CHANGEPOS .GT. NALIGN+1 ) THEN
 
            WRITE(*,'(A,I4)') ' cannot add after position ', NALIGN+1
            RETURN
         ELSE IF ( CHANGEPOS .EQ. NALIGN+1 ) THEN
            ALIPOINTER(CHANGEPOS) =
     1           ALIPOINTER(NALIGN)+ILAS(NALIGN)-IFIR(NALIGN)+1
         ELSE IF ( CHANGEPOS .LE. NALIGN ) THEN
            DO IPOS = ALIPOINTER(NALIGN)+ILAS(NALIGN)-IFIR(NALIGN)+1,
     1           ALIPOINTER(CHANGEPOS),-1
               IF ( IPOS+NEWSEQLEN+1 .LE. MAXCORE ) THEN
C shift by newseqlen+1, because a '/' is to be inserted after newseq
                  ALISEQ(IPOS+NEWSEQLEN+1 ) = ALISEQ(IPOS)
               ELSE
                  STOP 'MAXCORE OVERFLOW IN ADD_SEQ_TO_ALISEQ !'
               ENDIF
            ENDDO
C insert new member into arrays ifir .. at position changepos
C  and push following members by one
            DO IINS = 1,INSNUMBER
               IF ( INSALI(IINS) .GE. CHANGEPOS ) THEN
                  INSALI(IINS)=INSALI(IINS)+1
               ENDIF
            ENDDO
            DO IALIGN = NALIGN,CHANGEPOS,-1
               IFIR(IALIGN+1)=IFIR(IALIGN)
               ILAS(IALIGN+1)=ILAS(IALIGN)
               JFIR(IALIGN+1)=JFIR(IALIGN)
               JLAS(IALIGN+1)=JLAS(IALIGN)
               LALI(IALIGN+1)=LALI(IALIGN)
               NGAP(IALIGN+1)=NGAP(IALIGN)
               LGAP(IALIGN+1)=LGAP(IALIGN)
               LENSEQ(IALIGN+1)=LENSEQ(IALIGN)
               STRID(IALIGN+1)=STRID(IALIGN)
               ACCNUM(IALIGN+1)=ACCNUM(IALIGN)
               EMBLID(IALIGN+1)=EMBLID(IALIGN)
               PROTNAME(IALIGN+1)=PROTNAME(IALIGN)
               EXCLUDEFLAG(IALIGN+1)=EXCLUDEFLAG(IALIGN)
               IDE(IALIGN+1)=IDE(IALIGN)
               SIM(IALIGN+1)=SIM(IALIGN)
               ALIPOINTER(IALIGN+1) = ALIPOINTER(IALIGN)+NEWSEQLEN+1
            ENDDO
         ENDIF
 
C insert newseq into aliseq
C changepos............last res, '/'
C                            = +1
         LEN = NEWSEQSTART
         DO IPOS = ALIPOINTER(CHANGEPOS),
     1        (ALIPOINTER(CHANGEPOS)+NEWSEQLEN-1)
            IF (IPOS.GT.0) THEN
               ALISEQ(IPOS)= NEWSEQ(LEN)
               LEN=          LEN + 1
            ENDIF
         ENDDO
         ALISEQ(IPOS) = '/'
         IFIR(CHANGEPOS)=1
         ILAS(CHANGEPOS)=NEWSEQLEN
         JFIR(CHANGEPOS)=1
         JLAS(CHANGEPOS)=NEWSEQLEN
         LALI(CHANGEPOS)=NEWSEQLEN
         NGAP(CHANGEPOS)=0
         LGAP(CHANGEPOS)=0
         LENSEQ(CHANGEPOS)=NEWSEQLEN
         STRID(CHANGEPOS )= ' '
         ACCNUM(CHANGEPOS) = ' '
         EMBLID(CHANGEPOS)= NEWSEQNAME
         PROTNAME(CHANGEPOS)= ' '
         EXCLUDEFLAG(CHANGEPOS)= ' '
         IDE(CHANGEPOS)=0.0
         SIM(CHANGEPOS)=0.0
         
         NALIGN = NALIGN + 1

C------- br 99-03: watch names
         IF (EMBLID(1).EQ.EMBLID(CHANGEPOS)) THEN
            CALL STRPOS(EMBLID(1),IBEG,IEND)
            EMBLID(1)((IEND+1):(IEND+1))="0"
         ENDIF
C-----------------------------------------------------------------------
      ELSE IF ( LDELETE .AND. CHANGEPOS.NE.0) THEN
C-----------------------------------------------------------------------

C save sequence in "newseq"
         JPOS=0
C----    all before to gap (really what you want?)
         IF (IFIR(CHANGEPOS) .GE. 2) THEN
            DO JPOS=1,(IFIR(CHANGEPOS)-1)
               NEWSEQ(JPOS)= CGAPCHAR
            ENDDO
            JPOS=         JPOS - 1
         ENDIF

         NEWSEQLEN=       0
         IBEG=            ALIPOINTER(CHANGEPOS)
         IEND=            IBEG+ILAS(CHANGEPOS)-IFIR(CHANGEPOS)
C----    read real sequence for the respective range
         DO IPOS=IBEG,IEND
Cxx            write(6,*)'xx ipos=',ipos,' len=',lenseq(changepos)
            IF (IPOS.GT.0) THEN
               NEWSEQLEN=             NEWSEQLEN+1
               NEWSEQ(NEWSEQLEN+JPOS)=ALISEQ(IPOS)
            ENDIF
         ENDDO
C----    fill up with GAP
         DO IPOS=(ILAS(CHANGEPOS)+1),FILLUP
            NEWSEQ(IPOS)=          CGAPCHAR
         ENDDO
         NEWSEQSTART= IFIR(CHANGEPOS)
         NEWSEQSTOP=  ILAS(CHANGEPOS)
         
         IF ( CHANGEPOS .LT. NALIGN ) THEN
C if the last sequence is to be deleted, nothing has actually to be
C ...done to "aliseq". Otherwise: pull all following sequences and
C ...array entries by one, overwriting sequence No. "changepos"
            DO IPOS= ALIPOINTER(CHANGEPOS+1),
     1           ALIPOINTER(NALIGN)+ILAS(NALIGN)-IFIR(NALIGN)+1
C shift by newseqlen+1, because a '/' is to be inserted after newseq
               ALISEQ(IPOS-NEWSEQLEN-1 ) = ALISEQ(IPOS)
            ENDDO
            NEWSEQNAME= EMBLID(CHANGEPOS)
            DO IINS = 1,INSNUMBER
               IF (INSALI(IINS) .GE. CHANGEPOS) THEN
                  INSALI(IINS)=INSALI(IINS)-1
               ENDIF
            ENDDO
            DO IALIGN=CHANGEPOS,(NALIGN-1)
               IFIR(IALIGN)=       IFIR(IALIGN+1)
               ILAS(IALIGN)=       ILAS(IALIGN+1)
               JFIR(IALIGN)=       JFIR(IALIGN+1)
               JLAS(IALIGN)=       JLAS(IALIGN+1)
               LALI(IALIGN)=       LALI(IALIGN+1)
               NGAP(IALIGN)=       NGAP(IALIGN+1)
               LGAP(IALIGN)=       LGAP(IALIGN+1)
               LENSEQ(IALIGN)=     LENSEQ(IALIGN+1)
               STRID(IALIGN)=      STRID(IALIGN+1)
               ACCNUM(IALIGN)=     ACCNUM(IALIGN+1)
               EMBLID(IALIGN)=     EMBLID(IALIGN+1)
               PROTNAME(IALIGN)=   PROTNAME(IALIGN+1)
               EXCLUDEFLAG(IALIGN)=EXCLUDEFLAG(IALIGN+1)
               IDE(IALIGN)=        IDE(IALIGN+1)
               SIM(IALIGN)=        SIM(IALIGN+1)
               ALIPOINTER(IALIGN)= ALIPOINTER(IALIGN+1)-NEWSEQLEN-1
            ENDDO
         ENDIF

C----    reduce number of alignments (since CHANGEPOSnth seq removed)
         NALIGN=NALIGN-1
C----------------------------------------------------------------------
      ENDIF
C----------------------------------------------------------------------
      RETURN
      END
C     END CHANGE_ALISEQ
C......................................................................
 
C......................................................................
C     SUB DSSP_NOTATION_TO_CYS
      SUBROUTINE DSSP_NOTATION_TO_CYS(SEQIN,LEN)
 
      IMPLICIT        NONE
C 20.3.92
C Import:
      CHARACTER       SEQIN(*)
      INTEGER         LEN
C Internal:
C only used to get rid of INDEX command (CPU time)
      INTEGER         NASCII
      PARAMETER      (NASCII=                  256)
      INTEGER         LOWERPOS(NASCII),IRES, I
      CHARACTER*26    LOWER
      CHARACTER*1     C
*----------------------------------------------------------------------*

C used to convert lower case characters from the DSSP-seq to 'C' (Cys)
      LOWER='abcdefghijklmnopqrstuvwxyz'
      CALL GETPOS(LOWER,LOWERPOS,NASCII)
 
      IRES = 1
      DO WHILE ( IRES .LE. LEN)
         C = SEQIN(IRES)
         CALL GETINDEX(C,LOWERPOS,I)
         IF(I.NE.0) C='C'
         SEQIN(IRES) = C
         IRES = IRES + 1
      ENDDO
 
      RETURN
      END
C     END DSSP_NOTATION_TO_CYS
C......................................................................
 
C......................................................................
C     SUB EXTRACT_CHAINS
      SUBROUTINE EXTRACT_CHAINS(TEMPNAME,FILENAME,MAXCHAINS,
     1     CCHAIN)
 
      IMPLICIT NONE
C chain is given as an appendix to filename as follows:
C filename_!_chain
C
C IF CHAINID IS A DIGIT, IT IS TAKEN TO BE THE "DIGIT"TH CHAIN !
C
C Import
      INTEGER MAXCHAINS
      CHARACTER*(*) TEMPNAME
C Export
      CHARACTER*(*) FILENAME
      CHARACTER*(*) CCHAIN
C Internal
      INTEGER I,II,J
      CHARACTER*32 OUTFORMAT
	
      CCHAIN = ' '
      I = INDEX(TEMPNAME,'!')
      IF ( I .NE. 0 ) THEN
         FILENAME = TEMPNAME(1:I-2)
      ELSE
         FILENAME = TEMPNAME
         WRITE(OUTFORMAT,'(A,I4,A)') '( ',MAXCHAINS, '(I3,1X))'
         WRITE(CCHAIN,OUTFORMAT) (J,J=1,MAXCHAINS)
      ENDIF
      J = 1
      II = I
      DO WHILE ( II .NE. 0 )
         IF ( J .EQ. 1 ) THEN
            CCHAIN(1:1) = TEMPNAME(I+2:I+2)
         ELSE
            CCHAIN(2*J-1:2*J-1) = TEMPNAME(I+1:I+1)
         ENDIF
         II = INDEX(TEMPNAME(I+1:),',')
         I = I + II
         J = J + 1
      ENDDO
      RETURN
      END
C     END EXTRACT_CHAINS
C......................................................................
 
C......................................................................
C     SUB GETCONSWEIGHT_BR
      SUBROUTINE GETCONSWEIGHT_BR(MAXSTRSTATES,MAXIOSTATES,
     +     MAXRES,MAXALIGNS,MAXCORE,NTRANS,NASCII,NALIGN,NRES,
     +     IDE,IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
     +     EXCLUDEFLAG,CTRANS,MATRIX,SIMCONSERV,MATPOS,
     +     CONSWEIGHT_MIN,CONSWEIGHT)
C---- 
C---- BR May 98 + Oct 98
C---- 
C---- Calculate the conservation weight, taking into account the
C---- EXCLUDEFLAG(iali)='*' if the identity of alignment number
C---- 'iali' to any other sequence is above IDEMAX (threshold input)
C---- 
C---- 
C---- out:           output is the conservation weight
C---- 
C---- ------------------------------------------------------------------
C----
C---- formula: 
C----                 nali
C----                 -----
C----                 \      (1 - IDE(s,a,b)) * SIM(s,a,b)
C----          CW(s)=  >     -----------------------------       
C----                 /                DISTSUM
C----                 -----
C----                 a,b
C----                 
C---- with:    CW(s):       conservation weight for residue s
C----          a,b:         alignment between protein a and b
C----          IDE(s,a,b):  identity of residue s in a and s in b
C----                       = 0 || 1
C----          SIM(s,a,b):  similarity of residue s in a and s in b
C----                 
C----          DISTSUM(s):  sum over all distances at position s
C----                       and the following definition:
C---- 
C----                 nali   nres = overlap (a,b)
C----                 -----  ----
C----                 \      \             delta(s,a,b)
C----     DISTSUM(s)=  >      >     ------------------------------
C----                 /      /      number of overlapping residues
C----                 -----  ----
C----                 a,b    s
C----                 
C---- with:    delta(s,a,b) = 1 if residue s in a = residue s in b
C----                         0 else
C---- 
C---- normalise:
C----          finally normalised weights to have an average of 1:
C---- 
C----                 nres
C----                 -----
C----                 \      
C----        NORM(s)=  >     CW(s)
C----                 /           
C----                 -----
C----                 s
C---- 
C----     CW_NORM(s)= CW(s) / NORM
C---- 
C---- 
C---- ------------------------------------------------------------------
C---- 

      IMPLICIT       NONE  

C---- ------------------------------
C---- import
C---- ------------------------------
C---- 
C     parameters for array
      INTEGER        MAXSTRSTATES,MAXIOSTATES,MAXRES,MAXALIGNS,MAXCORE,
     +               NTRANS,NASCII
C     actual values
      INTEGER        NALIGN,NRES
C     pointer arrays
      INTEGER        IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +               ALIPOINTER(MAXALIGNS)
C     alignment length lali(i) length of ali between PDBSEQ and ali i
      INTEGER        LALI(MAXALIGNS)
C     guide sequence
      CHARACTER      PDBSEQ(MAXRES)
C     all aligned sequences
      CHARACTER      ALISEQ(MAXCORE)
C      CHARACTER*(*)  ALISEQ(MAXCORE)
C     flags (take ' ', else other)
      CHARACTER      EXCLUDEFLAG(MAXALIGNS)
C     percentage sequence identity
      REAL           IDE(MAXALIGNS),IDEMAX
C     comparison metric
      REAL           MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                      MAXSTRSTATES,MAXIOSTATES)   
C     normalised to sum over 0 (by SETCONSERVATION)
      REAL           SIMCONSERV(NTRANS,NTRANS)
C     allowed sequence symbols
      CHARACTER      CTRANS*26
C     minimal conservation weight
      REAL           CONSWEIGHT_MIN
C     only used to get rid of INDEX command (CPU time)
      INTEGER        MATPOS(NASCII)

C----
C---- output from sbr
C----
C     conservation weight
      REAL           CONSWEIGHT(MAXRES)

C---- ------------------------------------------------------------------
C---- internal
C---- ------------------------------------------------------------------
C----
C      INTEGER        NASCII,MAXLEN
      INTEGER         MAXRES_LOC,MAXLEN
      PARAMETER      (MAXRES_LOC=             9999)
C      PARAMETER      (MAXRES_LOC=            10000)
C      PARAMETER      (MAXRES_LOC=            30011)
      PARAMETER      (MAXLEN=                20000)
      INTEGER         IALIGN_SEQ(MAXRES_LOC),JALIGN_SEQ(MAXRES_LOC),
     +                I,J,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP,ISAFERANGE,
     +                IALIGN_SEQTMP,JALIGN_SEQTMP
      INTEGER         NOCC(MAXRES_LOC)

C---- big: seq ide distance for pair i,j
      REAL            SUM,MEAN,XVAL
      INTEGER         NPOS

      REAL            SIMDIST_POS(MAXRES_LOC)
      REAL            SEQDIST_POS(MAXRES_LOC)

      REAL            SEQDIST
      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR

C---- ------------------------------------------------------------------
C---- 
C---- defaults, ini

C---- 
C---- FORMULA+ISAFERANGE -> include into averaging
      ISAFERANGE= 5
C---- br: make 'safer' for weights
      ISAFERANGE= 5
C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
      WRITE(6,*)  '--- GETCONSWEIGHT_BR begin'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(6,*)'*** ERROR: NRES .GT. MAXRES IN GETCONSWEIGHT_BR'
         WRITE(6,*)'*** INCREASE MAXRES ****'
         STOP
      ENDIF
C---- 
C---- ERROR!
C---- 
      IF (NRES .LE. 0) RETURN
C---- 
C---- initialize 
C----
      DO I=1,NRES
         IALIGN_SEQ(I)= 0
         JALIGN_SEQ(I)= 0
         SIMDIST_POS(I)=0.0
         SEQDIST_POS(I)=0.0
         NOCC(I)=       0
      ENDDO

C      WRITE(6,*)'XX in getCONS PDB='
C      WRITE(6,'(40A1)')(PDBSEQ(I),I=1,NRES)

      
C---- ------------------------------------------------------------------
C---- guide against all
C---- ------------------------------------------------------------------
C---- store PDB sequence in integer array
      DO IRES=1,NRES
C         write(6,*)'xx ires=',ires,' pdb=',pdbseq(ires),','
         IALIGN_SEQ(IRES)=MATPOS(ICHAR(PDBSEQ(IRES)))
         IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
            IF ( PDBSEQ(IRES) .GE. 'a' .AND. 
     +           PDBSEQ(IRES) .LE. 'z') THEN
               IALIGN_SEQ(IRES)=
     +              MATPOS(ICHAR(PDBSEQ(IRES))-32)
            ENDIF
         ENDIF
      ENDDO
      
C----
C---- loop over all aligned sequences
C----
      DO JALIGN=1,NALIGN
C---- hack br 1999-12: problem with 'treat gaps as insertions'
C---- somehow the thing has IFIR(JALIGN) not defined!!
         IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
            IF (IFIR(JALIGN).EQ.0 .OR. ILAS(JALIGN).EQ.0) THEN
               EXCLUDEFLAG(JALIGN)="*"
            END IF
         END IF
C---- end of hack br 1999-12

         IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
C----          store alignment sequence in integer array (for j)
            JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
            DO IRES=IFIR(JALIGN),ILAS(JALIGN)
               JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
               IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                  IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(JPOS+IRES) .LE. 'z') THEN
                     JALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C---- 
C---- passed into SBR: IDE(i)
C---- 
            SEQDIST= 1.0 - IDE(JALIGN)
C----
C----       get overlap of aligned sequences
C----
            IBEG= MAX(1,   IFIR(JALIGN))
            IEND= MIN(NRES,ILAS(JALIGN))
            DO IRES= IBEG,IEND
               IF ( (IALIGN_SEQ(IRES) .NE. 0) .AND.
     +              (JALIGN_SEQ(IRES) .NE. 0) ) THEN
C---- 
C---- count up number of pairs found for current residue
C---- 
                  NOCC(IRES)=NOCC(IRES)+1
C----
C----             position specific distances
C---- 
                  SEQDIST_POS(IRES)=
     +                 SEQDIST_POS(IRES) + SEQDIST
                  SIMDIST_POS(IRES)=
     +                 SIMDIST_POS(IRES) + 
     +                 SEQDIST * SIMCONSERV(IALIGN_SEQ(IRES),
     +                                     JALIGN_SEQ(IRES))
               END IF
            END DO
         ENDIF
C----    end of: exclude?
      ENDDO
C---- end loop over all sequences aligned to guide

C---- ------------------------------------------------------------------
C---- all against all: get all pair distances
C---- ------------------------------------------------------------------
      DO IALIGN=1,NALIGN
C----    to exclude?
         IF ( EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
C----       store alignment sequence in integer array (for i)
            IPOS=ALIPOINTER(IALIGN)-IFIR(IALIGN)
            DO IRES=IFIR(IALIGN),ILAS(IALIGN)
               IALIGN_SEQ(IRES)=MATPOS( ICHAR( ALISEQ(IPOS+IRES) ) )
               IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
	          IF (ALISEQ(IPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(IPOS+IRES) .LE. 'z') THEN
                     IALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(IPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C----       loop over pair partners
C----
            DO JALIGN=IALIGN+1,NALIGN
	       IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
C----             store alignment sequence in integer array (for j)
                  JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
                  DO IRES=IFIR(JALIGN),ILAS(JALIGN)
                     JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
                     IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                        IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                       ALISEQ(JPOS+IRES) .LE. 'z') THEN
                           JALIGN_SEQ(IRES)=
     +                          MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                        ENDIF
                     ENDIF
                  ENDDO
C----
C---- get distance between overlap of aligned sequences
C----
                  IAGR=0
                  ILEN=0
                  IBEG= MAX(IFIR(IALIGN),IFIR(JALIGN))
                  IEND= MIN(ILAS(IALIGN),ILAS(JALIGN))
                  DO IRES=IBEG,IEND
                     IF ( IALIGN_SEQ(IRES) .NE. 0 .AND.
     +                    JALIGN_SEQ(IRES) .NE. 0) THEN

C---- count up number of pairs found for current residue
                        NOCC(IRES)=NOCC(IRES)+1

                        IF (IALIGN_SEQ(IRES).EQ.JALIGN_SEQ(IRES)) THEN
                           IAGR=IAGR+1
                        ENDIF
                        ILEN=ILEN+1
                     ENDIF
                  ENDDO
                  IF (ILEN .NE. 0) THEN
                  
                     SEQDIST= 1.0 - (FLOAT(IAGR)/ILEN)

                     DO IRES=IBEG,IEND
                        IF ( IALIGN_SEQ(IRES).NE.0 .AND.
     +                       JALIGN_SEQ(IRES).NE.0 ) THEN
                           SEQDIST_POS(IRES)=
     +                          SEQDIST_POS(IRES) + SEQDIST
                           SIMDIST_POS(IRES)=
     +                          SIMDIST_POS(IRES) + 
     +                          SEQDIST * SIMCONSERV(IALIGN_SEQ(IRES),
     +                                               JALIGN_SEQ(IRES))
                        ENDIF
                     END DO
                  END IF
               ENDIF
C----          end of: exclude?
            ENDDO
C----       end loop over pairs
         ENDIF
      ENDDO
C---- end loop over all alignments

C---- ------------------------------------------------------------------
C---- assign conservation weights
C---- ------------------------------------------------------------------

      DO IRES=1,NRES
         IF ((SEQDIST_POS(IRES) .GT. 0) .AND.
     +       (NOCC(IRES) .GT. 0) ) THEN
            CONSWEIGHT(IRES)=
     +           SIMDIST_POS(IRES)/SEQDIST_POS(IRES)
         ELSE 
            CONSWEIGHT(IRES)=1.0
         END IF
C----
C----    no negative values for conservation weight
C----
         IF (CONSWEIGHT(IRES) .LT. CONSWEIGHT_MIN) THEN
            CONSWEIGHT(IRES)=CONSWEIGHT_MIN
         ENDIF
      END DO

C---- ------------------------------------------------------------------
C---- weight conservation weights (average = 1)
C---- ------------------------------------------------------------------

      NPOS= 0 
      MEAN= 1.0
      SUM=  0.0
      DO IRES=1,NRES
         IF (NOCC(IRES).NE.0) THEN
            SUM = SUM  + CONSWEIGHT(IRES) 
            NPOS=NPOS+1
         ENDIF
      ENDDO
      IF (NPOS .NE. 0) THEN 
         MEAN=SUM/NPOS 
      ENDIF
      WRITE(6,*)'GETCONSWEIGHT: SUM,MEAN ',SUM,MEAN
      IF (MEAN.GT. 0.99 .AND. MEAN .LT. 1.01) RETURN
      XVAL=1.0-MEAN

      DO IRES=1,NRES
         IF (NOCC(IRES).NE.0) CONSWEIGHT(IRES)=CONSWEIGHT(IRES)+XVAL
      ENDDO

      WRITE(6,*)  '--- GETCONSWEIGHT_BR ended'
      RETURN
      END
C     END GETCONSWEIGHT_BR 
C......................................................................

C......................................................................
C     SUB GETSEQSIM_BR
      SUBROUTINE GETSEQSIM_BR(MAXSTRSTATES,MAXIOSTATES,
     +     MAXRES,MAXALIGNS,NTRANS,NASCII,NALIGN,NRES,
     +     IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
     +     EXCLUDEFLAG,CTRANS,MATRIX,SIMCONSERV,MATPOS,SIM,CONSWEIGHT)
C---- 
C---- BR 99-03
C---- 
C---- Calculate the sequence similarity.
C---- EXCLUDEFLAG(iali)='*' if the identity of alignment number
C---- 'iali' to any other sequence is above IDEMAX (threshold input)
C---- 
C---- 
C---- out:           output is the conservation weight
C---- 
C---- ------------------------------------------------------------------
C---- 
C---- 
C---- ------------------------------------------------------------------
C---- 

      IMPLICIT       NONE  

C---- 
C---- import
C---- 
C     parameters for array
      INTEGER        MAXSTRSTATES,MAXIOSTATES,MAXRES,MAXALIGNS,
     +               NTRANS,NASCII
C     actual values
      INTEGER        NALIGN,NRES
C     pointer arrays
      INTEGER        IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +               ALIPOINTER(MAXALIGNS)
C     alignment length lali(i) length of ali between PDBSEQ and ali i
      INTEGER        LALI(MAXALIGNS)
C     guide sequence
      CHARACTER      PDBSEQ(MAXRES)
C     all aligned sequences
      CHARACTER*(*)  ALISEQ(*)
C     flags (take ' ', else other)
      CHARACTER      EXCLUDEFLAG(MAXALIGNS)
C     percentage sequence identity
C      REAL           IDE(MAXALIGNS),IDEMAX
C     comparison metric
      REAL           MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                      MAXSTRSTATES,MAXIOSTATES)   
C     normalised to sum over 0 (by SETCONSERVATION)
      REAL           SIMCONSERV(NTRANS,NTRANS)
C     allowed sequence symbols
      CHARACTER      CTRANS*26
C     only used to get rid of INDEX command (CPU time)
      INTEGER        MATPOS(NASCII)
C     conservation weight
      REAL           CONSWEIGHT(MAXRES)
C----
C---- output from sbr
C----
C     percentage sequence similarity
      REAL           SIM(MAXRES)

C---- ------------------------------------------------------------------
C---- internal
C---- ------------------------------------------------------------------
C----
C      INTEGER        NASCII,MAXLEN
      INTEGER         MAXRES_LOC,MAXLEN
      PARAMETER      (MAXRES_LOC=             9999)
C      PARAMETER      (MAXRES_LOC=            10000)
C      PARAMETER      (MAXRES_LOC=            30011)
      PARAMETER      (MAXLEN=                20000)
      INTEGER         IALIGN_SEQ(MAXRES_LOC),JALIGN_SEQ(MAXRES_LOC),
     +                I,J,IALIGN,JALIGN,ILEN,IRES,
     +                IPOS,JPOS,IBEG,IEND,KPOS,IAGR,ISTEP,ISAFERANGE,
     +                IALIGN_SEQTMP,JALIGN_SEQTMP

C---- big: seq ide distance for pair i,j
      INTEGER         NPOS,NRES_OVERLAP
      REAL            SIM_XX(1000),SIM_XX2(1000)

      CHARACTER       LINE*(MAXLEN)
      LOGICAL         LERROR

C---- ------------------------------------------------------------------
C---- 
C---- defaults, ini

C---- ------------------------------------------------------------------
C---- now work on it      
C---- ------------------------------------------------------------------
      WRITE(6,*)  '--- GETSEQSIM_BR begin'
C---- 
C---- calculate variability only for the 22 (BZ) amino acids
C---- 
      DO I=1,NASCII 
         MATPOS(I)=0
      ENDDO
      CALL GETPOS(CTRANS(1:22),MATPOS,NASCII)
      IF (NRES .GT. MAXRES) THEN
         WRITE(*,*)'*** ERROR: NRES .GT. MAXRES IN GETSEQSIM_BR'
         WRITE(*,*)'*** INCREASE MAXRES ****'
         STOP
      ENDIF
C---- 
C---- ERROR!
C---- 
      IF (NRES .LE. 0) RETURN

C---- ------------------------------------------------------------------
C---- guide against all
C---- ------------------------------------------------------------------
C---- store PDB sequence in integer array
      DO IRES=1,NRES
         IALIGN_SEQ(IRES)=MATPOS(ICHAR(PDBSEQ(IRES)))
         IF ( IALIGN_SEQ(IRES) .EQ. 0) THEN
            IF ( PDBSEQ(IRES) .GE. 'a' .AND. 
     +           PDBSEQ(IRES) .LE. 'z') THEN
               IALIGN_SEQ(IRES)=
     +              MATPOS(ICHAR(PDBSEQ(IRES))-32)
            ENDIF
         ENDIF
      ENDDO
      
C----
C---- loop over all aligned sequences
C----
      DO JALIGN=1,NALIGN

         IF ( EXCLUDEFLAG(JALIGN) .EQ. ' ') THEN
C----       store alignment sequence in integer array (for j)
            JPOS=ALIPOINTER(JALIGN)-IFIR(JALIGN)
            DO IRES=IFIR(JALIGN),ILAS(JALIGN)
               JALIGN_SEQ(IRES)=MATPOS(ICHAR(ALISEQ(JPOS+IRES)))
               IF ( JALIGN_SEQ(IRES) .EQ. 0) THEN
                  IF (ALISEQ(JPOS+IRES) .GE. 'a' .AND. 
     +                 ALISEQ(JPOS+IRES) .LE. 'z') THEN
                     JALIGN_SEQ(IRES)=
     +                    MATPOS(ICHAR(ALISEQ(JPOS+IRES))-32)
                  ENDIF
               ENDIF
            ENDDO
C----
C----       get overlap of aligned sequences
C----
            IBEG=        MAX(1,   IFIR(JALIGN))
            IEND=        MIN(NRES,ILAS(JALIGN))

C----       ini new value for sequence similarity
            NRES_OVERLAP=0
            SIM(JALIGN)= 0
            SIM_XX(JALIGN)= 0
         
            DO IRES=IBEG,IEND
               IF ( (JALIGN_SEQ(IRES) .NE. 0) .AND.
     +              (JALIGN_SEQ(IRES) .NE. 0) ) THEN
                  NRES_OVERLAP=NRES_OVERLAP+1
C---- 
C----             sequence similarity
C---- 
C                  SIM(JALIGN)=SIM(JALIGN)+
C     +                 MATRIX(IALIGN_SEQ(IRES),JALIGN_SEQ(IRES),1,1,1,1)
C                  SIM(JALIGN)=SIM(JALIGN)+
C     +                 CONSWEIGHT(IRES)*
C     +                 MATRIX(IALIGN_SEQ(IRES),JALIGN_SEQ(IRES),1,1,1,1)
                  SIM(JALIGN)=SIM(JALIGN)+
     +                 CONSWEIGHT(IRES)*
     +                 SIMCONSERV(IALIGN_SEQ(IRES),JALIGN_SEQ(IRES))
C                  SIM_XX(JALIGN)=SIM_XX(JALIGN)+
C     +                 MATRIX(IALIGN_SEQ(IRES),JALIGN_SEQ(IRES),1,1,1,1)
                  SIM_XX(JALIGN)=SIM_XX(JALIGN)+
     +                 SIMCONSERV(IALIGN_SEQ(IRES),JALIGN_SEQ(IRES))
               END IF
            END DO
C----
C----       normalise sequence similarity to ratio
C----
            SIM_XX2(JALIGN)=SIM_XX(JALIGN)
            IF (NRES_OVERLAP.GT.0)  
     +           SIM_XX2(JALIGN)=
     +                    SIM_XX2(JALIGN)/REAL(NRES_OVERLAP)
            
            
            NRES_OVERLAP=1+ILAS(JALIGN)-IFIR(JALIGN)
            
            IF (NRES_OVERLAP.GT.0)  
     +           SIM(JALIGN)=
     +                    SIM(JALIGN)/REAL(NRES_OVERLAP)
            IF (NRES_OVERLAP.GT.0)  
     +           SIM_XX(JALIGN)=
     +                    SIM_XX(JALIGN)/REAL(NRES_OVERLAP)
         ENDIF
C----    end of: exclude?
      ENDDO
C---- end loop over all sequences aligned to guide
      write(6,*)'xx upon leaving got:'
      DO I=1,NALIGN
         write(6,'(i3,a,f5.2,a,f5.2,a,f5.2)')
     +        i,'xx sim=',SIM(i),' xx=',SIM_XX(i),
     +        ' nnt=',sim_xx2(i)
      END DO
      do i=1,22
C         write(6,'(i2,22i3)')i,(int(100*MATRIX(i,j,1,1,1,1)),j=1,22)
         write(6,'(i2,22i3)')i,(int(100*SIMCONSERV(i,j)),j=1,22)
      enddo
      stop

      write(6,*)'xx dia'
      write(6,'(22i4)')(int(100*MATRIX(j,j,1,1,1,1)),j=1,22)
      
      stop
      
Cxxx      

      WRITE(6,*)  '--- GETSEQSIM_BR ended'
      RETURN
      END
C     END GETSEQSIM_BR 
C......................................................................


C......................................................................
C     SUB IDENTITY
      SUBROUTINE IDENTITY(BEGIN,END,CGAPCHAR,SEQ1,SEQ2,IDE1,NOVERLAP)
C 26.10.92
      IMPLICIT      NONE
C Import
      INTEGER       BEGIN,END
      CHARACTER*1   CGAPCHAR
      CHARACTER*(*) SEQ1,SEQ2
C Export
      INTEGER       NOVERLAP
      REAL          IDE1
C Internal
      INTEGER       I,NIDE
      CHARACTER*1   C1, C2
 
      NOVERLAP= 0
      NIDE=     0
      
      DO I= BEGIN,END
         C1= SEQ1(I:I)
         C2= SEQ2(I:I)
         CALL LOWTOUP(C1,1)
         CALL LOWTOUP(C2,1)
         IF ( C1 .NE. CGAPCHAR .AND. C2 .NE. CGAPCHAR )  THEN
            NOVERLAP = NOVERLAP + 1
            IF ( C1 .EQ. C2 ) NIDE = NIDE + 1
         ENDIF
      ENDDO

      IF ( NOVERLAP .GT. 0 ) THEN
         IDE1 = FLOAT(NIDE) / FLOAT(NOVERLAP)
      ELSE
         WRITE(*,'(A)')
     1        ' ** sequences with no overlap : %ide set to 0 **'
         IDE1 = 0.0
      ENDIF
 
      RETURN
      END
C     END IDENTITY
C......................................................................
 
C......................................................................
C     SUB MAKE_HSSP
      SUBROUTINE MAKE_HSSP(MAXRES,MAXALIGNS,
     +     MAXCORE,MAXAA,MAXINS,MAXINSBUF,
     +     KOUT,OUTNAME,INFILE,PDBID,HEADER,
     +     COMPOUND,SOURCE,AUTHOR,ALILEN,NCHAIN,KCHAIN,
     +     CHAINREMARK,NALIGN,EXCLUDEFLAG,EMBLID,STRID,
     +     IDE,SIM,IFIR,ILAS,JFIR,JLAS,LALI,NGAP,LGAP,
     +     LENSEQ,ACCNUM_HSSP,PROTNAME,PDBNO,PDBSEQ,CHAINID,
     +     SECSTR_HSSP,COLS,SHEETLABEL,BP1,BP2,ACC,NOCC,
     +     VAR,ALISEQ,ALIPOINTER,SEQPROF,NDEL,NINS,ENTROPY,
     +     RELENT,CONSWEIGHT_MIN,CONSWEIGHT,LCONSERV,LOLDVERSION,
     +     CGAPCHAR,LFILTER,METRICFILE, LDOCLIP,
     +     INSNUMBER,INSALI,INSPOINTER,INSLEN,INSBEG_1,
     +     INSBEG_2,INSBUFFER,DO_INIT_INSBUF,ERROR,
     +     LHSSP_LONG_ID)
C 26.10.92
C 5.7.93 write insertion lists
C---- ------------------------------------------------------------------
      IMPLICIT        NONE
C Import
      INTEGER         MAXRES,MAXALIGNS,MAXCORE,MAXAA,MAXINS,MAXINSBUF,
     +                NALIGN
C HSSP descricptiption variables
      LOGICAL         LCONSERV,LOLDVERSION,LHSSP_LONG_ID
C attributes of sequence with known structure
      CHARACTER       PDBSEQ(MAXRES),CHAINID(MAXRES),
     +                SECSTR_HSSP(MAXRES),SHEETLABEL(MAXRES)
      CHARACTER*(*)   PDBID,COLS(MAXRES),HEADER,
     +                COMPOUND,SOURCE,AUTHOR,CHAINREMARK
      INTEGER         NCHAIN, KCHAIN, NREAD,ACC(MAXRES),
     +                PDBNO(MAXRES),BP1(MAXRES),BP2(MAXRES)
C attributes of aligned sequences
      INTEGER         IFIR(MAXALIGNS), ILAS(MAXALIGNS),
     +                ALIPOINTER(MAXALIGNS),
     +                INSNUMBER,INSALI(MAXINS),INSPOINTER(MAXINS),
     +                INSLEN(MAXINS),INSBEG_1(MAXINS),INSBEG_2(MAXINS)
      CHARACTER       INSBUFFER(MAXINSBUF),ALISEQ(MAXCORE),
     +                EXCLUDEFLAG(MAXALIGNS)
      CHARACTER*(*)   STRID(MAXALIGNS),ACCNUM_HSSP(MAXALIGNS),
     +                EMBLID(MAXALIGNS),PROTNAME(MAXALIGNS)
      INTEGER         JFIR(MAXALIGNS),JLAS(MAXALIGNS),
     +                LALI(MAXALIGNS),NGAP(MAXALIGNS),
     +                LGAP(MAXALIGNS),LENSEQ(MAXALIGNS)
      REAL            IDE(MAXALIGNS),SIM(MAXALIGNS)
C attributes of profile
      INTEGER         VAR(MAXRES),SEQPROF(MAXRES,MAXAA),RELENT(MAXRES),
     +                NOCC(MAXRES),NDEL(MAXRES),NINS(MAXRES)
      REAL            ENTROPY(MAXRES)
C threshold
      INTEGER         ISOLEN(100),NSTEP,ISAFE
      LOGICAL         LFORMULA,LALL
      REAL            CONSWEIGHT(MAXRES),ISOIDE(100),CONSWEIGHT_MIN
C .. and others
      INTEGER         KOUT,ALILEN
      CHARACTER       CGAPCHAR
      CHARACTER*(*)   OUTNAME,INFILE,METRICFILE
      LOGICAL         LFILTER, LDOCLIP, DO_INIT_INSBUF
C Export
C .. output to unit kout
      LOGICAL         ERROR
C Internal
      INTEGER         KSIM,CODELEN_LOC,NTRANS,MAXRES_LOC,
     +                MAXINS_LOC,MAXSTRSTATES,MAXIOSTATES
      PARAMETER      (KSIM=                     98)
      PARAMETER      (CODELEN_LOC=              40)
      PARAMETER      (MAXINS_LOC=            50000)
      PARAMETER      (MAXRES_LOC=             9999)
C      PARAMETER      (MAXRES_LOC=            10000)
C      PARAMETER      (MAXRES_LOC=            30011)
      PARAMETER      (NTRANS=                   26)
      PARAMETER      (MAXSTRSTATES=              3)
      PARAMETER      (MAXIOSTATES=               4)
      INTEGER         I, J, ISTART, IFIN,NPARALINE, CHANGEPOS,
     +                NSTRSTATES,NIOSTATES,NOVERLAP,
     +                SEQSTART,SEQSTOP, NDELETED,
     +                DELPOS(2,MAXINS_LOC),NDELPOS,NRES
C     comparison metric
      REAL            MATRIX (NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                        MAXSTRSTATES,MAXIOSTATES)
C     normalised to sum over 0 (by SETCONSERVATION)
      REAL            SIMCONSERV(NTRANS,NTRANS)
C
      REAL            IORANGE(MAXSTRSTATES,MAXIOSTATES,2),
     +                SMIN, SMAX, MAPLOW, MAPHIGH, THISIDE

      CHARACTER*(MAXRES_LOC)  SEQ1, SEQ2
      CHARACTER*(NTRANS)           TRANS
      CHARACTER*(CODELEN_LOC) PDBNAME
      CHARACTER*9     CDATE
      CHARACTER*80    ISOSIGFILE,DATABASE
      CHARACTER*132   CPARAMETER(5),HSSPLINE
      CHARACTER       CSTRSTATES*(MAXSTRSTATES),CIOSTATES*(MAXIOSTATES)
      LOGICAL         LINSERT, LDELETE

C----
C---- only used to get rid of INDEX command (CPU time)
C----
      INTEGER         NASCII
      PARAMETER      (NASCII=                  256)
      INTEGER         MATPOS(NASCII)


C---- ------------------------------------------------------------------
C---- 
C---- initialise
C---- 
      LFORMULA=    .FALSE.
      LALL=        .TRUE.
      LCONSERV=    .FALSE.
      LOLDVERSION= .FALSE.
C---- 
      SMIN=        0.0 
      SMAX=        1.0 
      MAPLOW=      0.0 
      MAPHIGH=     0.0
      CSTRSTATES=  ' ' 
      CIOSTATES=   ' '
C---- 
      HSSPLINE='HSSP       HOMOLOGY DERIVED SECONDARY STRUCTURE ' //
     1     'OF PROTEINS , VERSION 1.0 1991'
      CALL STRPOS(INFILE,ISTART,IFIN)
      DATABASE=    'SEQBASE    ' // INFILE(ISTART:IFIN)
      HEADER=      ' '
      COMPOUND=    ' '
      SOURCE=      ' '
      AUTHOR=      ' '
      CHAINREMARK= ' '
      ISOSIGFILE=  'ALL'
      NPARALINE=   1
      LFILTER=     .FALSE.
C---- 
      TRANS='VLIMFWYGAPSTCHRKQENDBZX!-.'
C---- 
      CALL CHOOSE_NAME(EMBLID,NALIGN,CHANGEPOS)
      LINSERT=     .FALSE.
      LDELETE=     .TRUE.
      SEQSTART=    0
      SEQSTOP=     0
      PDBSEQ(1)=   ' '
      PDBNAME=     ' '
C---- 
C---- ------------------------------------------------------------------
C---- 
C---- 
C delete the master sequence from aliseq data structure
C ( later restore it .. could be done more clever !! )
C---- also returns PDBSEQ=

      CALL CHANGE_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,MAXRES,
     1     LINSERT,LDELETE,CHANGEPOS,NALIGN,
     +     PDBSEQ,SEQSTART,SEQSTOP,PDBNAME,
     2     ALILEN,ALISEQ,ALIPOINTER,
     +     IFIR,ILAS,JFIR,JLAS,LALI,NGAP,LGAP,LENSEQ,STRID,
     3     IDE,SIM,EXCLUDEFLAG,ACCNUM_HSSP,EMBLID,PROTNAME,INSALI,
     5     INSNUMBER)
C      write(6,'(a)')'xx after change_aliseq pdb='
C      write(6,'(40a1)')(PDBSEQ(I),I=SEQSTART,SEQSTOP)
C----  br 99-03: tried to be smart, failed
C      EXCLUDEFLAG(CHANGEPOS)='*'

      IF ( LDOCLIP ) THEN
C remove gaps from master sequence
         LDELETE= .TRUE.
C hack br: 99-12
         DO I=1,ALILEN
            SEQ1(I:I)=PDBSEQ(I)
         END DO
         CALL MARK_LOC_RUNS(LDELETE,SEQ1,1,ALILEN,CGAPCHAR,
     1        DELPOS,NDELETED,NDELPOS)
 
C .. and delete gapped stretches in ALL alignments; 
C...     save them in "insbuffer"
C >>> THIS IS A IRREVERSIBLE CHANGE TO "ALISEQ" <<<<<<<<<<<<<<<<<<<<<
         IF (NDELPOS .GT. 0) THEN
            CALL CLIP_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,
     1           MAXINSBUF,ALISEQ,ALIPOINTER,NALIGN,CGAPCHAR,
     2           ALILEN,IFIR,ILAS,JFIR,JLAS,DELPOS,NDELPOS,
     3           INSNUMBER,INSALI,INSPOINTER,INSLEN,INSBEG_1,
     4           INSBEG_2,INSBUFFER,ERROR)
            IF ( ERROR ) STOP
            DO J = 1,ALILEN
               PDBSEQ(J)= SEQ1(J:J)
            ENDDO
         ELSE
C            write(6,*)'xx clip 2 alilen=',alilen
            DO J = 1,ALILEN
               SEQ1(J:J)=PDBSEQ(J)
C               write(6,*)'xx pdbseq(j=',j,')=',pdbseq(j)
            ENDDO
         ENDIF

C         WRITE(6,*)'XX AFTER CLIP STRPOS PDB='
C         WRITE(6,'(40A1)')(PDBSEQ(I),I=1,ALILEN)
      ENDIF
 
      CALL STRPOS(PDBNAME,ISTART,IFIN)
      PDBID = PDBNAME(ISTART:IFIN)
      CPARAMETER(1) = ' CONVERTSEQ of ' // pdbname(istart:IFIN)
 
      IF (LHSSP_LONG_ID) THEN
         NPARALINE=NPARALINE+1
         CPARAMETER(NPARALINE)='  LONG-ID : YES'
      ENDIF
      
      LDELETE = .FALSE.
      DO I= 1,NALIGN
         SEQ2 =          ' '
         CALL GET_SEQ_FROM_ALISEQ(ALISEQ,IFIR,ILAS,ALIPOINTER,
     1        ALILEN,I,SEQ2,NREAD,ERROR)
         IF ( ERROR ) STOP
         CALL IDENTITY(IFIR(I),ILAS(I),CGAPCHAR,SEQ1,SEQ2,THISIDE,
     1        NOVERLAP)
         IDE(I)=         THISIDE
         LALI(I)=        ILAS(I)-IFIR(I)+1
         CALL MARK_LOC_RUNS(LDELETE,SEQ2,IFIR(I),ILAS(I),
     1        CGAPCHAR,DELPOS,LGAP(I),NGAP(I))
         SEQ2 =          ' '
         JFIR(I)=        1
         JLAS(I)=        LALI(I)-LGAP(I)
         LENSEQ(I)=      JLAS(I)
         PROTNAME(I)=    ' '
         EXCLUDEFLAG(I)= ' '
         STRID(I)=       ' '
         ACCNUM_HSSP(I)= ' '
      ENDDO
      DO I = 1,ALILEN
         SECSTR_HSSP(I)= ' '
         SHEETLABEL(I)=  ' '
         CHAINID(I)=     ' '
         PDBNO(I)=       I
         COLS(I)=        ' '
         ACC(I)=         0
         BP1(I)=         0
         BP2(I)=         0
         CONSWEIGHT(I)=  1.0
      ENDDO
      CALL GETDATE(CDATE)
      ISAFE=             0
      NRES=              ALILEN

C---- 
C---- get similarity metric and scale according to smin/smax
C---- 
      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,
     +     MAXIOSTATES,NSTRSTATES,NIOSTATES,
     +     NSTRSTATES,NIOSTATES,CSTRSTATES,
     +     CIOSTATES,IORANGE,KSIM,METRICFILE,MATRIX)
C---- 
C---- 98-10: br & rs 
C---- normalise MATRIX -> SIMCONSERV
C----    such that SIMCONSERV has an average of 0
C---- 
      CALL SETCONSERVATION(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES,NIOSTATES,CSTRSTATES,CIOSTATES,IORANGE,KSIM,
     +     METRICFILE,MATRIX,SIMCONSERV)
C---- 
C---- 98-10: br
C---- 98-10: br & rs 
C---- compile conservation weights
C---- 99-03: br add sequence similarity
C---- 
C      WRITE(6,*)'XX BEFORE CONS PDB='
C      WRITE(6,'(40A1)')(PDBSEQ(I),I=1,NRES)

      CALL GETCONSWEIGHT_BR(MAXSTRSTATES,MAXIOSTATES,
     +     MAXRES,MAXALIGNS,MAXCORE,NTRANS,NASCII,NALIGN,NRES,
     +     IDE,IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
     +     EXCLUDEFLAG,TRANS,MATRIX,SIMCONSERV,MATPOS,
     +     CONSWEIGHT_MIN,CONSWEIGHT)
C      STOP 'xx after get cons'
C---- 
C---- rescale metric
C---- 
      CALL SCALEMETRIC(NTRANS,TRANS,MAXSTRSTATES,
     +     MAXIOSTATES,MATRIX,SMIN,SMAX,MAPLOW,MAPHIGH)

C----        xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C---- 
C---- 99-03: br add sequence similarity
Cxxxxxxxxx   wanted to, failed...
C----        xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C---- 
C      CALL GETSEQSIM_BR(MAXSTRSTATES,MAXIOSTATES,
C     +     MAXRES,MAXALIGNS,NTRANS,NASCII,NALIGN,NRES,
C     +     IFIR,ILAS,LALI,ALIPOINTER,PDBSEQ,ALISEQ,
C     +     EXCLUDEFLAG,TRANS,MATRIX,SIMCONSERV,MATPOS,SIM,
C     +     CONSWEIGHT)
C----        xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C---- 
C---- calculate variability
C---- 
      CALL CALC_VAR(NALIGN,ALILEN,PDBSEQ,IDE,IFIR,
     +     ILAS,ALIPOINTER,ALISEQ,EXCLUDEFLAG,
     +     MAXSTRSTATES,MAXIOSTATES,NTRANS,TRANS,
     +     MATRIX,VAR)
C---- 
C---- profiles
C---- 
      CALL CALC_PROF(MAXRES,MAXAA,ALILEN,PDBSEQ,NALIGN,
     +     EXCLUDEFLAG,IDE,IFIR,ILAS,
     +     ALISEQ,ALIPOINTER,TRANS,
     +     SEQPROF,NOCC,NDEL,NINS,ENTROPY,RELENT)
C---- 
C---- finally write the HSSP file
C---- 

C---- write header
      CALL HSSPHEADER(KOUT,OUTNAME,HSSPLINE,PDBID,CDATE,
     +     DATABASE,CPARAMETER,NPARALINE,
     +     ISOSIGFILE,ISAFE,LFORMULA,
     +     HEADER,COMPOUND,SOURCE,AUTHOR,ALILEN,
     +     NCHAIN,KCHAIN,CHAINREMARK,NALIGN)

C---- write data (alignments)
      CALL WRITE_HSSP(KOUT,MAXRES,NALIGN,ALILEN,EMBLID,STRID,
     +     ACCNUM_HSSP,IDE,SIM,IFIR,ILAS,JFIR,JLAS,
     +     LALI,NGAP,LGAP,LENSEQ,PROTNAME,ALIPOINTER,
     +     ALISEQ,PDBNO,CHAINID,PDBSEQ,SECSTR_HSSP,COLS,
     +     BP1,BP2,SHEETLABEL,ACC,NOCC,VAR,SEQPROF,
     +     NDEL,NINS,ENTROPY,RELENT,CONSWEIGHT,
     +     INSNUMBER,INSALI,INSPOINTER,INSLEN,
     +     INSBEG_1,INSBEG_2,INSBUFFER,ISOLEN,
     +     ISOIDE,NSTEP,LFORMULA,LALL,ISAFE,
     +     EXCLUDEFLAG,LCONSERV,LHSSP_LONG_ID)
 
C finally restore aliseq data structure (! THINK OF SOMETHING BETTER ! )
      LINSERT = .TRUE.
      LDELETE = .FALSE.
      CALL CHANGE_ALISEQ(MAXALIGNS,MAXCORE,MAXINS,MAXRES,LINSERT,
     1     LDELETE,CHANGEPOS,NALIGN,PDBSEQ,SEQSTART,SEQSTOP,
     2     PDBNAME,ALILEN,ALISEQ,ALIPOINTER,IFIR,ILAS,JFIR,
     3     JLAS,LALI,NGAP,LGAP,LENSEQ,STRID,IDE,SIM,
     4     EXCLUDEFLAG,ACCNUM_HSSP,EMBLID,PROTNAME,INSALI,
     5     INSNUMBER)
 
      RETURN
      END
C     END MAKE_HSSP
C......................................................................
 
C......................................................................
C     SUB MARK_DUPLICATES
      SUBROUTINE MARK_DUPLICATES(LIST,NENTRIES)
C 12.8.93
      IMPLICIT        NONE
C Import
      INTEGER         NENTRIES
C Import / Export
      CHARACTER*(*)   LIST(*)
C Internal
      INTEGER         ENTRYLEN
      PARAMETER      (ENTRYLEN=                 41)
      INTEGER         I,J,ISTART,ISTOP,JSTART,JSTOP,NTIMES
      CHARACTER*(ENTRYLEN) CSTRING
*----------------------------------------------------------------------*
      
      
      DO J = 1,NENTRIES-1
         NTIMES = 1
         CALL STRPOS(LIST(J),JSTART,JSTOP)
         DO I = J+1,NENTRIES
            CALL STRPOS(LIST(I),ISTART,ISTOP)
            IF ( LIST(J)(JSTART:JSTOP) .EQ.
     1           LIST(I)(ISTART:ISTOP)      ) THEN
               NTIMES = NTIMES + 1
               CALL CONCAT_STRING_INT(LIST(I),NTIMES,CSTRING)
               LIST(I)(1:40) = CSTRING(1:40)
            ENDIF
         ENDDO
      ENDDO
 
      RETURN
      END
C     END MARK_DUPLICATES
C......................................................................
 
C......................................................................
C     SUB MARK_LOC_RUNS
***** ------------------------------------------------------------------
***** SUB MARK_LOC_RUNS
***** ------------------------------------------------------------------
C---- 
C---- NAME : MARK_LOC_RUNS
C---- ARG  : 1 LDELETE=       logical if true: delete from sequence
C---- ARG  : 2 SEQUENCE=      string
C---- ARG  : 3 IBEG=          first residue position in SEQUENCE
C---- ARG  : 4 IEND=          last residue position in SEQUENCE
C---- ARG  : -->              SEQUENCE(IBEG:IEND)
C---- ARG  : 5 SYMBOL         character to search (count and delete)
C---- ARG  : 6 RUNPOS         
C---- ARG  : 7 RUNLEN         
C---- ARG  : 8 NRUN           number of occurrences of SYMBOL in 
C---- ARG  :                  SEQUENCE
C---- DES  : Checks how often SYMBOL occurs in SEQUENCE, possibly
C---- DES  : deletes it (e.g. remove insertions!)
C---- 
*----------------------------------------------------------------------*
      SUBROUTINE MARK_LOC_RUNS(LDELETE,SEQUENCE,IBEG,IEND,
     1     SYMBOL,RUNPOS,RUNLEN,NRUN)
C 5.7.93
C 20.10. only internal runs
      IMPLICIT        NONE
C Import
C ..  "begin", "end" is left unchanged, 
C     even if some positions are actually deleted !!
      INTEGER         IBEG, IEND

      INTEGER         RUNLEN
      CHARACTER*1     SYMBOL
      LOGICAL         LDELETE

C Import/Export
      CHARACTER*(*)   SEQUENCE
C Export
      INTEGER         NRUN
      INTEGER         RUNPOS(2,*)
C Internal
      INTEGER         LAST_NONSYMBOL,IPOS,JPOS,RLEN,IRUN
      LOGICAL         INSIDE, IS_LOC_RUN
******------------------------------*-----------------------------******
 
C---- ini
      NRUN=          0
      RUNLEN=        0
      INSIDE=        .FALSE.
      IS_LOC_RUN=    .FALSE.
      LAST_NONSYMBOL=IEND
C---- 
C---- loop over all residues of sequence
C----    
C----    NRUN=        number of occurrences of SYMBOL
C----    RUNPOS(1,i)= [i=1,NRUN] the position of the ith occurrence
C----    RUNPOS(2,i)= [i=1,NRUN] ?? 
C----    LAST_NONSYMBOL=position of the last NON-hit (counts up)
C----    

      DO IPOS=IBEG,IEND
C------- is insertion ('.')
         IF ( SEQUENCE(IPOS:IPOS) .EQ. SYMBOL .AND. 
     +        IS_LOC_RUN .EQV. .TRUE. ) THEN
            IF ( .NOT. INSIDE ) THEN
               INSIDE=         .TRUE.
               NRUN=           NRUN + 1
               RUNPOS(1,NRUN)= IPOS
               RUNPOS(2,NRUN)= 0
            ENDIF
            RUNPOS(2,NRUN)=    RUNPOS(2,NRUN) + 1
            RUNLEN=            RUNLEN + 1
C------- is NOT insertion
         ELSE IF ( SEQUENCE(IPOS:IPOS) .NE. SYMBOL ) THEN
C---------- reset flag
            IF ( INSIDE )      INSIDE = .FALSE.
            IS_LOC_RUN=        .TRUE.
            LAST_NONSYMBOL=    IPOS
         ENDIF
      ENDDO

C---- trailing insertion - DO NOT COUNT
C----    -> reduce by 1!
      IF (NRUN.GT.0) THEN
         IF ( RUNPOS(1,NRUN) .EQ. LAST_NONSYMBOL+1 ) THEN
            NRUN=NRUN - 1
         ENDIF
      ENDIF
      
      IF ( LDELETE .AND. (NRUN.GT.0) ) THEN
         RLEN = 0
         IRUN = 1
         DO IPOS = IBEG,IEND
            IF ( IPOS .EQ. RUNPOS(1,IRUN) ) THEN
               DO JPOS = IPOS-RLEN,IEND-RUNPOS(2,IRUN)
                  SEQUENCE(JPOS:JPOS) =
     1                 SEQUENCE(JPOS+RUNPOS(2,IRUN):JPOS+RUNPOS(2,IRUN))
               ENDDO
               RLEN = RLEN + RUNPOS(2,IRUN)
               IRUN = IRUN + 1
            ENDIF
         ENDDO
      ENDIF
      RETURN
      END
C     END MARK_LOC_RUNS
C......................................................................
 
C......................................................................
C     SUB SETCONSERVATION
      SUBROUTINE SETCONSERVATION(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES,NIOSTATES,CSTRSTATES,CIOSTATES,IORANGE,KSIM,
     +     METRIC_FILENAME,MATRIX,SIMCONSERV)
C 1. set conservation weights to 1.0
C 2. rescale matrix for the 22 amino residues such that the sum over
C    the matrix is 0.0 (or near)
C this matrix is used to calculate the conservation weights (SIMCONSERV)
c	implicit none
C import
      CHARACTER*(*)   METRIC_FILENAME
      REAL            MATRIX(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +                      MAXSTRSTATES,MAXIOSTATES)
      REAL            SIMCONSERV(1:26,1:26)
      INTEGER         NSTRSTATES,NIOSTATES,KSIM
      CHARACTER*(*)   CSTRSTATES,CIOSTATES
      REAL            IORANGE(MAXSTRSTATES,MAXIOSTATES)
     
C internal
      INTEGER         NACID,MAXSQ
      PARAMETER      (NACID=                    22)
      PARAMETER      (MAXSQ=                  9999)
C      PARAMETER      (MAXSQ=                 30111)
C      PARAMETER      (MAXSQ=                100000)

      CHARACTER       TRANS*26

      INTEGER         I,J
      REAL            XLOW,XHIGH,XMAX,XMIN,XFACTOR,SUMMAT
      REAL            CONSWEIGHT_1(MAXSQ),CONSWEIGHT_2(MAXSQ),CONSMIN
      LOGICAL         LFIRSTWEIGHT
*----------------------------------------------------------------------*

C
      DO I=1,MAXSQ 
         CONSWEIGHT_1(I)=1.0
      ENDDO
      LFIRSTWEIGHT=.TRUE.

C     get metric
C     98-10 br: already done
C      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
C     +     NSTRSTATES,NIOSTATES,NSTRSTATES,NIOSTATES,
C     +     CSTRSTATES,CIOSTATES,IORANGE,KSIM,METRIC_FILENAME,MATRIX)

c     rescale matrix that the sum over matrix is +- 0.0 
      XLOW=     0.0 
      XHIGH=    0.0
      XMAX=     1.0 
      XMIN=    -1.0 
      XFACTOR=100.0
	
C (re)store original values in simconserv()
 20   DO J=1,NTRANS 
         DO I=1,NTRANS
            SIMCONSERV(I,J)=MATRIX(I,J,1,1,1,1) 
         ENDDO
      ENDDO
c scale with xmin/xmax
      CALL SCALEINTERVAL(SIMCONSERV,NTRANS**2,XMIN,XMAX,XLOW,XHIGH)
C RESEt the values for 'X' '!' and '-'
      I=INDEX(TRANS,'X')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'!')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'-')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'.')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
C calculate sum over matrix (22 amino acids) after scaling
      SUMMAT=0.0
      DO I=1,NACID 
         DO J=1,NACID
            SUMMAT=SUMMAT+SIMCONSERV(I,J)
         ENDDO
      ENDDO
cd	write(*,*)' sum: ',summat,xmin
c check sum=0.0 (+- 0.01) ; if not xmin=xmin/2 ; scale again
      IF (SUMMAT .GT. 0.01) THEN
         XMIN=XMIN+(XMIN/XFACTOR)
      ELSE IF (SUMMAT .LT. -0.01) THEN
         XMIN=XMIN-(XMIN/XFACTOR)
      ELSE
         WRITE(*,*)' SETCONSERVATION: sum over matrix: ',summat
         WRITE(*,*)'                  smin is : ',xmin
         RETURN
      ENDIF
      GOTO 20
      END
C     END SETCONSERVATION
C......................................................................

C......................................................................
C     SUB STRREPLACE
      SUBROUTINE STRREPLACE(STRING,LENGTH,C1,C2)
c	Implicit None
C replaces all occurences of c1 by c2
 
C Import
      INTEGER         LENGTH
      CHARACTER*1     C1, C2
C Import/Export
      CHARACTER*(*)   STRING
C Internal
      INTEGER IPOS
      
      DO IPOS = 1,LENGTH
         IF ( STRING(IPOS:IPOS) .EQ. C1 ) STRING(IPOS:IPOS) = C2
      ENDDO
 
      RETURN
      END
C     END STRREPLACE
C......................................................................
 
C......................................................................
C     SUB WRITE_DAF
      SUBROUTINE WRITE_DAF(KUNIT,INFILE,OUTFILE,MAXALIGNS,MAXRES,
     1     MAXCORE,MAXINS,MAXINSBUF,BEGIN,END,ALISEQ,
     2     ALIPOINTER,IDE,IFIR,ILAS,EMBLID,WEIGHT,
     3     ALILEN,NSEQ,LALI,INSNUMBER,INSALI,INSPOINTER,
     4     INSLEN,INSBEG_1,INSBUFFER,ERROR)

      IMPLICIT        NONE
C---- import
      INTEGER         MAXALIGNS,MAXRES,MAXCORE,MAXINS,MAXINSBUF,
     +                KUNIT,BEGIN,END,NSEQ,ALILEN,INSNUMBER
      INTEGER         ALIPOINTER(MAXALIGNS),LALI(MAXALIGNS),
     +                IFIR(MAXALIGNS),ILAS(MAXALIGNS),
     +                INSALI(MAXINS),INSPOINTER(MAXINS),
     +                INSLEN(MAXINS),INSBEG_1(MAXINS)
      CHARACTER*(*)   INFILE, OUTFILE
      CHARACTER*(*)   EMBLID(MAXALIGNS)
      CHARACTER       ALISEQ(MAXCORE),INSBUFFER(MAXINSBUF)
      REAL            WEIGHT(MAXALIGNS),IDE(MAXALIGNS)
C---- export
      LOGICAL         ERROR
C---- internal
      INTEGER         LINELEN,MAXRES_INTERN,MAXALIGNS_INTERN
      PARAMETER      (MAXRES_INTERN=          9999)
C      PARAMETER      (MAXRES_INTERN=         10000)
C      PARAMETER      (MAXRES_INTERN=         30011)
      PARAMETER      (LINELEN=               22000)
      PARAMETER      (MAXALIGNS_INTERN=       8765)
C      PARAMETER      (MAXALIGNS_INTERN=      10000)
      INTEGER         CODELEN,I,J,ISTART,ISTOP,ISEQ,IINS,K,
     +                IPOS,JPOS,KPOS,LENSEQ(MAXALIGNS_INTERN)
      CHARACTER*8     TIMESTRING
      CHARACTER*9     DATESTRING
      CHARACTER*(LINELEN) LINE
      CHARACTER*(MAXRES_INTERN) STRAND,SEQ1_STRING
      CHARACTER*50    TRANS
C---- ------------------------------------------------------------------ 
C---- ini
      ERROR=  .FALSE.
      TRANS=  'VLIMFWYGAPSTCHRKQENDBZX.'
C---- try to open outfile; return if unsuccessful	
      CALL OPEN_FILE(KUNIT,OUTFILE,'new,recl=22000',error)
C---- error messages are alredy issued by OPEN_FILE
      IF (ERROR) RETURN
      IF (NSEQ.GT.MAXALIGNS) THEN
         WRITE(*,'(1X,A)') 'MAXALIGNS (global) overflow in write_daf !'
         ERROR = .TRUE.
         RETURN
      ENDIF
      IF (NSEQ.GT.MAXALIGNS_INTERN) THEN
         WRITE(*,'(1X,A)') 'MAXALIGNS (intern) overflow in write_daf !'
         ERROR= .TRUE.
         RETURN
      ENDIF
      IF (ALILEN.GT.MAXRES) THEN
         WRITE(*,'(1X,A)') 'MAXRES (global) overflow in write_daf !'
         ERROR= .TRUE.
         RETURN
      ENDIF
      IF (ALILEN.GT.MAXRES_INTERN ) THEN
         WRITE(*,'(1X,A)') 'MAXRES (intern) overflow in write_daf !'
         ERROR= .TRUE.
         RETURN
      ENDIF
C---- ------------------------------------------------------------------ 
C---- start
      CODELEN = 1
      DO I=1,NSEQ
         CALL STRPOS(EMBLID(I),ISTART,ISTOP)
         IF (ISTOP.GT.CODELEN) CODELEN=ISTOP+2
      ENDDO
      IF (CODELEN.GT.LEN(EMBLID(1))) CODELEN=LEN(EMBLID(1))
C----
C---- header
C----
      WRITE(KUNIT,'(A)') '# DAF (dirty alignment format)'
      CALL STRPOS(INFILE,ISTART,ISTOP)
      WRITE(KUNIT,'(A,A,A,I4,A,I4)')
     +     '# SOURCE:       converted from ',
     +     infile(istart:istop),' from: ',begin,' to: ',end
C---- get current date and time
      CALL GETDATE(DATESTRING)
      CALL GETTIME(TIMESTRING)
      WRITE(KUNIT,'(A,A,A)')
     1     '# DATE:         ',DATESTRING,TIMESTRING
      WRITE(KUNIT,'(A,A)')  '# ALISYM:       ',TRANS
      WRITE(KUNIT,'(A,I6)') '# NPAIRS:       ',NSEQ
      WRITE(KUNIT,'(A)') '#'
      WRITE(KUNIT,'(A)') '#'
      WRITE(KUNIT,'(A)') '# ALIGNMENTS'
      WRITE(KUNIT,'(A)') 'idSeq idStr lenSeq lenStr '//
     +     'lenAli pide seq str'
C----
C---- sequence information
C----
      DO ISEQ=2,NSEQ
         SEQ1_STRING=' '
         STRAND= ' '
         J = 1
         JPOS = ALIPOINTER(ISEQ)
         LENSEQ(ISEQ)=ILAS(ISEQ)-IFIR(ISEQ)+1
         DO IPOS = IFIR(ISEQ),ILAS(ISEQ)
            IF ( ICHAR(ALISEQ(JPOS)) .GT. 96 .AND.
     +           ICHAR(ALISEQ(JPOS)) .LT. 123) THEN
               STRAND(J:J) = ALISEQ(JPOS)
               CALL LOWTOUP(STRAND(J:J),1)
               SEQ1_STRING(J:J) = ALISEQ(IPOS)
               J = J + 1
               JPOS=JPOS+1
               DO IINS=1,INSNUMBER
                  IF(INSALI(IINS) .EQ. ISEQ .AND.
     +                 INSBEG_1(IINS) .EQ. IPOS)THEN
                     KPOS=INSPOINTER(IINS)+1
                     DO K=1,INSLEN(IINS)
                        STRAND(J:J) = INSBUFFER(KPOS)
                        SEQ1_STRING(J:J) = '.'
                        J=J+1
                        KPOS=KPOS+1
                     ENDDO
                  ENDIF
               ENDDO
            ELSE
               STRAND(J:J) = ALISEQ(JPOS)
               SEQ1_STRING(J:J) = ALISEQ(IPOS)
               J = J + 1
               JPOS=JPOS+1
            ENDIF
 
         ENDDO
         CALL STRPOS(STRAND,I,J)
 
C         WRITE(KUNIT,'(A,1X,A,1X,F7.1,1X,A,A,A)')
         WRITE(KUNIT,'(A,1X,A,1X,I6,I6,I6,F7.1,1X,A,A,A)')
     +        EMBLID(1)(1:CODELEN),
     +        EMBLID(ISEQ)(1:CODELEN),
     +        ALILEN,LALI(ISEQ),LENSEQ(ISEQ),
     +        (IDE(ISEQ)*100.0),SEQ1_STRING(I:J),'  ',STRAND(I:J)
 
      ENDDO
      CLOSE(KUNIT)
 
      RETURN
      END
C END WRITE_DAF...................................................

C......................................................................
C     SUB OPEN_FILE
      SUBROUTINE OPEN_FILE(IUNIT,INNAME,CSTRING,LERROR)
C     IMPLICIT NONE
C INPUT
C CSTATUS: 'OLD' OR 'NEW' OR 'UNKNOWN'
C CACCESS:  'APPEND' 'DIRECT'
C FORM:     'FORMATTED' OR 'UNFORMATTED'
C IRECLEN: RECORD LENGTH
C NOTE: AFTER OPENING A "OLD" OR "UNKNOWN" FILE (NO DIRECT ACESS): 
C       REWIND THE FILE, BECAUSE SOME STRANGE COMPILERS PUT THE FILE 
C       POINTER AT THE END !
C
      CHARACTER*(*) INNAME,CSTRING
      INTEGER IUNIT,IRECLEN
c output: lerror is true if open error
      LOGICAL LERROR
c internal
      CHARACTER*200 TEMPSTRING,CTEMP,FILENAME
      CHARACTER*10 CNUMBER
      LOGICAL LNEW,LAPPEND,LUNKNOWN
      LOGICAL LUNFORMATTED,LDIRECT
      LOGICAL LOPENDONE,LSILENT
      INTEGER LENGTH,I,J,K
c init
      TEMPSTRING=' '
      FILENAME=' '
      LNEW=.FALSE.
      LAPPEND=.FALSE.
      LERROR=.FALSE.
      LUNKNOWN=.FALSE.
      LUNFORMATTED=.FALSE.
      LDIRECT=.FALSE.
      LOPENDONE=.FALSE.
      LSILENT=.FALSE.
      IRECLEN=137
      TEMPSTRING(1:)=CSTRING(1:)
      CNUMBER='0123456789'
c
      LENGTH=LEN(TEMPSTRING)
      CALL LOWTOUP(TEMPSTRING,LENGTH)
      IF (INDEX(TEMPSTRING,'NEW').NE.0) THEN
         LNEW=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'UNKNOWN').NE.0) THEN
         LUNKNOWN=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'UNFORMATTED').NE.0) THEN
         LUNFORMATTED=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'DIRECT').NE.0) THEN
         LDIRECT=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'APPEND').NE.0) THEN
         LAPPEND=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'SILENT').NE.0) THEN
         LSILENT=.TRUE.
      ENDIF
      IF (INDEX(TEMPSTRING,'RECL=').NE.0) THEN
         CTEMP=' '
         K=INDEX(TEMPSTRING,'RECL=')+5
         CTEMP(1:)=TEMPSTRING(K:)
         CALL STRPOS(CTEMP,I,J)
         J=I
         DO WHILE (INDEX(CNUMBER,CTEMP(J:J)).NE.0 )
            J=J+1
         ENDDO
         J=J-1
         CALL READ_INT_FROM_STRING(CTEMP(I:J),IRECLEN)
      ENDIF

      CALL STRPOS(INNAME,IBEG,IEND)
      FILENAME(1:)=INNAME(IBEG:IEND)

      IF (LNEW) THEN
         CALL DEL_OLDFILE(IUNIT,FILENAME)
      ENDIF
      IF (LNEW .AND. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW .AND. LUNFORMATTED ) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED',
     +        ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',FORM='UNFORMATTED')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW .AND. (.NOT. LUNFORMATTED) .AND. LDIRECT ) THEN
         OPEN(IUNIT,FILE=FILENAME,ACCESS='DIRECT',STATUS='NEW',
     +        FORM='FORMATTED',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,ACCESS='DIRECT',STATUS='NEW',
C     +         FORM='FORMATTED',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. .NOT. LUNFORMATTED .AND. LDIRECT) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='FORMATTED',
     +        ACCESS='DIRECT',RECL=IRECLEN,ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='FORMATTED',
C     +	       ACCESS='DIRECT',RECL=IRECLEN)
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LUNFORMATTED ) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED',
     +        ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',FORM='UNFORMATTED')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSEIF (LNEW) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='NEW',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='NEW')
         REWIND(IUNIT)                         
         LOPENDONE=.TRUE.
      ELSEIF (LUNKNOWN .AND. LAPPEND) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ACCESS='APPEND',
     +        ERR=999)
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ACCESS='APPEND')
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN')
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW .AND. LAPPEND) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ACCESS='APPEND',ERR=999)
C	  OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ACCESS='APPEND')
         LOPENDONE=.TRUE.
      ELSEIF (.NOT. LNEW) THEN
         OPEN(IUNIT,FILE=FILENAME,STATUS='OLD',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='OLD')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ELSE
         OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN',ERR=999)
C          OPEN(IUNIT,FILE=FILENAME,STATUS='UNKNOWN')
         REWIND(IUNIT)
         LOPENDONE=.TRUE.
      ENDIF
      IF (.NOT. LOPENDONE) THEN
         WRITE(*,*)' ERROR IN OPEN_FILE: FILE NOT OPENED'
         WRITE(*,*)'  unknown specifier combination !'
         STOP
      ENDIF
      RETURN
 999  IF (.NOT. LSILENT) THEN
         WRITE(*,*)' ERROR: open file error for file: '
         WRITE(*,*)'name: ',FILENAME
         WRITE(*,*)'unit: ',iunit
      ENDIF
      LERROR=.TRUE.
      RETURN
      END
C     END OPEN_FILE
C......................................................................

C......................................................................
C     SUB CONCAT_STRINGS
      SUBROUTINE CONCAT_STRINGS(STRING1,STRING2,RESULT)
C concatenate "string1" and "string2" into "result"
      CHARACTER*(*) STRING1,STRING2,RESULT
      INTEGER IBEG,IEND,JBEG,JEND,ILEN

      RESULT=' '
      CALL STRPOS(STRING1,IBEG,IEND)
      CALL STRPOS(STRING2,JBEG,JEND)
      ILEN= (IEND-IBEG+1) + (JEND-JBEG+1)
      IF (ILEN .GT. LEN(RESULT) ) THEN
         ILEN=LEN(RESULT)
         write(*,*)' WARNING: in concat_strings: length overflow'
         write(*,*)'          cut string at: ',ilen
      ENDIF
      RESULT(1:ILEN)=STRING1(IBEG:IEND)//STRING2(JBEG:JEND)
      RETURN
      END
C     END CONCAT_STRINGS
C......................................................................

C......................................................................
C     SUB CONCAT_INT_STRING
      SUBROUTINE CONCAT_INT_STRING(INUMBER,STRING,RESULT)
C concatenate "inumber" and "string2" into "result"
C import/export
      CHARACTER*(*) STRING,RESULT
      INTEGER INUMBER
C internal
      CHARACTER TEMP*64,CFORMAT*100
      INTEGER IBEG,IEND,JBEG,JEND,ILEN,ILOG
C init
      TEMP=' '
      RESULT=' '
      ILOG=1
C get size of number

C CAUTION can produce wrong results with very high opt-levels
c	xnumber=float( inumber )
c	if (xnumber .gt. 0.0) then
c	  ilog = nint( log10(xnumber) + 0.5 )
c	else if (xnumber .lt. 0.0) then
c	  ilog = nint( log10( abs(xnumber) ) + 1.5 )
c	endif

      IF (INUMBER .GT. 0) THEN
         IF (INUMBER .LT. 10) THEN
            ILOG=1
         ELSE IF (INUMBER .LT. 100) THEN
            ILOG=2
         ELSE IF (INUMBER .LT. 1000) THEN
            ILOG=3
         ELSE IF (INUMBER .LT. 10000) THEN
            ILOG=4
         ELSE IF (INUMBER .LT. 100000) THEN
            ILOG=5
         ELSE IF (INUMBER .LT. 1000000) THEN
            ILOG=6
         ELSE IF (INUMBER .LT. 10000000) THEN
            ILOG=7
C too big for INT4 ?
c	   else if (inumber .lt. 100000000) then
c	      ilog=8
         ELSE
            write(*,*)' ERROR in CONCAT_INT_STRING: update plus'
            CALL FLUSH_UNIT(6)
         ENDIF
      ELSE IF (INUMBER .LT. 0) THEN
         IF (INUMBER .GT. -10) THEN
            ILOG=2
         ELSE IF (INUMBER .GT. -100) THEN
            ILOG=3
         ELSE IF (INUMBER .GT. -1000) THEN
            ILOG=4
         ELSE IF (INUMBER .GT. -10000) THEN
            ILOG=5
         ELSE IF (INUMBER .GT. -100000) THEN
            ILOG=6
         ELSE IF (INUMBER .GT. -1000000) THEN
            ILOG=7
c	   else if (inumber .gt. -10000000) then
c	      ilog=8
c	   else if (inumber .gt. -100000000) then
c	      ilog=9
         ELSE
            write(*,*)' ERROR in CONCAT_INT_STRING: update minus'
            CALL FLUSH_UNIT(6)
         ENDIF
      ENDIF
      CALL CONCAT_STRING_INT('(I',ILOG,TEMP)
      CALL CONCAT_STRINGS(TEMP,')',CFORMAT)
      TEMP=' '
      WRITE(TEMP(1:),CFORMAT)INUMBER
      CALL STRPOS(TEMP,IBEG,IEND)
      CALL STRPOS(STRING,JBEG,JEND)
      IEND=IBEG+ILOG-1
      ILEN= (IEND-IBEG+1) + (JEND-JBEG+1)
      IF (ILEN .GT. LEN(RESULT) ) THEN
         ILEN=LEN(RESULT)
         write(*,*)' WARNING: in concat_int_string: length overflow'
         write(*,*)'          cut string at: ',ilen
      ENDIF
      RESULT(1:ILEN)=TEMP(IBEG:IEND)//STRING(JBEG:JEND)
      RETURN
      END
C     END CONCAT_INT_STRING
C......................................................................

C......................................................................
C     SUB CONCAT_STRING_INT
      SUBROUTINE CONCAT_STRING_INT(STRING,INUMBER,RESULT)
C concatenate "inumber" and "string2" into "result"
C import/export
      CHARACTER*(*) STRING,RESULT
      INTEGER INUMBER
C internal
      CHARACTER TEMP*64,CFORMAT*100
      INTEGER IBEG,IEND,JBEG,JEND,ILEN,ILOG
C init
      TEMP=' '
      RESULT=' '
      ILOG=1
C get size of number
c with some agressive optimizations, this can go wrong
c	xnumber=float( inumber )
c	if (xnumber .gt. 0.0) then
c	  ilog = nint( log10(xnumber) ) + 1
c	else if (xnumber .lt. 0.0) then
c	  ilog = nint( log10( abs(xnumber) ) ) + 2
c	endif

      IF (INUMBER .GT. 0) THEN
         IF (INUMBER .LT. 10) THEN
            ILOG=1
         ELSE IF (INUMBER .LT. 100) THEN
            ILOG=2
         ELSE IF (INUMBER .LT. 1000) THEN
            ILOG=3
         ELSE IF (INUMBER .LT. 10000) THEN
            ILOG=4
         ELSE IF (INUMBER .LT. 100000) THEN
            ILOG=5
         ELSE IF (INUMBER .LT. 1000000) THEN
            ILOG=6
         ELSE IF (INUMBER .LT. 10000000) THEN
            ILOG=7
C too big for INT4 ?
c	   else if (inumber .lt. 100000000) then
c	      ilog=8
c	   else if (inumber .lt. 1000000000) then
c	      ilog=9
c	   else if (inumber .lt. 10000000000) then
c	      ilog=10
         ELSE
            write(*,*)' ERROR in CONCAT_STRING_INT: update plus'
            CALL FLUSH_UNIT(6)
         ENDIF
      ELSE IF (INUMBER .LT. 0) THEN
         IF (INUMBER .GT. -10) THEN
            ILOG=2
         ELSE IF (INUMBER .GT. -100) THEN
            ILOG=3
         ELSE IF (INUMBER .GT. -1000) THEN
            ILOG=4
         ELSE IF (INUMBER .GT. -10000) THEN
            ILOG=5
         ELSE IF (INUMBER .GT. -100000) THEN
            ILOG=6
         ELSE IF (INUMBER .GT. -1000000) THEN
            ILOG=7
c	   else if (inumber .gt. -10000000) then
c	      ilog=8
c	   else if (inumber .gt. -100000000) then
c	      ilog=9
c	   else if (inumber .gt. -1000000000) then
c	      ilog=10
         ELSE
            write(*,*)' ERROR in CONCAT_STRING_INT: update minus'
            CALL FLUSH_UNIT(6)
         ENDIF
      ENDIF
      
      CALL MAKE_FORMAT_INT(ILOG,CFORMAT)
      WRITE(TEMP(1:),CFORMAT)INUMBER
      CALL STRPOS(TEMP,IBEG,IEND)
      CALL STRPOS(STRING,JBEG,JEND)
      IEND=IBEG+ILOG-1
      ILEN= (IEND-IBEG+1) + (JEND-JBEG+1)
      IF (ILEN .GT. LEN(RESULT) ) THEN
         ILEN=LEN(RESULT)
         write(*,*)' WARNING: in concat_int_string: length overflow'
         write(*,*)'          cut string at: ',ilen
      ENDIF
      RESULT(1:ILEN)=STRING(JBEG:JEND)//TEMP(IBEG:IEND)
      RETURN
      END
C     END CONCAT_STRING_INT
C......................................................................

C......................................................................
C     SUBR DEL_OLDFILE
      SUBROUTINE DEL_OLDFILE(IUNIT,FILENAME)
      CHARACTER*(*) FILENAME
      INTEGER IUNIT
      LOGICAL LEXIST,LOPEN
      INTEGER IBEG,IEND
      CHARACTER*100 TEMPNAME
      
      TEMPNAME=' '
      CALL STRPOS(FILENAME,IBEG,IEND)
      TEMPNAME(1:)=FILENAME(IBEG:IEND)
      INQUIRE(FILE=TEMPNAME,OPENED=LOPEN)
      IF (LOPEN) THEN
         CLOSE(IUNIT)
      ENDIF
      INQUIRE(FILE=TEMPNAME,EXIST=LEXIST)
      IF (LEXIST) THEN
         OPEN(IUNIT,FILE=TEMPNAME,STATUS='OLD')
         CLOSE(IUNIT,STATUS='DELETE')
      ENDIF
      RETURN
      END
C     END DEL_OLDFILE
C......................................................................

C......................................................................
C     SUB FLUSH_unit
      SUBROUTINE FLUSH_UNIT(IUNIT)
      INTEGER IUNIT
      
      CALL FLUSH(IUNIT)
      
      RETURN
      END
C     END FLUSH
C......................................................................

C......................................................................
C     SUB GET_ARG_NUMBER  
C     returns number of arguments
C     UNIX version
      SUBROUTINE GET_ARG_NUMBER(INUMBER)
      INTEGER INUMBER

      INUMBER=0
      INUMBER=IARGC()
      RETURN 
      END
C     END GET_ARG_NUMBER
C......................................................................

C......................................................................
C     SUB GET_ARGUMENT  
C     returns the content of x-th argument
C     UNIX version
      SUBROUTINE GET_ARGUMENT(INUMBER,ARGUMENT)
      CHARACTER*(*) ARGUMENT
      INTEGER INUMBER

      CALL GETARG(INUMBER,ARGUMENT)
      RETURN 
      END
C     END GET_ARGUMENT
C......................................................................

C......................................................................
C     SUB GETSIMMETRIC
      SUBROUTINE GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,NIOSTATES_2,
     +     CSTRSTATES,CIOSTATES,
     +     IORANGE,KSIM,SIMFILE,SIMMETRIC)
      
      IMPLICIT NONE
C import
      INTEGER NTRANS
      CHARACTER*(*) TRANS
      INTEGER MAXSTRSTATES,MAXIOSTATES
      INTEGER KSIM
      CHARACTER*(*) SIMFILE
c export 
      INTEGER NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,NIOSTATES_2
      REAL IORANGE(MAXSTRSTATES,MAXIOSTATES)
      CHARACTER*(*) CSTRSTATES,CIOSTATES
      REAL SIMMETRIC(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +     MAXSTRSTATES,MAXIOSTATES)
c internal
      INTEGER I,J,K,L,I1,I2,J1,J2,ITRANS,IBEG,IEND
      INTEGER NSTR,NIO,ISTR1,IO1,ISTR2,IO2
      INTEGER MATRIXPOS
      CHARACTER CSTR,CIO,LINE*250
      CHARACTER*250 TESTSTRING
      CHARACTER*30 CTRANS
      LOGICAL LERROR
C======================================================================
C init
C======================================================================
      MATRIXPOS=22
      I= (NTRANS * NTRANS) * (MAXSTRSTATES * MAXSTRSTATES) * 
     +     (MAXIOSTATES * MAXIOSTATES)
      CALL INIT_REAL_ARRAY(1,I,SIMMETRIC,0.0)
C accessibility cut to 200% = take all
      I= MAXSTRSTATES * MAXIOSTATES 
      CALL INIT_REAL_ARRAY(1,I,IORANGE,200.0)
      TESTSTRING=' '
      LINE=' '
      CSTRSTATES=' '
      CIOSTATES=' '
      ITRANS=0
      NSTRSTATES_1=1
      NIOSTATES_1=1
      NSTRSTATES_2=1
      NIOSTATES_2=1
      NSTR=0
      NIO=0
c-----------------------------------------------------------------------
      TESTSTRING='AA STR I/O  V     L     I     M     '//
     +       'F     W     Y     G     A     P     S     T     C     '//
     +       'H     R     K     Q     E     N     D     B     Z'
      write(*,'(a,a)')' GETSIMMATRIX open metric: ',simfile(1:50)
      CALL OPEN_FILE(KSIM,SIMFILE,'READONLY,OLD',LERROR)
      IF (LERROR) GOTO 99
C----------------------------------------------------------------------
      DO WHILE (INDEX(LINE,TESTSTRING).EQ.0)
         READ(KSIM,'(A)',END=99)LINE          
         IF (INDEX(LINE,'STRUCTURE-STATES_1:') .NE. 0) THEN
            I=INDEX(LINE,':')+1
            CALL STRPOS(LINE,IBEG,IEND)
            CALL READ_INT_FROM_STRING(LINE(I:IEND),NSTRSTATES_1)
         ELSEIF (INDEX(LINE,'STRUCTURE-STATES_2:') .NE. 0) THEN
            I=INDEX(LINE,':')+1
            CALL STRPOS(LINE,IBEG,IEND)
            CALL READ_INT_FROM_STRING(LINE(I:IEND),NSTRSTATES_2)
         ELSEIF (INDEX(LINE,'I/O-STATES_1:') .NE. 0) THEN
            I=INDEX(LINE,':')+1
            CALL STRPOS(LINE,IBEG,IEND)
            CALL READ_INT_FROM_STRING(LINE(I:IEND),NIOSTATES_1)
         ELSEIF (INDEX(LINE,'I/O-STATES_2:') .NE. 0) THEN
            I=INDEX(LINE,':')+1
            CALL STRPOS(LINE,IBEG,IEND)
            CALL READ_INT_FROM_STRING(LINE(I:IEND),NIOSTATES_2)
         ELSEIF (INDEX(LINE,'DSSP-STRUCTURE') .NE. 0) THEN
            DO I=1,NSTRSTATES_1
               DO J=1,NIOSTATES_1
                  READ(KSIM,'(A)')LINE
                  READ(LINE,'(4X,A1,13X,A1)')CSTR,CIO
                  K=INDEX(CSTRSTATES,CSTR)
                  IF (K.EQ.0) THEN
	             NSTR=NSTR+1
	             K=NSTR
	             IF (NSTR .GT. MAXSTRSTATES) THEN
                        write(*,*)'*** ERROR: struct-states overflow'
                        STOP
	             ENDIF
                     CALL STRPOS(CSTRSTATES,IBEG,IEND)
	             IF (IEND+1 .GT. LEN(CSTRSTATES)) THEN
                        write(*,*)
     +                       '*** ERROR: CSTRSTATES string too short'
                        STOP          
	             ENDIF
	             WRITE(CSTRSTATES(IEND+1:IEND+1),'(A1)')CSTR
                  ENDIF
                  L=INDEX(CIOSTATES,CIO)
                  IF (L.EQ.0) THEN
	             NIO=NIO+1
	             L=NIO
	             IF (NIO .GT. MAXIOSTATES) THEN
                        write(*,*)'*** ERROR: I/O-states overflow'
                        STOP           
	             ENDIF
                     CALL STRPOS(CIOSTATES,IBEG,IEND)
	             IF (IEND+1 .GT. LEN(CSTRSTATES)) THEN
                        write(*,*)
     +                       '*** ERROR: CIOSTATES string too short'
                        STOP           
	             ENDIF
	             WRITE(CIOSTATES(IEND+1:IEND+1),'(A1)')CIO
                  ENDIF
                  READ(LINE,'(26X,F3.0)')IORANGE(K,L)
               ENDDO
            ENDDO
         ENDIF
      ENDDO
C----------------------------------------------------------------------
      write(*,*)' STRUCTURE-STATES_1: ',cstrstates,nstrstates_1
      write(*,*)' I/O-STATES_1      : ',ciostates,niostates_1
      write(*,*)' STRUCTURE-STATES_2: ',cstrstates,nstrstates_2
      write(*,*)' I/O-STATES_2      : ',ciostates,niostates_2
      IF (NSTRSTATES_1 .EQ. 1)NSTR=1
      IF (NIOSTATES_1  .EQ. 1)NIO=1
      IF (NSTR .NE. NSTRSTATES_1 .OR. NIO .NE. NIOSTATES_1 ) THEN
         write(*,*)'*** ERROR: number of structure-states .ne. NSTR'
         write(*,*)'    OR     number of I/O-states       .ne. NIO'
         STOP                                               
      ENDIF
C----------------------------------------------------------------------
      DO WHILE (.TRUE.)
         ITRANS=ITRANS+1
         DO ISTR1=1,NSTRSTATES_1
            DO IO1=1,NIOSTATES_1
               DO ISTR2=1,NSTRSTATES_2
                  DO IO2=1,NIOSTATES_2
                     READ(KSIM,'(A)',END=11)LINE
                     I1=INDEX(CSTRSTATES,LINE(5:5))
                     J1=INDEX(CIOSTATES,LINE(8:8))
                     I2=INDEX(CSTRSTATES,LINE(6:6))
                     J2=INDEX(CIOSTATES,LINE(9:9))
                     IF (I1.EQ.0.OR.I2.EQ.0.OR.J1.EQ.0.OR.J2.EQ.0) THEN
                        IF (I1.EQ.0)I1=1
                        IF (J1.EQ.0)J1=1
                        IF (I2.EQ.0)I2=1
                        IF (J2.EQ.0)J2=1
                     ENDIF
                     READ(LINE,'(1X,A1,7X,22(1X,F5.2))')
     +                    CTRANS(ITRANS:ITRANS),
     +                    (SIMMETRIC(ITRANS,K,I1,J1,I2,J2),
     +                    K=1,MATRIXPOS)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
 11   CLOSE(KSIM)
      ITRANS=ITRANS-1
C=======================================================================
C reset value for chain breaks etc...
C add 'X'
      ITRANS=ITRANS+1
      CTRANS(ITRANS:ITRANS)='X'
      I=INDEX(TRANS,'X')
      DO J=1,NTRANS
         DO ISTR1=1,NSTRSTATES_1
            DO IO1=1,NIOSTATES_1
               DO ISTR2=1,NSTRSTATES_2
                  DO IO2=1,NIOSTATES_2
                     SIMMETRIC(I,J,ISTR1,IO1,ISTR2,IO2)=0.0
                     SIMMETRIC(J,I,ISTR1,IO1,ISTR2,IO2)=0.0
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
c add '!'
      ITRANS=ITRANS+1
      CTRANS(ITRANS:ITRANS)='!'
      I=INDEX(TRANS,'!')
      DO J=1,NTRANS
         DO ISTR1=1,NSTRSTATES_1
            DO IO1=1,NIOSTATES_1
               DO ISTR2=1,NSTRSTATES_2
                  DO IO2=1,NIOSTATES_2
                     SIMMETRIC(I,J,ISTR1,IO1,ISTR2,IO2)=0.0
                     SIMMETRIC(J,I,ISTR1,IO1,ISTR2,IO2)=0.0
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
c add '-'
      ITRANS=ITRANS+1
      CTRANS(ITRANS:ITRANS)='-'
      I=INDEX(TRANS,'-')
      DO J=1,NTRANS
         DO ISTR1=1,NSTRSTATES_1
            DO IO1=1,NIOSTATES_1
               DO ISTR2=1,NSTRSTATES_2
                  DO IO2=1,NIOSTATES_2
                     SIMMETRIC(I,J,ISTR1,IO1,ISTR2,IO2)=0.0
                     SIMMETRIC(J,I,ISTR1,IO1,ISTR2,IO2)=0.0
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
c add '.'
      ITRANS=ITRANS+1
      CTRANS(ITRANS:ITRANS)='.'
      I=INDEX(TRANS,'.')
      DO J=1,NTRANS
         DO ISTR1=1,NSTRSTATES_1
            DO IO1=1,NIOSTATES_1
               DO ISTR2=1,NSTRSTATES_2
                  DO IO2=1,NIOSTATES_2
                     SIMMETRIC(I,J,ISTR1,IO1,ISTR2,IO2)=0.0
                     SIMMETRIC(J,I,ISTR1,IO1,ISTR2,IO2)=0.0
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
C----------------------------------------------------------------------
C check input order of amino acids
C=======================================================================
      IF (TRANS(1:NTRANS) .NE. CTRANS(1:ITRANS)) THEN
         write(*,*)' *** ERROR: CTRANS from metric-file and TRANS'//
     +        ' are not the same'
         write(*,*)'GETSIMMATRIX: ',ctrans,itrans
         write(*,*)'GETSIMMATRIX: ',trans,ntrans
         STOP                            
      ENDIF

C=======================================================================
C debug
C=======================================================================
c	do istr1=1,nstrstates_1
c	   do io1=1,niostates_1
c	      do istr2=1,nstrstates_2
c	         do io2=1,niostates_2
c                  write(*,*)(simmetric(1,j,istr1,io1,istr2,io2),j=1,26)
c	         enddo
c	      enddo
c	   enddo
c	enddo
C=======================================================================
      RETURN
C=======================================================================
C unknown metric or read error
C=======================================================================
 99   CLOSE(KSIM)
      write(*,'(a)')
     +     '** ERROR reading metric in GETSIMMATRIX **'
      STOP
      END
***** end of GETSIMMETRIC
C     END GETSIMMETRIC
C......................................................................

C......................................................................
C     SUB INIT_REAL_ARRAY
      SUBROUTINE INIT_REAL_ARRAY(IBEG,IEND,ARRAY,VALUE)
      
      IMPLICIT NONE
      INTEGER I,IBEG,IEND
      REAL ARRAY
      DIMENSION ARRAY(IBEG:IEND)
      REAL VALUE
      
      DO I=IBEG,IEND
         ARRAY(I)=VALUE
      ENDDO

      RETURN
      END
***** end of INIT_REAL_ARRAY
C     END INIT_REAL_ARRAY
C......................................................................

C......................................................................
C     SUB LOWTOUP
      SUBROUTINE LOWTOUP(STRING,LENGTH)
C LOWTOUP.......CONVERTS STRING......CHRIS SANDER JULY 1983
C changed by RS (speed up)
      CHARACTER*(*) STRING
      INTEGER LENGTH
CX      CHARACTER UPPER*26, LOWER*26, STRING*(*)
CX      DATA UPPER/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
CX      DATA LOWER/'abcdefghijklmnopqrstuvwxyz'/
C
      DO I=1,LENGTH
         IF (STRING(I:I) .GE. 'a' .AND. STRING(I:I) .LE. 'z') THEN
            STRING(I:I)=CHAR( ICHAR(STRING(I:I))-32 )
CX           K=INDEX(LOWER,STRING(I:I))
CX           IF (K.NE.0) STRING(I:I)=UPPER(K:K)
         ENDIF
      ENDDO
      RETURN
      END
C     END LOWTOUP
C......................................................................

C......................................................................
C     SUB MAKE_FORMAT_INT
      SUBROUTINE MAKE_FORMAT_INT(ILEN,CFORMAT)

      INTEGER ILEN
      CHARACTER*(*) CFORMAT
      CHARACTER*20 CTEMP,CINT
      
      CFORMAT=' '
      CINT=' '
      WRITE(CINT,'(I20)')ILEN
      CALL CONCAT_STRINGS('(I',CINT,CTEMP)
      CALL CONCAT_STRINGS(CTEMP,')',CFORMAT)

      RETURN
      END
C     END MAKE_FORMAT_INT
C......................................................................

C......................................................................
C     SUB READ_INT_FROM_STRING
      SUBROUTINE READ_INT_FROM_STRING(CSTRING,INUMBER)
C import
      CHARACTER*(*) CSTRING
C export
      INTEGER INUMBER
C internal 
      CHARACTER*100 CFORMAT,CTEMP
      CHARACTER*12 CNUMBER

      CNUMBER='-=0123456789'
      CFORMAT=' '
      INUMBER=0

      CALL STRPOS(CSTRING,ISTART,ISTOP)
      ITOTAL=ISTOP-ISTART+1
      DO I=ISTART,ISTOP
         J=INDEX(CNUMBER,CSTRING(I:I))
         IF ( J .LE. 0) THEN
            ITOTAL=I-ISTART
	    WRITE(*,*)' *** NOT AN INTEGER:',CSTRING(ISTART:ISTOP)
         ENDIF
      ENDDO
      CALL CONCAT_STRING_INT('(I',ITOTAL,CTEMP)
      CALL CONCAT_STRINGS(CTEMP,')',CFORMAT)
      READ(CSTRING(ISTART:ISTOP),CFORMAT)INUMBER
      RETURN
      END
***** end of READ_INT_FROM_STRING
C     END READ_INT_FROM_STRING
C......................................................................

C......................................................................
C     SUB STRPOS
      SUBROUTINE STRPOS(SOURCE,ISTART,ISTOP)
C StrPos(Source,IStart,IStop): Finds the positions of the first and
C last non-blank/non-TAB in Source. IStart=IStop=0 for empty Source
      CHARACTER*(*) SOURCE
      INTEGER ISTART,ISTOP
      
      ISTART=0
      ISTOP=0
      DO J=1,LEN(SOURCE)
         IF (SOURCE(J:J).NE.' ') THEN
            ISTART=J
            GOTO 20
         ENDIF
      ENDDO
      RETURN
 20   DO J=LEN(SOURCE),1,-1
         IF (SOURCE(J:J).NE.' ') THEN
            ISTOP=J
            RETURN
         ENDIF
      ENDDO
      ISTART=0
      ISTOP=0
      RETURN
      END
***** end of STRPOS
C     END STRPOS
C......................................................................

C.......................................................................
C     SUB COPY_FIELD
      SUBROUTINE COPY_FIELD(CIN,COUT,IFIELD,MAXFIELD)

c	implicit none
      CHARACTER*(*) CIN(*),COUT
      INTEGER IFIELD,MAXFIELD
C internal
      INTEGER IBEG,IEND

      IF (IFIELD+1 .GT. MAXFIELD) THEN
         CALL STRPOS(CIN(IFIELD),IBEG,IEND)
         WRITE(*,*)'**** NO VALUE GIVEN FOR: ',CIN(IFIELD)(IBEG:IEND)
      ELSE
         CALL STRPOS(CIN(IFIELD+1),IBEG,IEND)
         IF (IEND .GE. 1) THEN
            COUT=CIN(IFIELD+1)(IBEG:IEND)
	    IFIELD=IFIELD+2
         ENDIF
      ENDIF
      RETURN
      END
C     END COPY_FIELD
C.......................................................................

C.......................................................................
C     SUB CALC_PROFILE
      SUBROUTINE CALC_PROFILE(MAXSQ,MAXAA,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,
     +     NIOSTATES_2,
     +     SCALE_FACTOR,LOG_BASE,SIGMA,BETA,
     +     NRES,NALIGN,
     +     AL_EXCLUDEFLAG,AL_IFIRST,AL_ILAST,
     +     SEQBUFFER,ISEQPOINTER,NTRANS,TRANS,
     +     SEQ_WEIGHT,OPEN_1,ELONG_1,
     +     GAPOPEN_1,
     +     GAPELONG_1,SIMORG,SIMMETRIC_1) 
      
      INTEGER NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,NIOSTATES_2
c	common/strstates/ nstrstates_1,niostates_1,nstrstates_2,
c     +                    niostates_2
C import
      INTEGER MAXSQ,MAXAA,NRES,NALIGN,NTRANS
      REAL SCALE_FACTOR,LOG_BASE
      REAL SIGMA,BETA
      INTEGER AL_IFIRST(*),AL_ILAST(*),ISEQPOINTER(*)
      CHARACTER SEQBUFFER(*)
      CHARACTER TRANS*(*),AL_EXCLUDEFLAG(*)
      REAL SEQ_WEIGHT(*),OPEN_1,ELONG_1,GAPOPEN_1(*),
     +     GAPELONG_1(*)
      REAL SIMORG(NTRANS,NTRANS,MAXSTRSTATES,MAXIOSTATES,
     +     MAXSTRSTATES,MAXIOSTATES)
C export
      REAL SIMMETRIC_1(MAXSQ,NTRANS)
C internal
      INTEGER MAXTRANS
      PARAMETER (MAXTRANS=26)
      INTEGER IRES,IALIGN,I,J
      REAL FREQUENCY(MAXTRANS)
      REAL BTOD,BTON,ZTOE,ZTOQ
      REAL XOCC,XINS,XDEL
      CHARACTER C1
      
      REAL SIM_COPY(MAXTRANS,MAXTRANS)
      REAL INV(MAXTRANS,MAXTRANS)
      INTEGER INDX(MAXTRANS)
      REAL PROB_I(MAXTRANS)

C================

CAUTION: pass the following values from outside
CAUTION only for BLOSUM
c	scale_factor = 0.5
c	log_base = 2.0

c	scale_factor = 1.0
c	log_base = 10.0

c	beta=1.0 ; sigma=1.0

C 'B' and 'Z' are assigned as well to the acid as to the amide form
C with respect to their frequency in EMBL/SWISSPROT 21.0
      BTOD=0.524
      BTON=0.445
      ZTOE=0.626
      ZTOQ=0.407
      ILEN=LEN(TRANS)

      WRITE(*,*)'calc_profile'

C check if MAXHOM tries do more than we implemented here :-)
      IF (NTRANS .GT. MAXTRANS) THEN
         WRITE(*,*)' WARNING: NTRANS GT MAXTRANS'
         WRITE(*,*)' update routine: calc_profile !!!'
         STOP
      ENDIF
      IF (NSTRSTATES_1 .GT. 1 .OR. NIOSTATES_1 .GT. 1 .OR.
     +     NSTRSTATES_2 .GT. 1 .OR. NIOSTATES_2 .GT. 1) THEN
         WRITE(*,*)' WARNING: routine calc_profile not'
         WRITE(*,*)' working with STR and/or I/O dependent'
         WRITE(*,*)' metrices, update routine !!!'
         STOP
      ENDIF
C copy "simorg" in "sim_copy" so "simorg" will be unchanged !
      DO I=1,NTRANS 
         DO J=1,NTRANS 
            SIM_COPY(I,J)= SIMORG(I,J,1,1,1,1)
         ENDDO
      ENDDO
C scale metric if necessary
      DO I=1,MAXTRANS 
         DO J=1,MAXTRANS 
            SIM_COPY(I,J)=SIM_COPY(I,J) * SCALE_FACTOR
         ENDDO
      ENDDO
C de-log the matrix to get the ( P(i,j) / ( P(i) * P(j) ) )
      DO I=1,MAXTRANS
         DO J=1,MAXTRANS 
            SIM_COPY(I,J)= LOG_BASE ** SIM_COPY(I,J)
         ENDDO
      ENDDO
C build diagonal matrix
      DO I=1,NTRANS
         DO J=1,NTRANS 
            INV(I,J)=0.0 
         ENDDO
         INV(I,I) =1.0
      ENDDO
C invert matrix
C NOTE: sim_copy gets changed
      CALL LUDCMP(SIM_COPY,MAXAA,MAXTRANS,INDX,D)
      DO I=1,MAXAA
         CALL LUBKSB(SIM_COPY,MAXAA,MAXTRANS,INDX,INV(1,I))
      ENDDO
C normalize to 1.0 to get the P(i)
      DO I=1,MAXAA
         SUM=0.0
         DO J=1,MAXAA 
            SUM= SUM + INV(I,J) 
         ENDDO
         PROB_I(I)=SUM
         DO J=1,MAXAA 
            INV(I,J)=INV(I,J) /SUM 
         ENDDO
C check
         SUM=0.0
         DO J=1,MAXAA 
            SUM= SUM + INV(I,J)
         ENDDO
         CALL CHECKREALEQUALITY(SUM,1.0,0.002,'sum','calc_profile')
      ENDDO
C restore sim_copy (changed by matrix inverse)
      DO I=1,MAXTRANS 
         DO J=1,MAXTRANS 
            SIM_COPY(I,J)= SIMORG(I,J,1,1,1,1)
         ENDDO
      ENDDO
C scale metric
      DO I=1,MAXTRANS 
         DO J=1,MAXTRANS 
            SIM_COPY(I,J)=SIM_COPY(I,J) * SCALE_FACTOR
         ENDDO
      ENDDO
C de-log the matrix and multiply by P(i) to get the conditional probabilities:
C  ( P(i,j) | P(j) )
      DO I=1,MAXTRANS
         DO J=1,MAXTRANS 
            SIM_COPY(I,J)= ( LOG_BASE ** SIM_COPY(I,J) ) * PROB_I(I)
         ENDDO
      ENDDO
C check sum rule
      DO J=1,MAXAA
         SIM=0.0
         DO I=1,MAXAA
            SIM = SIM + SIM_COPY(I,J)
         ENDDO
c	   write(*,*)'sum P(i,j) | P(j): ',j,sim
         CALL CHECKREALEQUALITY(SIM,1.0,0.002,'sim','calc_profile')
      ENDDO
C     calculate sequence profile
      DO IRES=1,NRES  
         XOCC=0.0 
         XINS=0.0 
         XDEL=0.0
         DO I=1,MAXTRANS 
            FREQUENCY(I)=0.0
         ENDDO
         DO IALIGN=1,NALIGN
            IF (IRES .GE. AL_IFIRST(IALIGN) .AND. 
     +           IRES .LE. AL_ILAST(IALIGN)
     +           .AND. AL_EXCLUDEFLAG(IALIGN) .EQ. ' ') THEN
               C1=SEQBUFFER( ISEQPOINTER(IALIGN) + 
     +              IRES-AL_IFIRST(IALIGN) )
C if lower case character: insertions
               IF (C1 .GE. 'a' .AND. C1 .LE. 'z') THEN
                  C1=CHAR( ICHAR(C1)-32 )
                  XINS=XINS + SEQ_WEIGHT(IALIGN)
               ENDIF
               IF (C1 .NE. '.') THEN
                  XOCC=XOCC + SEQ_WEIGHT(IALIGN)
                  IF (INDEX('BZ',C1).EQ.0) THEN
                     I=INDEX(TRANS,C1)
                     IF (I .LE. 0 .OR. I .GT. ILEN) THEN
                        WRITE(*,*)' GETFREQUENCY: UNKNOWN RES : ',C1
                     ELSE
                        FREQUENCY(I)=FREQUENCY(I) + SEQ_WEIGHT(IALIGN)
                     ENDIF
                  ELSE IF (C1 .EQ. 'B') THEN
                     WRITE(*,*)' GETFREQUENCY: convert B'
                     I=INDEX(TRANS,'D')
                     J=INDEX(TRANS,'N')
                     FREQUENCY(I)=FREQUENCY(I)+(BTOD*SEQ_WEIGHT(IALIGN))
                     FREQUENCY(J)=FREQUENCY(J)+(BTON*SEQ_WEIGHT(IALIGN))
                  ELSE IF (C1 .EQ. 'Z') THEN
                     WRITE(*,*)' GETFREQUENCY: convert Z'
                     I=INDEX(TRANS,'E')
                     J=INDEX(TRANS,'Q')
                     FREQUENCY(I)=FREQUENCY(I)+(ZTOE*SEQ_WEIGHT(IALIGN))
                     FREQUENCY(J)=FREQUENCY(J)+(ZTOQ*SEQ_WEIGHT(IALIGN))
	          ENDIF
               ELSE 
C if '.' : deletion
		  XDEL=XDEL+ SEQ_WEIGHT(IALIGN)
               ENDIF
            ENDIF
         ENDDO	
C======================
C profile
         SUM= 0.0 
         DO I=1,MAXAA 
            SUM = SUM + FREQUENCY(I) 
         ENDDO
         IF (SUM .NE. 0.0) THEN
            DO I=1,MAXAA 
               FREQUENCY(I)= FREQUENCY(I) / SUM 
            ENDDO
C check sum rule for frequencies
            X=0.0 
            DO I=1,MAXAA 
               X = X + FREQUENCY(I) 
            ENDDO
            CALL CHECKREALEQUALITY(X,1.0,0.002,'freq','calc_profile')
C smooth the profile
C sigma: smooth dependent on the number of alignments
C beta:  mixing of the two models (expected <--> observed)
            SMOOTH= ( SUM / (SUM +SIGMA)) * BETA
C do for each of the AA types in a row
            DO I=1,MAXAA

               SIM=0.0
C sum up the conditional probabilities 
               DO J=1,MAXAA
                  SIM = SIM + ( FREQUENCY(J) * SIM_COPY(I,J) )
               ENDDO
C add the observed frequencies and smooth
               SIMMETRIC_1(IRES,I)=( (1-SMOOTH) * SIM) + 
     +              (SMOOTH * FREQUENCY(I) )
C divide by the expected probability
               SIMMETRIC_1(IRES,I)=SIMMETRIC_1(IRES,I)/PROB_I(I)
c	        simmetric_1(ires,i)= frequency(i) /prob_i(i)
C log-odd
               IF (SIMMETRIC_1(IRES,I) .LE. 10E-3) THEN
                  SIMMETRIC_1(IRES,I)=10E-3
               ENDIF
               SIMMETRIC_1(IRES,I)=LOG10 ( SIMMETRIC_1(IRES,I) )



c	        write(*,*)ires,trans(i:i),sum,frequency(i),
c     +                    sim,smooth,simmetric_1(ires,i)
C gap-weights 
               GAPOPEN_1(IRES) =OPEN_1  / (1.0 + ((XINS+XDEL)/SUM)) 
               GAPELONG_1(IRES)=ELONG_1 / (1.0 + ((XINS+XDEL)/SUM)) 
            ENDDO
         ELSE
            WRITE(*,*)'CALC_PROFILE: position not occupied !'
            C1=SEQBUFFER( ISEQPOINTER(1)+IRES-AL_IFIRST(1) )
            WRITE(*,*)'  sequence symbol of first sequence: ',c1
            WRITE(*,*)'  set profile row to 0.0'
            DO I=1,MAXAA 
               SIMMETRIC_1(IRES,I)=0.0 
            ENDDO
            GAPOPEN_1(IRES) = 0.0 
            GAPELONG_1(IRES)= 0.0
         ENDIF
      ENDDO
C set value for chain breaks etc... to 0.0
C later there are refilled in MAXHOM (like "!" = -200.0)
      IX=INDEX(TRANS,'X')
      IB=INDEX(TRANS,'B')
      IZ=INDEX(TRANS,'Z')
      I1=INDEX(TRANS,'!')
      I2=INDEX(TRANS,'-')
      DO IRES=1,NRES  
         SIMMETRIC_1(IRES,IX)=0.0
         SIMMETRIC_1(IRES,IB)=0.0
         SIMMETRIC_1(IRES,IZ)=0.0
         SIMMETRIC_1(IRES,I1)=0.0
         SIMMETRIC_1(IRES,I2)=0.0
      ENDDO

      RETURN
      END
C     END CALC_PROFILE
C.......................................................................

C.......................................................................
C     SUB HSSP
      SUBROUTINE HSSP(NALIGN,CHAINREMARK)
C write  XX.HSSP files using alignment-data      RS 1988/89
      IMPLICIT NONE
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
C import
      INTEGER NALIGN
      CHARACTER*(*) CHAINREMARK
C internal
c	character*1   csq_1_array(maxsq)
      CHARACTER     CTEMP*128,HSSPFILE*200,CDATE*9
      CHARACTER*132 HSSPLINE,DATABASE,CPARAMETER(10)
      REAL RMIN,RMAX
      REAL RELEASE
      INTEGER NPARALINE,NRES,LRES,NENTRIES,NRESIDUE
      INTEGER I,J,ISTART,ISTOP
c initialize
      DO I=1,NALIGN 
         AL_EXCLUDEFLAG(I)=' '
      ENDDO
      DO J=1,MAXSQ
         DO I=1,MAXPROFAA 
            AL_SEQPROF(J,I)=0
         ENDDO
      ENDDO
      DO J=1,MAXSQ
         AL_VARIABILITY(J)=0 
         AL_ENTROPY(J)=0
         NOCC_1(J)=0 
         AL_NDELETION(J)=0 
         AL_NINS(J)=0
      ENDDO
C HSSP release note
      WRITE(HSSPLINE,'(A)')'HSSP       HOMOLOGY DERIVED SECONDARY'//
     +     ' STRUCTURE OF PROTEINS , VERSION 1.0 1991'
C get swissprot release
      CALL SWISSPROTRELEASE(KREL,RELNOTES,RELEASE,NENTRIES,NRESIDUE)
      WRITE(DATABASE,'(A,F4.1,A,I6,A)')'SEQBASE    RELEASE ',release,
     +     ' OF EMBL/SWISS-PROT WITH ',nentries,' SEQUENCES'
c get actual date
      CDATE=' '
      CALL GETDATE (CDATE)
C get GCG-metric file and scale between 0.0 and 1.0
      RMIN=0.0 
      RMAX=1.0
      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,
     +     NIOSTATES_2,CSTRSTATES,CIOSTATES,
     +     IORANGE,KSIM,METRIC_HSSP_VAR,SIMORG)
      IF (NSTRSTATES_1 .NE. 1 .OR. NIOSTATES_1 .NE. 1) THEN
         WRITE(*,*)'**** ERROR: NSTRSTATES_1 OR NIOSTATES_1 .GT. 1'
         WRITE(*,*)'CHANGE CALC_VAR ROUTINE'
      ENDIF
      CALL SCALEMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     SIMORG,RMIN,RMAX,0.0,0.0)
C write alignment parameter in CPARAMETER (passed to HSSPHEADER)
      NPARALINE=1
      WRITE(CPARAMETER(NPARALINE),'(A,F4.1,A,F4.1)')
     +     ' SMIN: ',SMIN,'  SMAX: ',SMAX
      NPARALINE=NPARALINE+1
	
      IF (OPENWEIGHT_ANSWER .EQ. 'PROFILE' ) THEN
         WRITE(CPARAMETER(NPARALINE),'(A,A)')
     +        ' gap-open: profile',' gap-elongation: profile'
      ELSE
         WRITE(CPARAMETER(NPARALINE),'(A,F4.1,A,F4.1)')
     +    ' gap-open: ',gapopen_1(1),' gap-elongation: ',gapelong_1(1)
      ENDIF
      IF (LPROFILE_1 .OR. LPROFILE_2) THEN
         NPARALINE=NPARALINE+1
         WRITE(CPARAMETER(NPARALINE),'(A,A)')
     +	      '  profile from : ',name_1(1:100)
      ENDIF
      NPARALINE=NPARALINE+1
      IF (LCONSERV_1 .OR. LCONSERV_2 .OR. LCONSIMPORT) THEN
         WRITE(CPARAMETER(NPARALINE),'(A)')
     +        '  conservation weights: YES'
      ELSE
         WRITE(CPARAMETER(NPARALINE),'(A)')
     +        '  conservation weights: NO'
      ENDIF
      NPARALINE=NPARALINE+1
      IF (LINSERT_1) THEN
         WRITE(CPARAMETER(NPARALINE),'(A)')
     +        'InDels in secondary structure allowed: YES'  
      ELSE
         WRITE(CPARAMETER(NPARALINE),'(A)')
     +        'InDels in secondary structure allowed: NO'
      ENDIF
      NPARALINE=NPARALINE+1
      CALL CONCAT_STRINGS('  alignments sorted according to : ',
     +     CSORTMODE,CPARAMETER(NPARALINE) )
        
      IF (LHSSP_LONG_ID .EQV. .TRUE.) THEN
         NPARALINE=NPARALINE+1
         CALL CONCAT_STRINGS('  LONG-ID : ',
     +        HSSP_FORMAT_ANSWER,CPARAMETER(NPARALINE) )
      ENDIF

      IF (HSSP_ANSWER .EQ. 'YES') THEN
         CALL CONCAT_STRINGS(HSSPID_1,'.hssp',HSSPFILE)
      ELSE
         HSSPFILE=HSSP_ANSWER
      ENDIF
      BRKID_1=HSSPID_1(1:4)
C
      IF (.NOT. LDSSP_1 ) THEN
         NRES=N1 
         LRES=N1
	 HEADER_1=NAME_1(1:40)
	 COMPND_1=' ' 
         SOURCE_1=' ' 
         AUTHOR_1=' '
      ELSE
	 NRES=N1 
         LRES=NRES-NCHAINUSED+1
      ENDIF

      DO I=1,N1 
         CSQ_1_ARRAY(I)=CSQ_1(I:I) 
      ENDDO
      CALL CALC_VAR(NALIGN,NRES,CSQ_1_ARRAY,AL_HOM,
     +     AL_IFIRST,AL_ILAST,ISEQPOINTER,
     +     SEQBUFFER,AL_EXCLUDEFLAG,MAXSTRSTATES,MAXIOSTATES,
     +     NTRANS,TRANS,SIMORG,AL_VARIABILITY)
      CALL CALC_PROF(MAXSQ,MAXPROFAA,NRES,CSQ_1_ARRAY,NALIGN,
     +     AL_EXCLUDEFLAG,AL_HOM,AL_IFIRST,
     +     AL_ILAST,SEQBUFFER,ISEQPOINTER,TRANS,AL_SEQPROF,
     +     NOCC_1,AL_NDELETION,AL_NINS,AL_ENTROPY,AL_RELENT)
      
      IF (CHAINREMARK .NE. ' ') THEN
         CTEMP=' '
         I=INDEX(CHAINREMARK,'!')
         IF (I .NE. 0) THEN	
            WRITE(CTEMP,'(A)')CHAINREMARK(I+2:)
         ENDIF
         CHAINREMARK=' '
         CALL STRPOS(CTEMP,ISTART,ISTOP)
         WRITE(CHAINREMARK,'(A)')CTEMP(1:ISTOP)
      ENDIF
      CALL HSSPHEADER(KHSSP,HSSPFILE,HSSPLINE,HSSPID_1,CDATE,DATABASE,
     +     CPARAMETER,NPARALINE,ISOSIGFILE,ISAFE,LFORMULA,
     +     HEADER_1,COMPND_1,SOURCE_1,AUTHOR_1,LRES,
     +     NCHAIN_1,NCHAINUSED,CHAINREMARK,NALIGN)
      CALL WRITE_HSSP(KHSSP,MAXSQ,NALIGN,NRES,AL_EMBLPID,
     +     AL_PDB_POINTER,AL_ACCESSION,AL_HOM,AL_SIM,
     +     AL_IFIRST,AL_ILAST,AL_JFIRST,AL_JLAST,AL_HOMLEN,
     +     AL_NGAP,AL_LGAP,AL_LSEQ_2,AL_COMPOUND,
     +     ISEQPOINTER,SEQBUFFER,PDBNO_1,CHAINID_1,
     +     CSQ_1_ARRAY,STRUC_1,COLS_1,BP1_1,BP2_1,
     +     SHEETLABEL_1,NSURF_1,NOCC_1,AL_VARIABILITY,
     +     AL_SEQPROF,AL_NDELETION,AL_NINS,AL_ENTROPY,
     +     AL_RELENT,CONSWEIGHT_1,INSNUMBER,INSALI,
     +     INSPOINTER,INSLEN,INSBEG_1,INSBEG_2,INSBUFFER,
     +     ISOLEN,ISOIDE,NSTEP,LFORMULA,LALL,ISAFE,
     +     AL_EXCLUDEFLAG,LCONSERV_1,LHSSP_LONG_ID)
	RETURN
        END
C     END HSSP
C.......................................................................

C.......................................................................
C     SUB READ_FILENAME
      SUBROUTINE READ_FILENAME(KUNIT,FILENAME,LENDFILE,LERROR)
      
      CHARACTER*(*) FILENAME
      INTEGER KUNIT
      LOGICAL LENDFILE,LERROR
      
      LENDFILE=.FALSE. 
      LERROR=.FALSE.
      FILENAME=' '
      READ(KUNIT,'(A)',END=100,ERR=200)FILENAME
      RETURN
 100  LENDFILE=.TRUE.
      RETURN
 200  LERROR=.TRUE.
      RETURN
      END
C     END READ_FILENAME
C.......................................................................

C.......................................................................
C     SUB RECEIVE_RESULTS_FROM_NODE
      SUBROUTINE RECEIVE_RESULTS_FROM_NODE(NALIGN)
C import
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
C export
      INTEGER NALIGN
C local for each node
c   	integer irecpoi(maxaligns),ifilepoi(maxaligns)
c   	real    alisortkey(maxaligns),len2_orig(maxaligns)
C internal
      INTEGER IWORKER,IALIGN,IBEG,IEND
      INTEGER IALIGN_GOOD_ALL
C receive result from nodes and store in GLOBAL space 
      ILINK=1 
      LOGSTRING=' '

      IALIGN_GOOD_ALL = IALIGN_GOOD

      WRITE(*,*)' receive results: nalign nworker ', nalign,
     +     NWORKER,IALIGN_GOOD
      CALL FLUSH_UNIT(6)

c	msgtype=idtop
      DO IWORKER=1,NWORKER
         MSGTYPE=4000 
         ILINK=IWORKER
         CALL MP_RECEIVE_DATA(MSGTYPE,LINK(ILINK))
         CALL MP_GET_INT4(MSGTYPE,LINK(ILINK),IALIGN,N_ONE)
         CALL MP_GET_INT4(MSGTYPE,LINK(ILINK),IALIGN_GOOD,
     +        N_ONE)

         IALIGN_GOOD_ALL = IALIGN_GOOD_ALL + IALIGN_GOOD

         WRITE(*,*)ILINK,' IALIGN/GOOD/GOOD_ALL',
     +        IALIGN,IALIGN_GOOD,IALIGN_GOOD_ALL
         CALL FLUSH_UNIT(6)
         IF (IALIGN .GT. 0) THEN
            MSGTYPE=5000
            IBEG=NALIGN 
            IEND=NALIGN+IALIGN-1
            IF (IEND .GT. MAXALIGNS) THEN
               WRITE(*,*)'FATAL ERROR: MAXALIGNS OVERFLOW, INCREASE !!'
               CALL FLUSH_UNIT(6)
               STOP
            ENDIF
            CALL MP_RECEIVE_DATA(MSGTYPE,LINK(ILINK))
            CALL MP_GET_REAL4(MSGTYPE,LINK(ILINK),
     +           ALISORTKEY(IBEG),IALIGN)
            CALL MP_GET_INT4(MSGTYPE,LINK(ILINK),
     +           IRECPOI(IBEG),IALIGN)
            CALL MP_GET_INT4(MSGTYPE,LINK(ILINK),
     +           IFILEPOI(IBEG),IALIGN)
            NALIGN=NALIGN+IALIGN
            WRITE(LOGSTRING,'(A,4(I6))')' pid / done : ',
     +           IWORKER,IALIGN
         ELSE
            WRITE(LOGSTRING,'(A,I6,I6)')'nothing found: ',
     +           IWORKER,IALIGN
         ENDIF
         CALL LOG_FILE(KLOG,LOGSTRING,0)
         CALL FLUSH_UNIT(6)
      ENDDO
      NALIGN=NALIGN-1
      IALIGN_GOOD=IALIGN_GOOD_ALL
      WRITE(*,*)' total done : ',nalign,ialign_good
      CALL FLUSH_UNIT(6)
      RETURN
      END
C     END RECEIVE_RESULTS_FROM_NODE
C.......................................................................

C.......................................................................
C     SUB SEND_ALI_REQUEST
      SUBROUTINE SEND_ALI_REQUEST(IWORKER,IRECORD,IMSGTAG,CHECKVAL) 
      IMPLICIT NONE
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
c input
      INTEGER IWORKER,IRECORD,IMSGTAG
      REAL CHECKVAL
      MSGTYPE=6000
      
      CALL MP_INIT_SEND()
      CALL MP_PUT_INT4(MSGTYPE,IWORKER,IRECORD,N_ONE)
      CALL MP_PUT_INT4(MSGTYPE,IWORKER,IMSGTAG,N_ONE)
      CALL MP_PUT_REAL4(MSGTYPE,IWORKER,CHECKVAL,N_ONE)
      CALL MP_SEND_DATA(MSGTYPE,LINK(IWORKER))
      
      RETURN
      END
C     END SEND_ALI_REQUEST
C.......................................................................

C.......................................................................
C     SUB SEND_JOBS
C get "ready" signal from node and send "nfile" jobs

      SUBROUTINE SEND_JOBS(LH1,LH2,NFILE,NALIGN,NENTRIES,
     +     NAMINO_ACIDS)
C import
      IMPLICIT NONE
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
      INTEGER NFILE,NENTRIES,NAMINO_ACIDS
c import
      REAL      LH1(0:MAXMAT)
      INTEGER*2 LH2(0:MAXTRACE)
c	real lh(0:maxmat*2)
C internal
      INTEGER IFLAG
c       integer inix
      INTEGER IFILE,JFILE,ISET,ILINK,I,NALIGN,IALIGN,IFIRST_ROUND
      INTEGER NRECORD,IPOINTER

      INTEGER IDONE(MAXPROC)

c        integer ipos,nsplit,isplit
c        logical lendbase,ldb_read_one

      LOGICAL LERROR,LENDFILE
      CHARACTER*80 FILENAME
C init
      FILENAME=' '
      JFILE=0 
      ILINK=1 
      MSGTYPE=0
      DO I=1,MAXPROC 
         IDONE(I)=0 
      ENDDO
      NALIGN=1 
      IALIGN=0
      IFILE=1 
      IFIRST_ROUND=0
      NRECORD=0 
      ISET=0 
      IPOINTER=1
      IALIGN_GOOD=0

c        ldb_read_one=.false.


c$$$        if (ldb_read_one .eqv. .true.) THEN
c$$$	   nbuffer_len = 6 + len(name_2) + len(compnd_2) + 
c$$$     +                len(ACCESSION_2) + len(pdbref_2)
c$$$           lfirst_scan=.false.
c$$$           nsplit=namino_acids / (nworker +1)
c$$$
c$$$	   iset=0 ; isplit=0
c$$$
c$$$           do while( ifile .le. nfile)
c$$$              lendbase=.false.
c$$$	      call open_sw_data_file(kbase,ifile,split_db_data,
c$$$     +                               split_db_path)
c$$$c              write(*,*)ifile,nseq_warm_start,isplit,nsplit
c$$$c              call flush_unit(6)
c$$$
c$$$	      do while(lendbase .eqv. .false.)
c$$$               call get_swiss_entry(maxsq,kbase,lbinary,n2in,
c$$$     +                          name_2,compnd_2,
c$$$     +                          ACCESSION_2,pdbref_2,csq_2,lendbase)
c$$$
c$$$                 if (lendbase .eqv. .false.) THEN
c$$$                    IF ( (ipointer + nbuffer_len + n2in) .gt. 
c$$$     +                maxdatabase_buffer) THEN
c$$$                      write(*,*)' **** FATAL ERROR ****'
c$$$                      write(*,*)' database_buffer overflow increase'
c$$$                      write(*,*)' dimension of MAXDATABASE_BUFFER'
c$$$                      STOP
c$$$                    endif
c$$$                    write(cbuffer_line(1:),'(i6,a,a,a,a)')
c$$$     +                n2in,name_2,
c$$$     +                compnd_2,ACCESSION_2,pdbref_2
c$$$                    do ipos=1,nbuffer_len
c$$$                      cdatabase_buffer(ipointer)=
c$$$     +                                cbuffer_line(ipos:ipos)
c$$$                      ipointer=ipointer+1
c$$$                    enddo
c$$$                    do ipos=1,n2in
c$$$                       cdatabase_buffer(ipointer)=csq_2(ipos:ipos)
c$$$                       ipointer=ipointer+1
c$$$                    enddo   
c$$$                    isplit=isplit+n2in 
c$$$                    nseq_warm_start=nseq_warm_start+1
c$$$                    if ( (isplit .ge. nsplit) .and. 
c$$$     +                   (iset .le. nworker) ) then
c$$$                       iset=iset+1 ; ipointer=ipointer-1
c$$$                       write(*,'(a,i6,i8,i10,i8)')
c$$$     +                    'internal buffer: ',iset,nseq_warm_start,
c$$$     +                    ipointer,isplit
c$$$                       call flush_unit(6)
c$$$
c$$$                       msgtype=8000 ; ilink=iset
c$$$                       call mp_init_send()
c$$$                       call mp_put_int4(msgtype,ilink,ipointer,n_one)
c$$$                       call mp_put_int4(msgtype,ilink,nseq_warm_start,
c$$$     +                                  n_one)
c$$$                       call mp_send_data(msgtype,link(ilink))
c$$$                       msgtype=9000
c$$$                       call mp_init_send()
c$$$                       call mp_put_string_array(msgtype,ilink,
c$$$     +                                     cdatabase_buffer,ipointer)
c$$$                       call mp_send_data(msgtype,link(ilink))
c$$$                       ipointer=1 ; nseq_warm_start=0 ; isplit=0
c$$$                    endif
c$$$                 else 
c$$$                    close(kbase) ; ifile=ifile+1
c$$$                 endif    
c$$$              enddo   
c$$$           enddo
c$$$           msgtype=10000 
c$$$           call mp_init_send()
c$$$           call mp_put_int4(msgtype,ilink,ipointer,n_one)
c$$$           call mp_cast(nworker,msgtype,link(1))
c$$$        endif   

      CALL GET_CPU_TIME('time init:',IDPROC,
     +     ITIME_OLD,ITIME_NEW,TOTAL_TIME,LOGSTRING)
      CALL LOG_FILE(KLOG,LOGSTRING,2)
      IPOINTER=1

      IF (LISTOFSEQ_2 .EQV. .FALSE.) THEN
         IF (LFIRST_SCAN .EQV. .TRUE.) THEN
            DO WHILE (IFILE .LE. NFILE )
               MSGTYPE=2000 
               ILINK=-1
c	        call mp_receive_data(msgtype,ilink)
c	        call mp_get_int4(msgtype,ilink,ilink,n_one)

C first test for messages
               CALL MP_PROBE(MSGTYPE,IFLAG)
C if no communication is necessary do some "real" work
               IF ( IFLAG.EQ.0 .AND. IFILE .GE. NWORKSET*MAXQUEUE) THEN
                  WRITE(LOGSTRING,*)' file to host: ',ifile
                  CALL LOG_FILE(KLOG,LOGSTRING,1)
                  CALL HOST_INTERFACE(LH1,LH2,IFILE,FILENAME,IALIGN,
     +                 NRECORD,IPOINTER)
                  IFILE=IFILE+1
                  IFIRST_ROUND=1
c we have to fill the work-queue
               ELSE
                  MSGTYPE=2000 
                  CALL MP_RECEIVE_DATA(MSGTYPE,ILINK)
                  CALL MP_GET_INT4(MSGTYPE,ILINK,ILINK,N_ONE)
                  CALL MP_INIT_SEND()
C when we communicate the fist time, we fill the queue
                  IF (IFIRST_ROUND .EQ. 0) THEN
                     ISET=ISET+1
                     JFILE=ISET
                     DO I=1,MAXQUEUE
c                    write(*,'(a,i4,a,i4)')' file: ',jfile,' to: ',ilink
c                    call flush_unit(6)
                        MSGTYPE=3000
                        CALL MP_PUT_INT4(MSGTYPE,ILINK,JFILE,N_ONE)
                        JFILE=JFILE+NWORKSET
                        IFILE=IFILE+1
                     ENDDO   
                     CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
C send one file-pointer to refill the work-queue
                  ELSE
c                  write(*,'(a,i4,a,i4)')' file: ',ifile,' to: ',ilink
c                  call flush_unit(6)
                     MSGTYPE=3000
                     CALL MP_PUT_INT4(MSGTYPE,ILINK,IFILE,N_ONE)
                     IFILE=IFILE+1
                     CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
                  ENDIF
               ENDIF
            ENDDO
            LFIRST_SCAN=.FALSE.
C now tell everybody that the work is done
            ISET=0
            DO WHILE (ISET .LT. NWORKSET)
               MSGTYPE=2000 
               ILINK=-1
               CALL MP_RECEIVE_DATA(MSGTYPE,ILINK)
               CALL MP_GET_INT4(MSGTYPE,ILINK,ILINK,N_ONE)
               IF (IDONE(ILINK) .EQ. 0) THEN
c                   write(*,'(a,i4)')' last from: ',ilink ; call flush_unit(6)
                  ISET=ISET+1
                  IDONE(ILINK)=1
                  MSGTYPE=3000 
                  IFILE=-1
                  CALL MP_INIT_SEND()
                  CALL MP_PUT_INT4(MSGTYPE,ILINK,IFILE,N_ONE)
                  CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
c                else
c                   write(*,'(a,i4)')' collect dead message: ',ilink
c                   call flush_unit(6)
               ENDIF
            ENDDO

            WRITE(LOGSTRING,'(a,i6,i8,i10)')'internal buffer: ',
     +           IDPROC,NSEQ_WARM_START,IPOINTER
            CALL LOG_FILE(KLOG,LOGSTRING,1)
         ELSE
            CALL HOST_INTERFACE(LH1,LH2,IFILE,FILENAME,IALIGN,
     +           NRECORD,IPOINTER)
         ENDIF
      ELSE
C ===================================================================
C list of filenames
C ===================================================================
         IFILE=0


         WRITE(*,*)' load work queue: ',ilink
         LENDFILE=.FALSE. 
         LERROR=.FALSE.
         DO ILINK=1,NWORKSET
            DO I=1,MAXQUEUE_LIST
               IF ( (LENDFILE .EQV. .FALSE.) .AND. 
     +              (LERROR .EQV. .FALSE. ) ) THEN
                  CALL READ_FILENAME(KLIS2,FILENAME,LENDFILE,
     +                 LERROR)
               ENDIF
               IF ( (LENDFILE .EQV. .TRUE.) .OR. 
     +              (LERROR .EQV. .TRUE. ) ) THEN
                  FILENAME='STOP'
               ENDIF
               WRITE(*,'(A,A,A,I4)')'file: ',filename(1:50),
     +              ' to: ',ILINK
               CALL FLUSH_UNIT(6)
               MSGTYPE=9000
               CALL MP_INIT_SEND()
               CALL MP_PUT_STRING(MSGTYPE,ILINK,FILENAME,
     +              LEN(FILENAME))
               CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
               IF ( (LENDFILE .EQV. .TRUE.) .OR. 
     +              (LERROR .EQV. .TRUE. ) ) THEN
                  GOTO 500
               ENDIF
               IFILE=IFILE+1
            ENDDO
         ENDDO

         DO WHILE (.TRUE. )
            MSGTYPE=2000 
            ILINK=-1
C first test for messages
            CALL MP_PROBE(MSGTYPE,IFLAG)
C if no communication is necessary do some "real" work
c              IF ( iflag .eq. 0 ) THEN
c                 ifirst_round=1

c              IF ( iflag .eq. 0 .and. 
c     +            ifile .ge. (nworkset * maxqueue_list) ) THEN
c                 ifirst_round=1
c                 call read_filename(klis2,filename,lendfile,lerror)
c                 IF (lendfile .eqv. .true. .or. lerror .eqv. .true.) THEN
c                    filename='STOP'
c                          goto 500
c                 endif
c                 write(logstring,*)' host is working on file: ',ifile
c                 call log_file(klog,logstring,1)
c                 call host_interface(lh1,lh2,ifile,filename,ialign,
c     +                              nrecord,ipointer)
c                 ifile=ifile+1
c we have to fill the work-queue
c              else
            MSGTYPE=2000 
            CALL MP_RECEIVE_DATA(MSGTYPE,ILINK)
            CALL MP_GET_INT4(MSGTYPE,ILINK,ILINK,N_ONE)
            CALL MP_INIT_SEND()
C send one file-pointer to refill the work-queue
c                 if (ifirst_round .ne. 0) then
            CALL READ_FILENAME(KLIS2,FILENAME,LENDFILE,LERROR)
            IF ( (LENDFILE .EQV. .TRUE.)  .OR. 
     +           ( LERROR .EQV. .TRUE.) ) THEN
               FILENAME='STOP'
               GOTO 500
            ENDIF
            WRITE(*,'(A,I4)')FILENAME(1:50),ILINK
            CALL FLUSH_UNIT(6)

            MSGTYPE=3000
            CALL MP_PUT_STRING(MSGTYPE,ILINK,FILENAME,
     +           LEN(FILENAME))
            CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
            IFILE=IFILE+1
C when we communicate the fist time, we fill the queue
c                 else  
c                 endif
c              endif   
         ENDDO
c           lfirst_scan=.false.
C now tell everybody that the work is done
 500     ISET=0
         DO WHILE (ISET .LT. NWORKSET)
            MSGTYPE=2000 
            ILINK=-1
            CALL MP_RECEIVE_DATA(MSGTYPE,ILINK)
            CALL MP_GET_INT4(MSGTYPE,ILINK,ILINK,N_ONE)
            IF (IDONE(ILINK) .EQ. 0) THEN
               WRITE(*,'(a,i4)')' last from: ',ilink
               CALL FLUSH_UNIT(6)
               ISET=ISET+1 
               IDONE(ILINK)=1
               MSGTYPE=3000 
               FILENAME='STOP'
               CALL MP_INIT_SEND()
               CALL MP_PUT_STRING(MSGTYPE,ILINK,FILENAME,
     +              LEN(FILENAME))
               CALL MP_SEND_DATA(MSGTYPE,LINK(ILINK))
c                else
c                   write(*,'(a,i4)')' collect dead message: ',ilink
c                   call flush_unit(6)
            ENDIF
         ENDDO
      ENDIF
      NALIGN=NALIGN+IALIGN
      WRITE(LOGSTRING,*)' host processed: ',nseq_warm_start,
     +     IALIGN_GOOD
      CALL LOG_FILE(KLOG,LOGSTRING,1)
      RETURN
      END
C     END SEND_JOBS
C.......................................................................

C.......................................................................
C     SUB SETCONSERVATION
      SUBROUTINE SETCONSERVATION(METRIC_FILENAME)
C 1. set conservation weights to 1.0
C 2. rescale matrix for the 22 amino residues such that the sum over
C    the matrix is 0.0 (or near)
C this matrix is used to calculate the conservation weights (SIMCONSERV)
c	implicit none
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
C import
      CHARACTER*(*) METRIC_FILENAME

C internal
      INTEGER    NACID
      PARAMETER (NACID=22)
      INTEGER I,J
      REAL XLOW,XHIGH,XMAX,XMIN,XFACTOR,SUMMAT

C
      DO I=1,MAXSQ 
         CONSWEIGHT_1(I)=1.0
      ENDDO
      LFIRSTWEIGHT=.TRUE.
C get metric
      CALL GETSIMMETRIC(NTRANS,TRANS,MAXSTRSTATES,MAXIOSTATES,
     +     NSTRSTATES_1,NIOSTATES_1,NSTRSTATES_2,
     +     NIOSTATES_2,CSTRSTATES,CIOSTATES,
     +     IORANGE,KSIM,METRIC_FILENAME,SIMORG)
c rescale matrix that the sum over matrix is +- 0.0 
      XLOW=0.0 
      XHIGH=0.0
      XMAX=1.0 
      XMIN=-1.0 
      XFACTOR=100.0
	
C (re)store original values in simconserv()
 20   DO J=1,NTRANS 
         DO I=1,NTRANS
            SIMCONSERV(I,J)=SIMORG(I,J,1,1,1,1) 
         ENDDO
      ENDDO
c scale with xmin/xmax
      CALL SCALEINTERVAL(SIMCONSERV,NTRANS**2,XMIN,XMAX,XLOW,XHIGH)
C RESEt the values for 'X' '!' and '-'
      I=INDEX(TRANS,'X')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'!')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'-')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
      I=INDEX(TRANS,'.')
      DO J=1,NTRANS
         SIMCONSERV(I,J)=0.0 
         SIMCONSERV(J,I)=0.0
      ENDDO
C calculate sum over matrix (22 amino acids) after scaling
      SUMMAT=0.0
      DO I=1,NACID 
         DO J=1,NACID
            SUMMAT=SUMMAT+SIMCONSERV(I,J)
         ENDDO
      ENDDO
cd	write(*,*)' sum: ',summat,xmin
c check sum=0.0 (+- 0.01) ; if not xmin=xmin/2 ; scale again
      IF (SUMMAT .GT. 0.01) THEN
         XMIN=XMIN+(XMIN/XFACTOR)
      ELSE IF (SUMMAT .LT. -0.01) THEN
         XMIN=XMIN-(XMIN/XFACTOR)
      ELSE
         WRITE(*,*)' SETCONSERVATION: sum over matrix: ',summat
         WRITE(*,*)'                  smin is : ',xmin
c	  kdeb=45
c	  call open_file(kdeb,'DEBUG.X','NEW',lerror)
c          do i=1,ntrans        
c	   write(kdeb,'(a,26(f5.2))')trans(i:i),
c     +                (simconserv(i,j),j=1,ntrans)
c          enddo
c	  write(kdeb,*)'sum over matrix: ',summat
c	  write(kdeb,*)'min,max: ',xmin,xmax
c	  close(kdeb)
         RETURN
      ENDIF
      GOTO 20	
      END
C     END SETCONSERVATION
C.......................................................................

C.......................................................................
C     SUB SINGLE_SEQ_WEIGHTS
      SUBROUTINE SINGLE_SEQ_WEIGHTS(NALIGN,SEQBUFFER,
     +     ISEQPOINTER,AL_IFIRST,AL_ILAST,MODE,WEIGHTS)
c
c     input: hssp alignments
c       w0 -- eigenvalue iteration weights x(i) 
c       w1 -- squared eigenvectors x(i)**2
c       w2 -- sum of distances w(i)=SUM(dist(i,j))
c       w3 -- exponential weight w(i)=1/SUM(exp(-dist(i,j)/dmean))
c
      IMPLICIT NONE
C import
      INTEGER NALIGN
      INTEGER AL_IFIRST(*),AL_ILAST(*),ISEQPOINTER(*)
      CHARACTER SEQBUFFER(*)
      CHARACTER MODE*(*)
C export
      REAL WEIGHTS(*)
c
      INTEGER MAXALIGNS,MAXSTEP
      PARAMETER (MAXALIGNS=300)
      PARAMETER(MAXSTEP=100)
      REAL TOLERANCE
      PARAMETER(TOLERANCE=0.00001)
      REAL DIST(MAXALIGNS,MAXALIGNS)
c	real sim_table(maxaligns,maxaligns)
c	integer maxaa
c	real sel_press,xpower,xtemp1,xtemp2
      REAL WTEMP(MAXALIGNS)
c	real vtemp(maxaligns,maxaligns)
c
      INTEGER STEP
      CHARACTER A1,A2
      INTEGER LENGTH,NPOS
      INTEGER I,J,K,K0,K1,KPOS
      REAL X,S,DMEAN

c	maxaa=19

      I=LEN(MODE)
      CALL LOWTOUP(MODE,I)
      IF (NALIGN .GT. MAXALIGNS) THEN
         WRITE(*,*)' maxaligns overflow in single_seq_weight'
         STOP
      ENDIF

      DO I=1,NALIGN
         WEIGHTS(I)=1.0
      ENDDO
      IF (NALIGN .LE. 1) THEN
         WRITE(*,*)' SINGLE_SEQ_WEIGHT: no alignments !'
         RETURN
      ENDIF
C calculate distance/identity table
      WRITE(*,*)' calculate distance table...'
      DO I=1,NALIGN
         DIST(I,I)=0.0
c	   sim_table(i,i)=1.0
         DO J=I+1,NALIGN
            LENGTH=0
            NPOS=0
            K0=MAX(AL_IFIRST(I),AL_IFIRST(J))
            K1=MIN(AL_ILAST(I),AL_ILAST(J))
            KPOS=ISEQPOINTER(I) + K0 - AL_IFIRST(I)
            DO K=K0,K1
               NPOS=NPOS+1
               A1= SEQBUFFER(KPOS)
               A2= SEQBUFFER(KPOS)
               KPOS=KPOS+1
               IF (A1.EQ.A2) LENGTH=LENGTH+1
               IF (A1 .GE. 'a' .OR. A2 .GE. 'a') THEN
                  IF (A1 .GE. 'a' ) THEN
                     A1=CHAR( ICHAR(A1)-32 )
                  ENDIF
                  IF (A2 .GE. 'a' ) THEN
                     A2=CHAR( ICHAR(A2)-32 )
                  ENDIF
                  IF (A1.EQ.A2) LENGTH=LENGTH+1
               ENDIF

c	         IF (a1 .ge. 'a' .and. a1 .le. 'z') THEN
c	           a1=char( ichar(a1)-32 )
c	         endif
c	         IF (a2 .ge. 'a' .and. a2 .le. 'z') THEN
c	           a2=char( ichar(a2)-32 )
c	         endif

            END DO
            DIST(I,J)= 1- (FLOAT(LENGTH)/MAX(1.0,FLOAT(NPOS)) )
c	      sim_table(i,j)=float(length)/max(1.0,float(npos))
c	      dist(i,j)= 1.00 - sim_table(i,j)
            DIST(J,I)=DIST(I,J)
c              sim_table(j,i)=sim_table(i,j)
         END DO
      END DO
c	write(*,*) ' distances: '
c	do i=1,nalign
c	   write(*,'(26i3)') (nint(100*dist(j,i)),j=1,nalign)
c	end do
c
      IF (INDEX(MODE,'MAT'). NE. 0 ) THEN 
         WRITE(*,*)' weight mode MAT NOT active '
         STOP
c	  write(*,*)' preparing identity matrix...'
c	  sel_press=0.5
c	  xpower= 1.0 / (1.0 - sel_press + (1.0/maxaa) )
c	  xtemp1= 1.0 + (1.0 / (maxaa * (1.0 - sel_press) ) )
c	  xtemp2= 1.0 / (maxaa * (1-sel_press) )
c	  do i=1,nalign ; do j=1,nalign
c             sim_table(i,j) = ( sim_table(i,j) * xtemp1 - xtemp2 )
c	     IF (sim_table(i,j) .le. tolerance) THEN
c	       write(*,*)'set sim_table to tolerance ',i,j
c               sim_table(i,j) = tolerance
c	     endif
c             sim_table(i,j) = sim_table(i,j) **xpower
c	  enddo ; enddo
c	  write(*,*)' calculate singular value decomposition...'
c          call svdcmp(sim_table,nalign,nalign,maxaligns,maxaligns,wtemp,
c     +                vtemp)
c	  write(*,*)' calculate matrix invers...'
c	  do i=1,nalign
c	     if (wtemp(i) .le. 0.0001) THEN
c                x=0.0
c	     else
c                x= 1/wtemp(i)
c	     endif
c	     do j=1,nalign
c                sim_table(i,j) = vtemp(i,j) * x * sim_table(i,j)
c	        weights(i) = weights(i) + sim_table(i,j)
c	     enddo
c	  enddo
c=======================================================================
c     calculate one-sequence weights from a distance matrix
c     step 0: w(k)    = 1 / N * sum[dist(k,length)]
c     step i: w(k)(i) = 1 / NORM * sum[dist(k,l) * w(length)(i-1)]
c     iterate until sum[|w(k)(i)-w(k)(i-1)|] < tolerance
c=======================================================================
c  eigenvector iteration 
c=======================================================================
      ELSE IF (INDEX(MODE,'EIGEN')  .NE. 0 .OR. 
     +        INDEX(MODE,'SQUARE') .NE. 0) THEN
         DO I=1,NALIGN
            WTEMP(I)=1.0/NALIGN
         END DO
         STEP=0
 10      STEP=STEP+1
         X=0.0
         DO I=1,NALIGN
            WEIGHTS(I)=0.0
            DO J=1,NALIGN
               WEIGHTS(I) = WEIGHTS(I) + WTEMP(J) * DIST(I,J)
            END DO
            X=X+WEIGHTS(I)
         END DO
         S=0.0
         DO I=1,NALIGN
            S = S +(WTEMP(I)-WEIGHTS(I)/X) * (WTEMP(I)-WEIGHTS(I)/X)
            WTEMP(I)=WEIGHTS(I)/X
         END DO
         S=SQRT(S/NALIGN)
         IF ((STEP .LT. MAXSTEP) .AND. (S .GT. TOLERANCE)) GOTO 10
         WRITE(*,'(A,I5,A,F10.4)')' WEIGHTS AT STEP:', STEP,
     +        ' DIFFERENCE: ',S
         WRITE(*,'(13F6.3)') (NALIGN*WTEMP(I),I=1,NALIGN)
      ENDIF
c=======================================================================
c                           weights(i)=wtemp(i)**2
c=======================================================================
      IF (INDEX(MODE,'SQUARE') .NE. 0) THEN
         S=0.0
         DO I=1,NALIGN
            WEIGHTS(I)=WTEMP(I) * WTEMP(I)
            S=S+WEIGHTS(I)
         END DO
         DO I=1,NALIGN
            WEIGHTS(I)=WEIGHTS(I)/S
         END DO
         WRITE(*,*) ' squared weights '
         WRITE(*,'(13F6.3)') (NALIGN*WEIGHTS(I),I=1,NALIGN)
c=======================================================================
c                  weights(i)=SUM(dist(i,j))
c=======================================================================
      ELSE IF (INDEX(MODE,'SUM') .NE. 0) THEN
         S=0.0
         DO I=1,NALIGN
            WEIGHTS(I)=0.0
            DO J=1,NALIGN
               WEIGHTS(I)=WEIGHTS(I) + DIST(I,J)
            END DO
            S=S+WEIGHTS(I)
         END DO
         DO I=1,NALIGN
            WEIGHTS(I)=WEIGHTS(I)/S
         END DO
         WRITE(*,*) ' summed distance weights '
         WRITE(*,'(13F6.3)') (NALIGN*WEIGHTS(I),I=1,NALIGN)
c=======================================================================
c               weights(i)=1/SUM(exp(-dist(i,j)/dmean))
c=======================================================================
      ELSE IF (INDEX(MODE,'EXP') .NE. 0) THEN
         S=0.0
         DO I=1,NALIGN
            DO J=I+1,NALIGN
               S=S+DIST(I,J)
            END DO
         END DO
         DMEAN=S/NALIGN/(NALIGN-1)*2
         DO I=1,NALIGN
            S=0.0
            DO J=1,NALIGN
               S=S+EXP(-DIST(I,J)/DMEAN)
            END DO
            IF (S.GT.0.0) THEN
               WEIGHTS(I)=1/S
            ELSE
               WRITE(*,*)  ' warning: s=0 in weights '
               WEIGHTS(I)=1.0
            END IF
         END DO
c normalize to 1.0
         S=0.0
         DO I=1,NALIGN
            S=S+WEIGHTS(I)
         END DO
         DO I=1,NALIGN
            WEIGHTS(I)=WEIGHTS(I)/S
         END DO
         WRITE(*,*) ' exponential distance weights '
         WRITE(*,'(13F6.3)') (NALIGN*WEIGHTS(I),I=1,NALIGN)
      ENDIF
 
      RETURN
      END
C     end single_seq_weight
C.......................................................................

C.......................................................................
C     SUB SVDCMP
      SUBROUTINE SVDCMP(A,M,N,MP,NP,W,V)
      PARAMETER (NMAX=2000)
      DIMENSION A(MP,NP),W(NP),V(NP,NP),RV1(NMAX)
        
      L=0
      nm=0
      G=0.0
      SCALE=0.0
      ANORM=0.0
      IF (m .gt. nmax) THEN
         write(*,*)'***ERROR: dim. overflow for RV1 in SVDCMP'
         STOP
      endif
      DO 25 I=1,N
         L=I+1
         RV1(I)=SCALE*G
         G=0.0
         S=0.0
         SCALE=0.0
         IF (I.LE.M) THEN
	    DO 11 K=I,M
               SCALE=SCALE+ABS(A(K,I))
 11         CONTINUE
            IF (SCALE.NE.0.0) THEN
               DO 12 K=I,M
                  A(K,I)=A(K,I)/SCALE
                  S=S+A(K,I)*A(K,I)
 12            CONTINUE
               F=A(I,I)
               G=-SIGN(SQRT(S),F)
               H=F*G-S
               A(I,I)=F-G
               IF (I.NE.N) THEN
                  DO 15 J=L,N
                     S=0.0
                     DO 13 K=I,M
                        S=S+A(K,I)*A(K,J)
 13                  CONTINUE
                     F=S/H
                     DO 14 K=I,M
                        A(K,J)=A(K,J)+F*A(K,I)
 14                  CONTINUE
 15               CONTINUE
               ENDIF
               DO 16 K= I,M
                  A(K,I)=SCALE*A(K,I)
 16            CONTINUE
            ENDIF
         ENDIF
         W(I)=SCALE *G
         G=0.0
         S=0.0
         SCALE=0.0
         IF ((I.LE.M).AND.(I.NE.N)) THEN
            DO 17 K=L,N
               SCALE=SCALE+ABS(A(I,K))
 17         CONTINUE
            IF (SCALE.NE.0.0) THEN
               DO 18 K=L,N
                  A(I,K)=A(I,K)/SCALE
                  S=S+A(I,K)*A(I,K)
 18            CONTINUE
               F=A(I,L)
               G=-SIGN(SQRT(S),F)
               H=F*G-S
               A(I,L)=F-G
               DO 19 K=L,N
                  RV1(K)=A(I,K)/H
 19            CONTINUE
               IF (I.NE.M) THEN
                  DO 23 J=L,M
                     S=0.0
                     DO 21 K=L,N
                        S=S+A(J,K)*A(I,K)
 21                  CONTINUE
                     DO 22 K=L,N
                        A(J,K)=A(J,K)+S*RV1(K)
 22                  CONTINUE
 23               CONTINUE
               ENDIF
               DO 24 K=L,N
                  A(I,K)=SCALE*A(I,K)
 24            CONTINUE
            ENDIF
         ENDIF
         ANORM=MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
 25   CONTINUE
      DO 32 I=N,1,-1
         IF (I.LT.N) THEN
            IF (G.NE.0.0) THEN
               DO 26 J=L,N
                  V(J,I)=(A(I,J)/A(I,L))/G
 26            CONTINUE
               DO 29 J=L,N
                  S=0.0
                  DO 27 K=L,N
                     S=S+A(I,K)*V(K,J)
 27               CONTINUE
                  DO 28 K=L,N
                     V(K,J)=V(K,J)+S*V(K,I)
 28               CONTINUE
 29            CONTINUE
            ENDIF
            DO 31 J=L,N
               V(I,J)=0.0
               V(J,I)=0.0
 31         CONTINUE
         ENDIF
         V(I,I)=1.0
         G=RV1(I)
         L=I
 32   CONTINUE
      DO 39 I=N,1,-1
         L=I+1
         G=W(I)
         IF (I.LT.N) THEN
            DO 33 J=L,N
               A(I,J)=0.0
 33         CONTINUE
         ENDIF
         IF (G.NE.0.0) THEN
            G=1.0/G
            IF (I.NE.N) THEN
               DO 36 J=L,N
                  S=0.0
                  DO 34 K=L,M
                     S=S+A(K,I)*A(K,J)
 34               CONTINUE
                  F=(S/A(I,I))*G
                  DO 35 K=I,M
                     A(K,J)=A(K,J)+F*A(K,I)
 35               CONTINUE
 36            CONTINUE
            ENDIF
            DO 37 J=I,M
               A(J,I)=A(J,I)*G
 37         CONTINUE
         ELSE
            DO 38 J= I,M
               A(J,I)=0.0
 38         CONTINUE
         ENDIF
         A(I,I)=A(I,I)+1.0
 39   CONTINUE
      DO 49 K=N,1,-1
         DO 48 ITS=1,30
            DO 41 L=K,1,-1
               NM=L-1
               IF ((ABS(RV1(L))+ANORM).EQ.ANORM)  GOTO 2
               IF ((ABS(W(NM))+ANORM).EQ.ANORM)  GOTO 1
 41         CONTINUE
 1          C=0.0
            S=1.0
            DO 43 I=L,K
               F=S*RV1(I)
               IF ((ABS(F)+ANORM).NE.ANORM) THEN
                  G=W(I)
                  H=SQRT(F*F+G*G)
                  W(I)=H
                  H=1.0/H
                  C= (G*H)
                  S=-(F*H)
                  DO 42 J=1,M
                     Y=A(J,NM)
                     Z=A(J,I)
                     A(J,NM)=(Y*C)+(Z*S)
                     A(J,I)=-(Y*S)+(Z*C)
 42               CONTINUE
               ENDIF
 43         CONTINUE
 2          Z=W(K)
            IF (L.EQ.K) THEN
               IF (Z.LT.0.0) THEN
                  W(K)=-Z
                  DO 44 J=1,N
                     V(J,K)=-V(J,K)
 44               CONTINUE
               ENDIF
               GOTO 3
            ENDIF
            IF (ITS.EQ.30) PAUSE 'No convergence in 30 iterations'
            X=W(L)
            NM=K-1
            Y=W(NM)
            G=RV1(NM)
            H=RV1(K)
            F=((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
            G=SQRT(F*F+1.0)
            F=((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
            C=1.0
            S=1.0
            DO 47 J=L,NM
               I=J+1
               G=RV1(I)
               Y=W(I)
               H=S*G
               G=C*G
               Z=SQRT(F*F+H*H)
               RV1(J)=Z
               C=F/Z
               S=H/Z
               F= (X*C)+(G*S)
               G=-(X*S)+(G*C)
               H=Y*S
               Y=Y*C
               DO 45 NM=1,N
                  X=V(NM,J)
                  Z=V(NM,I)
                  V(NM,J)= (X*C)+(Z*S)
                  V(NM,I)=-(X*S)+(Z*C)
 45            CONTINUE
               Z=SQRT(F*F+H*H)
               W(J)=Z
               IF (Z.NE.0.0) THEN
                  Z=1.0/Z
                  C=F*Z
                  S=H*Z
               ENDIF
               F= (C*G)+(S*Y)
               X=-(S*G)+(C*Y)
               DO 46 NM=1,M
                  Y=A(NM,J)
                  Z=A(NM,I)
                  A(NM,J)= (Y*C)+(Z*S)
                  A(NM,I)=-(Y*S)+(Z*C)
 46            CONTINUE
 47         CONTINUE
            RV1(L)=0.0
            RV1(K)=F
            W(K)=X
 48      CONTINUE
 3       CONTINUE
 49   CONTINUE
      RETURN
      END
C     END SVDCMP 
C.......................................................................

C.......................................................................
C     SUB WRITE_HISTO
      SUBROUTINE WRITE_HISTO(KHISTO,HISTOFILE,NALIGN,SORTVAL)

c	implicit none
C import
      INTEGER KHISTO,NALIGN
      REAL SORTVAL(*)
      CHARACTER*(*) HISTOFILE
C internal
c	integer maxbin,maxlen
c	parameter (maxbin=100,maxlen=80)
c	integer i,ibin,nbin(maxbin),maxpop,minpop,iend
c	character line*(maxlen),mark
      LOGICAL LERROR

c	mark='*'
c	do i=1,maxlen ; line(i:i)=mark ; enddo
c	do i=1,maxbin ; nbin(i)=0 ; enddo

      CALL OPEN_FILE(KHISTO,HISTOFILE,'NEW',LERROR)
c	do i=1,nalign
c          ibin=nint( sortval(i) / sortval(nalign) * maxbin)
c	  IF (ibin .le. 0) THEN
c	    ibin=1
c	  else IF (ibin .gt. maxbin) THEN
c	    ibin=maxbin
c	  endif
c          nbin(ibin)=nbin(ibin)+1
c	enddo
c
c	maxpop=-1 ; minpop=1000000
c	do i=1,maxbin
c           IF (nbin(i) .gt. maxpop)maxpop=nbin(i)
c           IF (nbin(i) .lt. minpop)minpop=nbin(i)
c	enddo
      WRITE(KHISTO,'(A,I6)')  ' number of scores: ',nalign
      WRITE(KHISTO,'(A,F7.2)')' minimal scores:   ',sortval(1)
      WRITE(KHISTO,'(A,F7.2)')' maximum scores:   ',sortval(nalign)
      WRITE(KHISTO,'(A)')'_________________________________________'//
     +     '_____________________________________________'
c	do i=1,maxbin
c	   iend=nint( (float(nbin(i)) / float(maxpop)) * float(maxlen) )
c	   IF (iend .gt.0 ) THEN
c             write(khisto,'(i5,a,a)')nbin(i),' |',line(1:iend)
c	   else
c             write(khisto,'(i5,a)')nbin(i),' |'
c           endif
c	enddo
c	write(khisto,*)
      WRITE(KHISTO,'(A)')' values: '
      DO I=1,NALIGN
         WRITE(KHISTO,'(I5,2X,F7.2)')I,SORTVAL(I)
      ENDDO

      CLOSE(KHISTO)

      RETURN
      END
C     END WRITE_HISTO
C.......................................................................

C.......................................................................
C     SUB WRITE_MAXHOM_COM
      SUBROUTINE WRITE_MAXHOM_COM(CFILTER)

c	implicit none
      INCLUDE 'maxhom.param'
      INCLUDE 'maxhom.common'
      CHARACTER*(*) CFILTER
c internal
      INTEGER OPTCUT,LENFILENAME,IBEG,IEND,I,J,JBEG,JEND
      CHARACTER COMMANDFILE*80,COMEXT*4,OUTLINE*80,LINE*35
      CHARACTER COMMENTLINE*80
      LOGICAL LERROR
C init
      OUTLINE=' '
      OPTCUT=110

      COMMENTLINE='$!==========================================='//
     +     '============================'
      COMEXT='.csh'

      LENFILENAME=INDEX(NAME1_ANSWER,'!')-1
      IF (LENFILENAME .LE. 0)LENFILENAME=LEN(NAME1_ANSWER)
      CALL GETPIDCODE(NAME1_ANSWER(1:LENFILENAME),HSSPID_1)
      CALL LOWTOUP(COMMANDFILE_ANSWER,80)

      CALL STRPOS(HSSPID_1,IBEG,IEND)
      IF (CFILTER .EQ. ' ') THEN
         COMMANDFILE(1:)=HSSPID_1(IBEG:IEND)//'_maxhom'//comext
      ELSE
         COMMANDFILE(1:)=HSSPID_1(IBEG:IEND)//'_hssp'//comext
      ENDIF
      CALL OPEN_FILE(KCOM,COMMANDFILE,'NEW',LERROR)

C=======================================================================
C UNIX c-shell script
C=======================================================================
      COMMENTLINE='#==========================================='//
     +     '============================'
      WRITE(KCOM,'(A)')'#! /bin/csh'
      WRITE(KCOM,'(A)')COMMENTLINE
      IF (CFILTER .EQ. ' ') THEN
         WRITE(KCOM,'(A)')'# command file to run MAXHOM'
      ELSE
         WRITE(KCOM,'(A)')'# command file to run a PRE-FILTERED MAXHOM'
      ENDIF
      WRITE(KCOM,'(A)')'goto set_enviroment'
      WRITE(KCOM,'(A)')'start:'
      WRITE(KCOM,'(A)')COMMENTLINE
      WRITE(KCOM,'(A)')'# This .csh file writes a temporary '//
     +     'command file ("MAXHOM_"process_id".temp")'
      WRITE(KCOM,'(A)')'# containing the answers to the MAXHOM '//
     +     'questions.'
      WRITE(KCOM,'(A)')COMMENTLINE

C===================================================================

      IF (CFILTER .NE.' ') THEN
C get sequence 1 
         CALL STRPOS(NAME1_ANSWER,I,J)
         IF (LISTOFSEQ_1) THEN
	    WRITE(KCOM,'(A)')'# LOOP OVER FILENAMES IN LIST'
	    WRITE(KCOM,'(A)')
     +          'foreach filename ( "`cat '//NAME1_ANSWER(I:J)//'`" )'  
         ELSE
	    WRITE(KCOM,'(A)')'set filename = '//NAME1_ANSWER(I:J)  
         ENDIF
C get identifier
         WRITE(KCOM,'(A)')COMMENTLINE
         WRITE(KCOM,'(A)')'# GET IDENTIFIER'
         WRITE(KCOM,'(A)')COMMENTLINE
         WRITE(KCOM,'(A)')'   set name1 = $filename:r'
         WRITE(KCOM,'(A)')'   set name2 = $name1:t'
C convertseq
         WRITE(KCOM,'(A)')COMMENTLINE
         WRITE(KCOM,'(A)')'# CONVERT ALL FORMATS TO FASTA'
         WRITE(KCOM,'(A)')'   echo $filename    >   MAXHOM_$$.temp'
         WRITE(KCOM,'(A)')'   echo "F"          >>  MAXHOM_$$.temp'
         WRITE(KCOM,'(A)')'   echo "N"          >>  MAXHOM_$$.temp'
         WRITE(KCOM,'(A)')'   echo $name2".y"   >>  MAXHOM_$$.temp'
         WRITE(KCOM,'(A)')'   echo "N"          >>  MAXHOM_$$.temp'
         IF (CONVERTSEQ_EXE .NE. ' ') THEN
	    CALL STRPOS(CONVERTSEQ_EXE,IBEG,IEND)
	    WRITE(KCOM,'(A)')'   echo "run convert_seq"'
	    WRITE(KCOM,'(A,A,A)')
     +        '   ',CONVERTSEQ_EXE(IBEG:IEND),
     +        '  < MAXHOM_$$.temp >& /dev/null'
         ELSE
            STOP ' ERROR: CONVERTSEQ_EXE UNDEFINED '
         ENDIF
         WRITE(KCOM,'(A)')'   rm MAXHOM_$$.temp'
C run FASTA
         IF (CFILTER .EQ. 'FASTA') THEN
            WRITE(KCOM,'(A)')'   echo $name2".y"   >   MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo "S"          >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo "1"          >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo "fasta.x_"$$ >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo "2000"       >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo " "          >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo "yes"        >>  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   echo " "          >>  MAXHOM_$$.temp'
            IF (FASTA_EXE .NE. ' ') THEN
               CALL STRPOS(FASTA_EXE,IBEG,IEND)
               WRITE(KCOM,'(A,A,A)')'   ',FASTA_EXE(IBEG:IEND),
     +              ' -b 2000 -d 2000 -o < MAXHOM_$$.temp > fasta.x_$$'
            ELSE
               STOP ' ERROR: FASTA_EXE UNDEFINED '
            ENDIF
            WRITE(KCOM,'(A)')'   rm MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')'   rm $name2".y"'
C get filter.list
            WRITE(KCOM,'(A)')COMMENTLINE
            WRITE(KCOM,'(A)')'# EXTRACT POSSIBL HITS FROM FASTA-OUTPUT'
            WRITE(KCOM,'(A)')' echo "fasta.x_"$$ >  MAXHOM_$$.temp'
            WRITE(KCOM,'(A)')' echo "filter.list_"$$ >> MAXHOM_$$.temp'
            I=ISAFE-5
            IF (I.GT.0) THEN
               WRITE(OUTLINE,'(A,I2)')'FORMULA+',I
            ELSE IF (I.EQ.0) THEN
               WRITE(OUTLINE,'(A)')'FORMULA'
            ELSE
               WRITE(OUTLINE,'(A,I2)')'FORMULA-',ABS(I)
            ENDIF
            CALL STRPOS(OUTLINE,I,J)
	    WRITE(KCOM,'(A)')'   echo "'//OUTLINE(I:J)//
     +           '"  >> MAXHOM_$$.temp'
	    WRITE(KCOM,'(A,I5,A)')'   echo "',OPTCUT,
     +           '"  >> MAXHOM_$$.temp'
	    WRITE(KCOM,'(A)')'   echo "distance"   >>  MAXHOM_$$.temp'
	    IF (FILTER_FASTA_EXE .NE. ' ') THEN
               CALL STRPOS(FILTER_FASTA_EXE,IBEG,IEND)
               WRITE(KCOM,'(A,A,A)')'   ',FILTER_FASTA_EXE(IBEG:IEND),
     +              '  <  MAXHOM_$$.temp'
	    ELSE
               STOP ' ERROR: FILTER_FASTA_EXE UNDEFINED '
	    ENDIF
	    WRITE(KCOM,'(A)')'   rm MAXHOM_$$.temp'
	    WRITE(KCOM,'(A)')'   rm fasta.x_$$'
C rename output files if wanted
	    IF (STRIPFILE_ANSWER.NE.'NO') THEN
               STRIPFILE_ANSWER='$name2"_strip.x"'
            ENDIF
	    IF (long_output_ANSWER.NE.'NO') THEN
               LONG_OUTPUT_ANSWER='$name2"_long.x"'
            ENDIF
	    IF (PLOTFILE_ANSWER.NE.'NO') THEN
               PLOTFILE_ANSWER='$name2"_trace.x"'
            ENDIF
C run BLASTP
         ELSE IF (CFILTER .EQ. 'BLASTP') THEN
	    IF (BLASTP_EXE .NE. ' ') THEN
               CALL STRPOS(BLASTP_EXE,IBEG,IEND)
               WRITE(KCOM,'(A)')'   echo "run blastp"'
               WRITE(KCOM,'(A,A,A)')'   ',BLASTP_EXE(IBEG:IEND),
     +              ' swiss $name2".y" B=2000 > blast.x_$$'
	    ELSE
               STOP ' ERROR: BLASTP_EXE UNDEFINED '
	    ENDIF
	    WRITE(KCOM,'(A)')'   rm MAXHOM_$$.temp'
	    WRITE(KCOM,'(A)')'   rm $name2".y"'
	    write(kcom,'(a)')commentline
	    WRITE(KCOM,'(A)')'# EXTRACT HITS FROM BLASTP-OUTPUT'
	    IF (FILTER_BLASTP_EXE .NE. ' ') THEN
               CALL STRPOS(FILTER_BLASTP_EXE,IBEG,IEND)
               CALL STRPOS(sw_current,jBEG,jEND)
               WRITE(KCOM,'(A,A,A,A,A)')'   ',
     +              FILTER_BLASTP_EXE(IBEG:IEND),' ',
     +              sw_current(jbeg:jend),
     +              ' <  blast.x_$$ > filter.list_$$'
               write(kcom,'(a)')'   rm blast.x_$$'
	    ELSE
               STOP ' ERROR: FILTER_BLASTP_EXE UNDEFINED '
	    ENDIF
         ENDIF
      ENDIF
C call MAXHOM 
      LINE='"            >> MAXHOM_$$.temp  ' 
      write(kcom,'(a)')commentline
      WRITE(KCOM,'(A)')'# --------  finally call MAXHOM     -------'
      write(kcom,'(a)')commentline
      WRITE(KCOM,'(A)')'   echo "COMMAND NO" >  MAXHOM_$$.temp'
      WRITE(KCOM,'(A)')'   echo "BATCH" >>  MAXHOM_$$.temp'
      WRITE(KCOM,'(A)')'   echo "PID: "$$    >>  MAXHOM_$$.temp'
      IF (CFILTER .NE. ' ') THEN
         WRITE(KCOM,'(A)')'   echo "SEQ_1 "$filename >> MAXHOM_$$.temp'
         WRITE(KCOM,'(A)')
     +        '   echo "SEQ_2 filter.list_"$$ >> MAXHOM_$$.temp'
      ELSE
         CALL STRPOS(NAME1_ANSWER,I,J)
         WRITE(KCOM,'(A)')'   echo "SEQ_1 '//NAME1_ANSWER(I:J)//LINE
         CALL STRPOS(NAME2_ANSWER,I,J)
         WRITE(KCOM,'(A)')'   echo "SEQ_2 '//NAME2_ANSWER(I:J)//LINE
      ENDIF
      CALL STRPOS(PROFILE_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "2_PROFILES '//
     +                   PROFILE_ANSWER(I:J)//LINE
      CALL STRPOS(METRIC_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "METRIC '//METRIC_ANSWER(I:J)//LINE

      CALL STRPOS(NORM_PROFILE_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "NORM_PROFILE '//
     +     NORM_PROFILE_ANSWER(I:J)//LINE
      CALL STRPOS(PROFILE_EPSILON_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "MEAN_PROFILE '//
     +     PROFILE_EPSILON_ANSWER(I:J)//LINE
      CALL STRPOS(PROFILE_GAMMA_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "FACTOR_GAPS '//
     +     PROFILE_GAMMA_ANSWER(I:J)//LINE
      CALL STRPOS(SMIN_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "SMIN '//SMIN_ANSWER(I:J)//LINE
      CALL STRPOS(SMAX_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "SMAX '//SMAX_ANSWER(I:J)//LINE
      CALL STRPOS(OPENWEIGHT_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "GAP_OPEN '//
     +     OPENWEIGHT_ANSWER(I:J)//LINE
      CALL STRPOS(ELONGWEIGHT_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "GAP_ELONG '//
     +     ELONGWEIGHT_ANSWER(I:J)//LINE
      CALL STRPOS(WEIGHT1_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "WEIGHT1 '//WEIGHT1_ANSWER(I:J)//LINE
      CALL STRPOS(WEIGHT2_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "WEIGHT2 '//WEIGHT2_ANSWER(I:J)//LINE
      CALL STRPOS(WAY3_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "WAY3_ALIGN '//
     +     WAY3_ANSWER(I:J)//LINE
      CALL STRPOS(INDEL_ANSWER_1,I,J)
      WRITE(KCOM,'(A)')'   echo "INDEL_1 '//
     +     INDEL_ANSWER_1(I:J)//LINE
      CALL STRPOS(INDEL_ANSWER_2,I,J)
      WRITE(KCOM,'(A)')'   echo "INDEL_2 '//
     +     INDEL_ANSWER_2(I:J)//LINE
      CALL STRPOS(BACKWARD_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "RELIABILITY '//
     +     BACKWARD_ANSWER(I:J)//LINE
      CALL STRPOS(FILTER_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "FILTER_RANGE '//
     +     FILTER_ANSWER(I:J)//LINE
      CALL STRPOS(NBEST_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "NBEST '//NBEST_ANSWER(I:J)//LINE
      CALL STRPOS(NGLOBALHITS_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "MAXALIGN '//
     +     NGLOBALHITS_ANSWER(I:J)//LINE
      CALL STRPOS(THRESHOLD_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "THRESHOLD '//
     +     THRESHOLD_ANSWER(I:J)//LINE
      CALL STRPOS(SORTMODE_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "SORT '//SORTMODE_ANSWER(I:J)//LINE
      CALL STRPOS(HSSP_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "HSSP '//HSSP_ANSWER(I:J)//LINE
      CALL STRPOS(SAMESEQ_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "SAME_SEQ_SHOW '//
     +     SAMESEQ_ANSWER(I:J)//LINE
      CALL STRPOS(COMPARE_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "SUPERPOS '//COMPARE_ANSWER(I:J)//LINE
      CALL STRPOS(PDBPATH_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "PDB_PATH '//PDBPATH_ANSWER(I:J)//LINE
      CALL STRPOS(PROFILEOUT_ANSWER,I,J)
      WRITE(KCOM,'(A)')'   echo "PROFILE_OUT '//
     +     PROFILEOUT_ANSWER(I:J)//LINE
      CALL STRPOS(STRIPFILE_ANSWER,I,J)
      IF (INDEX(STRIPFILE_ANSWER,'$name2').NE.0) THEN
         WRITE(KCOM,'(A)')'   echo "STRIP_OUT "'//
     +        STRIPFILE_ANSWER(I:J)//
     +        '     >> MAXHOM_$$.temp'
      ELSE
         WRITE(KCOM,'(A)')'   echo "STRIP_OUT '//
     +        STRIPFILE_ANSWER(I:J)//LINE
      ENDIF
      CALL STRPOS(long_output_ANSWER,I,J)
      IF (INDEX(long_output_ANSWER,'$name2').ne.0) THEN
         WRITE(KCOM,'(A)')'   echo "LONG_OUT "'//
     +        long_output_ANSWER(I:J)//
     +        '     >> MAXHOM_$$.temp'
      ELSE
         WRITE(KCOM,'(A)')'   echo "LONG_OUT '//
     +        long_output_ANSWER(I:J)//LINE
      ENDIF
      
      CALL STRPOS(PLOTFILE_ANSWER,I,J)
      IF (INDEX(PLOTFILE_ANSWER,'$name2').ne.0) THEN
         WRITE(KCOM,'(A)')'   echo "DOT_PLOT "'//PLOTFILE_ANSWER(I:J)//
     +        '      >> MAXHOM_$$.temp'
      ELSE
         WRITE(KCOM,'(A)')'   echo "DOT_PLOT '//
     +        PLOTFILE_ANSWER(I:J)//LINE
         WRITE(KCOM,'(A)')'   echo "RUN"      >> MAXHOM_$$.temp'
      ENDIF
      WRITE(KCOM,'(A)')'   maxhom -nopar < MAXHOM_$$.temp'
CALT	WRITE(KCOM,'(A)')'   $snice maxhom < MAXHOM_$$.temp'
      WRITE(KCOM,'(A)')'   rm MAXHOM_$$.temp'
      CALL STRPOS(COREFILE,IBEG,IEND)
      WRITE(KCOM,'(A,A,A)')'   rm ',COREFILE(IBEG:IEND),'$$'
      WRITE(KCOM,'(A)')'   rm filter.list_$$'
      IF (CFILTER .NE. ' ' .AND. LISTOFSEQ_1) THEN
         WRITE(KCOM,'(A)')'end'
      ENDIF
      WRITE(KCOM,'(A)')'exit'
      
      WRITE(KCOM,'(A)')COMMENTLINE
      WRITE(KCOM,'(A)')'set_enviroment:'
      WRITE(KCOM,'(A)')'nohup'
      WRITE(KCOM,'(A)')'alias rm ''rm -f'''
      WRITE(KCOM,'(A)')'goto start'
      WRITE(KCOM,'(A)')COMMENTLINE
      
      CLOSE(KCOM)
C======================================================================
      WRITE(*,*)'****************************************************'
      CALL STRPOS(COMMANDFILE,IBEG,IEND)
      WRITE(*,*)' wrote command file to: ',commandfile(ibeg:iend)
      IF (CMACHINE .EQ. 'VMS' ) THEN
         WRITE(*,*)'now submit this command file to a batch queue'
      ELSE
         CALL CHANGE_MODE(COMMANDFILE,'+x',i)
         WRITE(*,*)'to execute this file type: '
         IF (I .NE. 0) THEN
            WRITE(*,'(A,A)')'chmod +x ',COMMANDFILE(IBEG:IEND)
         ENDIF
         WRITE(*,'(2X,A,A)')COMMANDFILE(IBEG:IEND),' > /dev/null &'
      ENDIF
      WRITE(*,*)'****************************************************'

      RETURN
      END
C     END WRITE_MAXHOM_COM
C.......................................................................

echo "--- now Maxhom: "
echo "/usr/local/bin/gfortran -o maxhom.MACINTEL -O3 -C maxhom.f lib-sys-MAC.f lib-maxhom.f lib-maxhom-node-pvm3.f "
/usr/local/bin/gfortran -o maxhom.MACINTEL -O3 -C maxhom.f lib-sys-MAC.f lib-maxhom.f lib-maxhom-node-pvm3.f 

echo "--- now convert_seq: "
echo "/usr/local/bin/gfortran -o convert_seq.MACINTEL -O3 -C convert_seq.f lib-sys-MAC.f lib-convert.f"
/usr/local/bin/gfortran -o convert_seq.MACINTEL -O3 -C convert_seq.f lib-sys-MAC.f lib-convert.f

echo "--- now filter_hssp:"
echo "/usr/local/bin/gfortran -o filter_hssp.MACINTEL -O3 -C filter_hssp.f lib-sys-MAC.f lib-maxhom.f"
/usr/local/bin/gfortran -o filter_hssp.MACINTEL -O3 -C filter_hssp.f lib-sys-MAC.f lib-maxhom.f

echo "--- exit before profile_make! "
echo "--- "
echo "--- stay cool IS ok!!"
echo "--- "
exit

echo "--- now profile_make:"
echo "/usr/local/bin/gfortran -o profile_make.MACINTEL -O3 -C profile_make.f lib-sys-MAC.f lib-profile-make.f"
/usr/local/bin/gfortran -o profile_make.MACINTEL -O3 -C profile_make.f lib-sys-MAC.f lib-profile-make.f

=pod

=head1 NAME

convert_seq - conversion of sequence and alignment formats

=head1 SYNOPSIS

convert_seq [OPTION]

=head1 DESCRIPTION

convert_seq is used for sequence and alignment format conversion.  Instead of using command line arguments it starts a conversation with the user where the desired function can be invoked by answering questions.

This program is used by the prof(1) secondary structure, accessibility and transmembrane helix predictor from Burkhard Rost.

=head1 OPTIONS

None.  Answer questions printed on STDOUT by typing your choice into STDIN.

=head1 AUTHORS

=over

=item Reinhard Schneider        Mar,        1991      version 1.0 LION http://www.lion-ag/ Heidelberg

=item Ulrike Goebel             Mar,        1997      version 1.1 LION http://www.lion-ag/ Heidelberg

=item Reinhard Schneider        Mar,        1997      version 2.0 LION http://www.lion-ag/ Heidelberg

=item Burkhard Rost             May,        1998      version 2.1 EMBL/LION Heidelberg

=item Burkhard Rost		Oct,        1998      version 2.2

=item Laszlo Kajan <lkajan@rostlab.org> TU Muenchen, Germany

=item Guy Yachdav <gyachdav@rostlab.org> CUBIC (Columbia University, NY, USA), Technical University Munich (Munich, DE), BioSof LLC (USA)

=back

=head1 SEE ALSO

prof(1), filter_hssp(1)

=cut

=pod

=head1 NAME

filter_hssp - filters an HSSP file

=head1 SYNOPSIS

filter_hssp [OPTION]

=head1 DESCRIPTION

filter_hssp is used to filters an HSSP file.  Instead of using command line arguments it starts a conversation with the user where the desired function can be invoked by answering questions.

This program is used by the prof(1) secondary structure, accessibility and transmembrane helix predictor from Burkhard Rost.

=head1 OPTIONS

None.  Answer questions printed on STDOUT by typing your choice into STDIN.

=head1 AUTHORS

=over

=item Reinhard Schneider        Mar,        1990      version 1.0 LION, Heidelberg

=item Reinhard Schneider        Mar,        1997      version 2.0 LION, Heidelberg

=item Burkhard Rost             May,        1998      version 2.1 EMBL/LION, Heidelberg

=item Burkhard Rost             Oct,        1998      version 2.2 EMBL/LION, Heidelberg

=item Laszlo Kajan <lkajan@rostlab.org> TU Muenchen, Germany

=item Guy Yachdav <gyachdav@rostlab.org> CUBIC (Columbia University, NY, USA), Technical University Munich (Munich, DE), BioSof LLC (USA)

=back

=head1 SEE ALSO

prof(1), convert_seq(1)

=cut
